########################## TCL Event Handlers ##########################
#
#  VF2_4axis.tcl -
#
#  Created by darkstar  @  11 listopada 2015 12:35:34 Pacific Standard Time
#  with Post Builder version  9.0.0.
#
########################################################################


  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]


  if { ![info exists mom_sys_post_initialized] } {

     if { ![info exists mom_sys_ugpost_base_initialized] } {
        source ${cam_post_dir}ugpost_base.tcl
        set mom_sys_ugpost_base_initialized 1
     }
 
 
     set mom_sys_debug_mode OFF
 
 
     if { ![info exists env(PB_SUPPRESS_UGPOST_DEBUG)] } {
        set env(PB_SUPPRESS_UGPOST_DEBUG) 0
     }
 
     if $env(PB_SUPPRESS_UGPOST_DEBUG) {
        set mom_sys_debug_mode OFF
     }
 
     if { ![string compare $mom_sys_debug_mode "OFF"] } {
 
        proc MOM_before_each_add_var {} {}
        proc MOM_before_each_event   {} {}
        proc MOM_before_load_address {} {}
        proc MOM_end_debug {} {}
 
     } else {
 
        set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
        source ${cam_debug_dir}mom_review.tcl
     }
 
     MOM_set_debug_mode $mom_sys_debug_mode


   ####  Listing File variables 
     set mom_sys_list_output                       "OFF"
     set mom_sys_header_output                     "OFF"
     set mom_sys_list_file_rows                    "40" 
     set mom_sys_list_file_columns                 "30" 
     set mom_sys_warning_output                    "OFF"
     set mom_sys_group_output                      "OFF"
     set mom_sys_list_file_suffix                  "lpt"
     set mom_sys_output_file_suffix                "ptp"
     set mom_sys_commentary_output                 "ON" 
     set mom_sys_commentary_list                   "x y z 4axis 5axis feed speed"
     set mom_sys_pb_link_var_mode                  "OFF"
     set mom_sys_use_default_unit_fragment         "ON" 
     set mom_sys_alt_unit_post_name                "VF2_4axis__IN.pui"


   #=============================================================
   proc MOM_before_output { } {
   #=============================================================
   # This command is executed just before every NC block is
   # to be output to a file.
   #
   # - Never overload this command!
   # - Any customization should be done in PB_CMD_before_output!
   #

      if { [llength [info commands PB_CMD_kin_before_output]] &&\
           [llength [info commands PB_CMD_before_output]] } {

         PB_CMD_kin_before_output
      }

   ######### The following procedure invokes the listing file with warnings.

      global mom_sys_list_output
      if { [string match "ON" $mom_sys_list_output] } {
         LIST_FILE
      } else {
         global tape_bytes mom_o_buffer
         if { ![info exists tape_bytes] } {
            set tape_bytes [string length $mom_o_buffer]
         } else {
            incr tape_bytes [string length $mom_o_buffer]
         }
      }
   }


     if { [string match "OFF" [MOM_ask_env_var UGII_CAM_POST_LINK_VAR_MODE]] } {
        set mom_sys_link_var_mode                     "OFF"
     } else {
        set mom_sys_link_var_mode                     "$mom_sys_pb_link_var_mode"
     }


     set mom_sys_control_out                       "("  
     set mom_sys_control_in                        ")"  

     set mom_sys_post_initialized 1
  }


########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "0"  
  set mom_sys_linear_code                       "1"  
  set mom_sys_circle_code(CLW)                  "2"  
  set mom_sys_circle_code(CCLW)                 "3"  
  set mom_sys_delay_code(SECONDS)               "4"  
  set mom_sys_delay_code(REVOLUTIONS)           "4"  
  set mom_sys_cutcom_plane_code(XY)             "17" 
  set mom_sys_cutcom_plane_code(ZX)             "18" 
  set mom_sys_cutcom_plane_code(XZ)             "18" 
  set mom_sys_cutcom_plane_code(YZ)             "19" 
  set mom_sys_cutcom_plane_code(ZY)             "19" 
  set mom_sys_cutcom_code(OFF)                  "40" 
  set mom_sys_cutcom_code(LEFT)                 "41" 
  set mom_sys_cutcom_code(RIGHT)                "42" 
  set mom_sys_adjust_code                       "43" 
  set mom_sys_adjust_code_minus                 "44" 
  set mom_sys_adjust_cancel_code                "49" 
  set mom_sys_unit_code(IN)                     "70" 
  set mom_sys_unit_code(MM)                     "71" 
  set mom_sys_cycle_start_code                  "79" 
  set mom_sys_cycle_off                         "80" 
  set mom_sys_cycle_drill_code                  "81" 
  set mom_sys_cycle_drill_dwell_code            "82" 
  set mom_sys_cycle_drill_deep_code             "83" 
  set mom_sys_cycle_drill_break_chip_code       "73" 
  set mom_sys_cycle_tap_code                    "84" 
  set mom_sys_cycle_bore_code                   "85" 
  set mom_sys_cycle_bore_drag_code              "86" 
  set mom_sys_cycle_bore_no_drag_code           "76" 
  set mom_sys_cycle_bore_dwell_code             "89" 
  set mom_sys_cycle_bore_manual_code            "88" 
  set mom_sys_cycle_bore_back_code              "87" 
  set mom_sys_cycle_bore_manual_dwell_code      "88" 
  set mom_sys_output_code(ABSOLUTE)             "90" 
  set mom_sys_output_code(INCREMENTAL)          "91" 
  set mom_sys_cycle_ret_code(AUTO)              "98" 
  set mom_sys_cycle_ret_code(MANUAL)            "99" 
  set mom_sys_reset_code                        "92" 
  set mom_sys_feed_rate_mode_code(FRN)          "93" 
  set mom_sys_spindle_mode_code(SFM)            "96" 
  set mom_sys_spindle_mode_code(RPM)            "97" 
  set mom_sys_return_code                       "28" 
  set mom_sys_feed_rate_mode_code(MMPM)         "94" 
  set mom_sys_feed_rate_mode_code(MMPR)         "95" 
  set mom_sys_program_stop_code                 "0"  
  set mom_sys_optional_stop_code                "1"  
  set mom_sys_end_of_program_code               "2"  
  set mom_sys_spindle_direction_code(CLW)       "3"  
  set mom_sys_spindle_direction_code(CCLW)      "4"  
  set mom_sys_spindle_direction_code(OFF)       "5"  
  set mom_sys_tool_change_code                  "6"  
  set mom_sys_coolant_code(ON)                  "8"  
  set mom_sys_coolant_code(FLOOD)               "8"  
  set mom_sys_coolant_code(MIST)                "7"  
  set mom_sys_coolant_code(THRU)                "88" 
  set mom_sys_coolant_code(TAP)                 "27" 
  set mom_sys_coolant_code(OFF)                 "9"  
  set mom_sys_rewind_code                       "30" 
  set mom_sys_4th_axis_has_limits               "1"  
  set mom_sys_5th_axis_has_limits               "1"  
  set mom_sys_sim_cycle_drill                   "0"  
  set mom_sys_sim_cycle_drill_dwell             "0"  
  set mom_sys_sim_cycle_drill_deep              "0"  
  set mom_sys_sim_cycle_drill_break_chip        "0"  
  set mom_sys_sim_cycle_tap                     "0"  
  set mom_sys_sim_cycle_bore                    "0"  
  set mom_sys_sim_cycle_bore_drag               "0"  
  set mom_sys_sim_cycle_bore_nodrag             "0"  
  set mom_sys_sim_cycle_bore_manual             "0"  
  set mom_sys_sim_cycle_bore_dwell              "0"  
  set mom_sys_sim_cycle_bore_manual_dwell       "0"  
  set mom_sys_sim_cycle_bore_back               "0"  
  set mom_sys_cir_vector                        "Vector - Arc Start to Center"
  set mom_sys_spindle_ranges                    "0"  
  set mom_sys_rewind_stop_code                  "\#" 
  set mom_sys_home_pos(0)                       "0"  
  set mom_sys_home_pos(1)                       "0"  
  set mom_sys_home_pos(2)                       "0"  
  set mom_sys_zero                              "0"  
  set mom_sys_opskip_block_leader               "/"  
  set mom_sys_seqnum_start                      "10" 
  set mom_sys_seqnum_incr                       "10" 
  set mom_sys_seqnum_freq                       "1"  
  set mom_sys_seqnum_max                        "9999"
  set mom_sys_lathe_x_double                    "1"  
  set mom_sys_lathe_i_double                    "1"  
  set mom_sys_lathe_y_double                    "1"  
  set mom_sys_lathe_j_double                    "1"  
  set mom_sys_lathe_x_factor                    "1"  
  set mom_sys_lathe_y_factor                    "1"  
  set mom_sys_lathe_z_factor                    "1"  
  set mom_sys_lathe_i_factor                    "1"  
  set mom_sys_lathe_j_factor                    "1"  
  set mom_sys_lathe_k_factor                    "1"  
  set mom_sys_leader(N)                         "N"  
  set mom_sys_leader(X)                         "X"  
  set mom_sys_leader(Y)                         "Y"  
  set mom_sys_leader(Z)                         "Z"  
  set mom_sys_leader(fourth_axis)               "A"  
  set mom_sys_leader(fifth_axis)                "B"  
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(IPR,format)            "Feed_IPR"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_vnc_rapid_dogleg                  "1"  
  set mom_sys_prev_mach_head                    ""   
  set mom_sys_curr_mach_head                    ""   
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
  set mom_sys_linearization_method              "angle"
  set mom_sys_post_description                  "This is a 4-Axis Milling Machine With\n\
                                                  Rotary Table."
  set mom_sys_ugpadvkins_used                   "0"
  set mom_sys_post_builder_version              "9.0.0"

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_4th_axis_ang_offset               "0.0"
  set mom_kin_4th_axis_center_offset(0)         "0.0"
  set mom_kin_4th_axis_center_offset(1)         "0.0"
  set mom_kin_4th_axis_center_offset(2)         "0.0"
  set mom_kin_4th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_4th_axis_incr_switch              "ON" 
  set mom_kin_4th_axis_leader                   "A"  
  set mom_kin_4th_axis_limit_action             "Warning"
  set mom_kin_4th_axis_max_limit                "6000"
  set mom_kin_4th_axis_min_incr                 "0.001"
  set mom_kin_4th_axis_min_limit                "-6000"
  set mom_kin_4th_axis_plane                    "YZ" 
  set mom_kin_4th_axis_point(0)                 "0.0"
  set mom_kin_4th_axis_point(1)                 "0.0"
  set mom_kin_4th_axis_point(2)                 "0.0"
  set mom_kin_4th_axis_rotation                 "standard"
  set mom_kin_4th_axis_type                     "Table"
  set mom_kin_4th_axis_vector(0)                "1"  
  set mom_kin_4th_axis_vector(1)                "0"  
  set mom_kin_4th_axis_vector(2)                "0"  
  set mom_kin_4th_axis_zero                     "0.0"
  set mom_kin_5th_axis_center_offset(0)         "0.0"
  set mom_kin_5th_axis_center_offset(1)         "0.0"
  set mom_kin_5th_axis_center_offset(2)         "0.0"
  set mom_kin_5th_axis_incr_switch              "OFF"
  set mom_kin_5th_axis_max_limit                "0.0"
  set mom_kin_5th_axis_min_incr                 "0.0"
  set mom_kin_5th_axis_min_limit                "0.0"
  set mom_kin_5th_axis_point(0)                 "0.0"
  set mom_kin_5th_axis_point(1)                 "0.0"
  set mom_kin_5th_axis_point(2)                 "0.0"
  set mom_kin_5th_axis_vector(0)                "0.0"
  set mom_kin_5th_axis_vector(1)                "1.0"
  set mom_kin_5th_axis_vector(2)                "0.0"
  set mom_kin_5th_axis_zero                     "0.0"
  set mom_kin_arc_output_mode                   "FULL_CIRCLE"
  set mom_kin_arc_valid_plane                   "XYZ"
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_cycle_plane_change_per_axis       "0"  
  set mom_kin_cycle_plane_change_to_lower       "0"  
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "1"  
  set mom_kin_linearization_tol                 "0.01"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "4_axis_table"
  set mom_kin_machine_zero_offset(0)            "0.0"
  set mom_kin_machine_zero_offset(1)            "0.0"
  set mom_kin_machine_zero_offset(2)            "0.0"
  set mom_kin_max_arc_radius                    "99999.999"
  set mom_kin_max_dpm                           "7800"
  set mom_kin_max_fpm                           "15000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "999999.999"
  set mom_kin_min_arc_length                    "0.20"
  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.1"
  set mom_kin_min_frn                           "0.001"
  set mom_kin_output_unit                       "MM" 
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_pivot_guage_offset                ""   
  set mom_kin_post_data_unit                    "MM" 
  set mom_kin_rapid_feed_rate                   "10000"
  set mom_kin_retract_distance                  "500"
  set mom_kin_rotary_axis_method                "PREVIOUS"
  set mom_kin_spindle_axis(0)                   "0.0"
  set mom_kin_spindle_axis(1)                   "0.0"
  set mom_kin_spindle_axis(2)                   "1.0"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "1000"
  set mom_kin_y_axis_limit                      "1000"
  set mom_kin_z_axis_limit                      "1000"




if [llength [info commands MOM_SYS_do_template] ] {
   if [llength [info commands MOM_do_template] ] {
      rename MOM_do_template ""
   }
   rename MOM_SYS_do_template MOM_do_template
}




#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register
  global mom_wire_cutcom_status

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED
    set mom_wire_cutcom_status  UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    catch { OPEN_files } ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing



  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


   # Load parameters for alternate output units
    PB_load_alternate_unit_settings
    rename PB_load_alternate_unit_settings ""


#************
uplevel #0 {


#=============================================================
proc MOM_sync { } {
#=============================================================
  if [llength [info commands PB_CMD_kin_handle_sync_event] ] {
    PB_CMD_kin_handle_sync_event
  }
}


#=============================================================
proc MOM_set_csys { } {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys { } {
#=============================================================
}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
   MOM_do_template end_of_program_1
   MOM_do_template end_of_program_3
   MOM_do_template end_of_program_2
   MOM_force Once G Y
   MOM_do_template end_of_program_4
   MOM_do_template end_of_program_5
   MOM_do_template end_of_program
   MOM_set_seq_off
   MOM_do_template rewind_stop_code

#**** The following procedure lists the tool list with time in commentary data
   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files

   if [llength [info commands PB_CMD_kin_end_of_program] ] {
      PB_CMD_kin_end_of_program
   }
}


  incr mom_sys_post_initialized


} ;# uplevel
#***********


}


#=============================================================
proc PB_init_new_iks { } {
#=============================================================
  global mom_kin_iks_usage mom_kin_spindle_axis
  global mom_kin_4th_axis_vector mom_kin_5th_axis_vector


   set mom_kin_iks_usage 1

  # Override spindle axis vector defined in PB_CMD_init_rotary
   set mom_kin_spindle_axis(0)  0.0
   set mom_kin_spindle_axis(1)  0.0
   set mom_kin_spindle_axis(2)  1.0

  # Unitize vectors
   foreach i { 0 1 2 } {
      set vec($i) $mom_kin_spindle_axis($i)
   }
   VEC3_unitize vec mom_kin_spindle_axis

   foreach i { 0 1 2 } {
      set vec($i) $mom_kin_4th_axis_vector($i)
   }
   VEC3_unitize vec mom_kin_4th_axis_vector

   foreach i { 0 1 2 } {
      set vec($i) $mom_kin_5th_axis_vector($i)
   }
   VEC3_unitize vec mom_kin_5th_axis_vector

  # Reload kinematics
   MOM_reload_kinematics
}


#=============================================================
proc PB_DELAY_TIME_SET { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

  # Post Builder provided format for the current mode:
   if { [info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0 } {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
   }

   switch $mom_delay_mode {
      SECONDS { set delay_time $mom_delay_value }
      default { set delay_time $mom_delay_revs  }
   }
}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

   FEEDRATE_SET


   switch $mom_motion_type {
      ENGAGE   { PB_engage_move }
      APPROACH { PB_approach_move }
      FIRSTCUT { catch {PB_first_cut} }
      RETRACT  { PB_retract_move }
      RETURN   { catch {PB_return_move} }
      default  {}
   }

   if { [llength [info commands PB_CMD_kin_before_motion] ] } { PB_CMD_kin_before_motion }
   if { [llength [info commands PB_CMD_before_motion] ] }     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_start_of_group { } {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

   if { ![hiset group_level] } {
      set group_level 0
      return
   }

   if { [hiset mom_sys_group_output] } {
      if { ![string compare $mom_sys_group_output "OFF"] } {
         set group_level 0
         return
      }
   }

   if { [hiset group_level] } {
      incr group_level
   } else {
      set group_level 1
   }

   if { $group_level > 1 } {
      return
   }

   SEQNO_RESET ; #<4133654>
   MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

   if { [info exists ptp_file_name] } {
      MOM_close_output_file $ptp_file_name
      MOM_start_of_program
      if { ![string compare $mom_sys_ptp_output "ON"] } {
         MOM_open_output_file $ptp_file_name
      }
   } else {
      MOM_start_of_program
   }

   PB_start_of_program
   set pb_start_of_program_flag 1
}


#=============================================================
proc MOM_machine_mode { } {
#=============================================================
  global pb_start_of_program_flag
  global mom_operation_name mom_sys_change_mach_operation_name

   set mom_sys_change_mach_operation_name $mom_operation_name

   if { $pb_start_of_program_flag == 0 } {
      PB_start_of_program
      set pb_start_of_program_flag 1
   }

  # For simple mill-turn
   if { [llength [info commands PB_machine_mode] ] } {
      if { [catch {PB_machine_mode} res] } {
         CATCH_WARNING "$res"
      }
   }
}


#=============================================================
proc PB_FORCE { option args } {
#=============================================================
   set adds [join $args]
   if { [info exists option] && [llength $adds] } {
      lappend cmd MOM_force
      lappend cmd $option
      lappend cmd [join $adds]
      eval [join $cmd]
   }
}


#=============================================================
proc PB_SET_RAPID_MOD { mod_list blk_list ADDR NEW_MOD_LIST } {
#=============================================================
  upvar $ADDR addr
  upvar $NEW_MOD_LIST new_mod_list
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2


   set new_mod_list [list]

   foreach mod $mod_list {
      switch $mod {
         "rapid1" {
            set elem $addr($traverse_axis1)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid2" {
            set elem $addr($traverse_axis2)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid3" {
            set elem $addr($mom_cycle_spindle_axis)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         default {
            set elem $mod
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
      }
   }
}


########################
# Redefine FEEDRATE_SET
########################
if { [llength [info commands ugpost_FEEDRATE_SET] ] } {
   rename ugpost_FEEDRATE_SET ""
}

if { [llength [info commands FEEDRATE_SET] ] } {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET { } {
#=============================================================
   if { [llength [info commands PB_CMD_kin_feedrate_set] ] } {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}


############## EVENT HANDLING SECTION ################


#=============================================================
proc MOM_auxfun { } {
#=============================================================
   MOM_do_template auxfun
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_BACK
   CYCLE_SET
}


#=============================================================
proc MOM_bore_back_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_back
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_drag_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_drag
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_dwell_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_manual
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_dwell_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_manual_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_NO_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_no_drag_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_bore_no_drag
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================

   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   CIRCLE_SET
   MOM_do_template circular_move
}


#=============================================================
proc MOM_clamp { } {
#=============================================================
   global mom_clamp_axis
   global mom_clamp_status
   global mom_clamp_text
   PB_CMD_MOM_clamp
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
   COOLANT_SET
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
   CUTCOM_SET

   global mom_cutcom_adjust_register
   set cutcom_register_min 1
   set cutcom_register_max 99
   if { [info exists mom_cutcom_adjust_register] } {
      if { $mom_cutcom_adjust_register < $cutcom_register_min ||\
           $mom_cutcom_adjust_register > $cutcom_register_max } {
         CATCH_WARNING "CUTCOM register $mom_cutcom_adjust_register must be within the range between 1 and 99"
      }
   }
   PB_CMD_fixupD
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
   CUTCOM_SET
   PB_CMD_fixupD_off
}


#=============================================================
proc MOM_cycle_off { } {
#=============================================================
   MOM_do_template cycle_off
}


#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag
  global mom_cycle_tool_axis_change
  global mom_cycle_clearance_plane_change

   set cycle_init_flag TRUE
}


#=============================================================
proc MOM_delay { } {
#=============================================================
   PB_DELAY_TIME_SET
   MOM_do_template delay
}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_drill
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_drill_break_chip
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_drill_deep
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_drill_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_text { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_TEXT
   CYCLE_SET
}


#=============================================================
proc MOM_drill_text_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================
  global mom_sys_add_cutting_time mom_sys_add_non_cutting_time
  global mom_cutting_time mom_machine_time

  # Accumulated time should be in minutes.
   set mom_cutting_time [expr $mom_cutting_time + $mom_sys_add_cutting_time]
   set mom_machine_time [expr $mom_machine_time + $mom_sys_add_cutting_time + $mom_sys_add_non_cutting_time]
   MOM_reload_variable mom_cutting_time
   MOM_reload_variable mom_machine_time

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation
   set mom_sys_in_operation 0
}


#=============================================================
proc MOM_end_of_subop_path { } {
#=============================================================
}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_sameTool_superstop
   PB_CMD_changeHON
   PB_CMD_index_status
   PB_CMD_rapid_nanny
   catch {MOM_$mom_motion_event}
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_sys_first_tool_handled

  # First tool only gets handled once
   if { [info exists mom_sys_first_tool_handled] } {
      MOM_tool_change
      return
   }

   set mom_sys_first_tool_handled 1

   PB_CMD_setN
   MOM_do_template first_tool
   MOM_force Once G_mode
   MOM_do_template first_tool_3
   MOM_force Once G_adjust S M_spindle
   MOM_do_template first_tool_1
   MOM_do_template first_tool_2
   PB_CMD_HON_codes
}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_rapid_move
}


#=============================================================
proc MOM_head { } {
#=============================================================
   global mom_head_name
}


#=============================================================
proc MOM_Head { } {
#=============================================================
   MOM_head
}


#=============================================================
proc MOM_HEAD { } {
#=============================================================
   MOM_head
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_TOOL_INFO
   PB_CMD_index_status
   PB_CMD_rapid_nanny

  global mom_programmed_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
      MOM_rapid_move
   } else {
      MOM_linear_move
   }
}


#=============================================================
proc MOM_insert { } {
#=============================================================
   global mom_Instruction
   PB_CMD_MOM_insert
}


#=============================================================
proc MOM_instance_operation_handler { } {
#=============================================================
   global mom_handle_instanced_operations
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
   TOOL_SET MOM_length_compensation
   MOM_do_template tool_length_adjust
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate

   if { ![string compare $feed_mode "IPM"] || ![string compare $feed_mode "MMPM"] } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   global first_linear_move

   if { !$first_linear_move } {
      PB_first_linear_move
      incr first_linear_move
   }

   PB_CMD__combine_rotary_output
   PB_CMD_suppress_linear_block_plane_code
   PB_CMD_conditional_forceF
   MOM_do_template linear_move
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
}


#=============================================================
proc MOM_lock_axis { } {
#=============================================================
   global mom_lock_axis
   global mom_lock_axis_plane
   global mom_lock_axis_value
   PB_CMD_MOM_lock_axis
}


#=============================================================
proc MOM_operator_message { } {
#=============================================================
   global mom_operator_message
   PB_CMD_MOM_operator_message
}


#=============================================================
proc MOM_opskip_off { } {
#=============================================================
   global mom_opskip_text
   PB_CMD_MOM_opskip_off
}


#=============================================================
proc MOM_opskip_on { } {
#=============================================================
   global mom_opskip_text
   PB_CMD_MOM_opskip_on
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_origin { } {
#=============================================================
   global mom_X
   global mom_Y
   global mom_Z
   global mom_origin_text
}


#=============================================================
proc MOM_power { } {
#=============================================================
   global mom_power_value
   global mom_power_text
}


#=============================================================
proc MOM_pprint { } {
#=============================================================
   global mom_pprint
   PB_CMD_MOM_pprint
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
   MOM_do_template prefun
}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   set spindle_first NONE

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   set rapid_spindle_blk {G_mode G_adjust G_motion X Y Z fourth_axis H}
   set rapid_spindle_x_blk {G_mode G_adjust G_motion X fourth_axis H}
   set rapid_spindle_y_blk {G_mode G_adjust G_motion Y fourth_axis H}
   set rapid_spindle_z_blk {G_mode G_adjust G_motion Z fourth_axis H}
   set rapid_traverse_blk {G_mode G_plane G_motion X Y Z fourth_axis S M_spindle}
   set rapid_traverse_xy_blk {G_mode G_plane G_motion X Y fourth_axis S M_spindle}
   set rapid_traverse_yz_blk {G_mode G_plane G_motion Y Z fourth_axis S M_spindle}
   set rapid_traverse_xz_blk {G_mode G_plane G_motion X Z fourth_axis S M_spindle}
   set rapid_traverse_mod {}
   set rapid_spindle_mod {}

   global mom_sys_control_out mom_sys_control_in
   set co "$mom_sys_control_out"
   set ci "$mom_sys_control_in"


   if { ![info exists mom_cycle_spindle_axis] } {
      set mom_cycle_spindle_axis 2
   }
   if { ![info exists spindle_first] } {
      set spindle_first NONE
   }
   if { ![info exists rapid_spindle_inhibit] } {
      set rapid_spindle_inhibit FALSE
   }
   if { ![info exists rapid_traverse_inhibit] } {
      set rapid_traverse_inhibit FALSE
   }

   switch $mom_cycle_spindle_axis {
      0 {
         if [llength $rapid_spindle_x_blk] {
            set spindle_block  rapid_spindle_x
            PB_SET_RAPID_MOD $rapid_spindle_mod $rapid_spindle_x_blk aa mod_spindle
         } else {
            set spindle_block  ""
         }
         if [llength $rapid_traverse_yz_blk] {
            set traverse_block rapid_traverse_yz
            PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_yz_blk aa mod_traverse
         } else {
            set traverse_block  ""
         }
      }

      1 {
         if [llength $rapid_spindle_y_blk] {
            set spindle_block  rapid_spindle_y
            PB_SET_RAPID_MOD $rapid_spindle_mod $rapid_spindle_y_blk aa mod_spindle
         } else {
            set spindle_block  ""
         }
         if [llength $rapid_traverse_xz_blk] {
            set traverse_block rapid_traverse_xz
            PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_xz_blk aa mod_traverse
         } else {
            set traverse_block  ""
         }
      }

      2 {
         if [llength $rapid_spindle_z_blk] {
            set spindle_block  rapid_spindle_z
            PB_SET_RAPID_MOD $rapid_spindle_mod $rapid_spindle_z_blk aa mod_spindle
         } else {
            set spindle_block  ""
         }
         if [llength $rapid_traverse_xy_blk] {
            set traverse_block rapid_traverse_xy
            PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_xy_blk aa mod_traverse
         } else {
            set traverse_block  ""
         }
      }

      default {
         set spindle_block  rapid_spindle
         set traverse_block rapid_traverse
         PB_SET_RAPID_MOD $rapid_spindle_mod $rapid_spindle_blk aa mod_spindle
         PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_blk aa mod_traverse
      }
   }

   if { ![string compare $spindle_first "TRUE"] } {
      if { ![string compare $rapid_spindle_inhibit "FALSE"] } {
         if { [string compare $spindle_block ""] } {
            PB_FORCE Once $mod_spindle
            MOM_do_template $spindle_block
         } else {
            MOM_output_literal "$co Rapid Spindle Block is empty! $ci"
         }
      }
      if { ![string compare $rapid_traverse_inhibit "FALSE"] } {
         if { [string compare $traverse_block ""] } {
            PB_FORCE Once $mod_traverse
            MOM_do_template $traverse_block
         } else {
            MOM_output_literal "$co Rapid Traverse Block is empty! $ci"
         }
      }
   } elseif { ![string compare $spindle_first "FALSE"] } {
      if { ![string compare $rapid_traverse_inhibit "FALSE"] } {
         if { [string compare $traverse_block ""] } {
            PB_FORCE Once $mod_traverse
            MOM_do_template $traverse_block
         } else {
            MOM_output_literal "$co Rapid Traverse Block is empty! $ci"
         }
      }
      if { ![string compare $rapid_spindle_inhibit "FALSE"] } {
         if { [string compare $spindle_block ""] } {
            PB_FORCE Once $mod_spindle
            MOM_do_template $spindle_block
         } else {
            MOM_output_literal "$co Rapid Spindle Block is empty! $ci"
         }
      }
   } else {
      PB_FORCE Once $mod_traverse
      MOM_do_template rapid_traverse
   }
   PB_CMD_save_tablepos
}


#=============================================================
proc MOM_rotate { } {
#=============================================================
   global mom_rotate_axis_type
   global mom_rotation_mode
   global mom_rotation_direction
   global mom_rotation_angle
   global mom_rotation_reference_mode
   global mom_rotation_text
   PB_CMD_MOM_rotate
}


#=============================================================
proc MOM_select_head { } {
#=============================================================
   global mom_head_type
   global mom_head_text
}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   global mom_sequence_mode
   global mom_sequence_number
   global mom_sequence_increment
   global mom_sequence_frequency
   global mom_sequence_text
   SEQNO_SET
}


#=============================================================
proc MOM_set_axis { } {
#=============================================================
   global mom_axis_position
   global mom_axis_position_value
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
   MODES_SET
}


#=============================================================
proc MOM_set_polar { } {
#=============================================================
   global mom_coordinate_output_mode
}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   SPINDLE_SET
   MOM_force Once S M_spindle
   MOM_do_template spindle_rpm
}


#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global mom_sys_in_operation
   set mom_sys_in_operation 1

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path


  global mom_sys_add_cutting_time mom_sys_add_non_cutting_time
  global mom_sys_machine_time mom_machine_time
   set mom_sys_add_cutting_time 0.0
   set mom_sys_add_non_cutting_time 0.0
   set mom_sys_machine_time $mom_machine_time

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

   PB_CMD_TOOL_INFO
   PB_CMD_INFO
   PB_CMD_start_of_operation_force_addresses
   PB_CMD_trap_zeros
}


#=============================================================
proc MOM_start_of_subop_path { } {
#=============================================================
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET
}


#=============================================================
proc MOM_tap_move { } {
#=============================================================
   global cycle_init_flag


   global mom_sys_abort_next_event
   if { [info exists mom_sys_abort_next_event] } {
      if { [llength [info commands PB_CMD_kin_abort_event]] } {
         PB_CMD_kin_abort_event
      }
   }


   MOM_do_template cycle_tap
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_text { } {
#=============================================================
   global mom_user_defined_text
   PB_CMD_MOM_text
}


#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if { [info exists mom_tool_change_type] } {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif { [info exists mom_manual_tool_change] } {
      if { ![string compare $mom_manual_tool_change "TRUE"] } {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
   if {[info exists mom_tool_preselect_number]} {
      set mom_next_tool_number $mom_tool_preselect_number
   }
   MOM_do_template tool_preselect
}


#=============================================================
proc MOM_workpiece_load { } {
#=============================================================
   global mom_spindle_number
}


#=============================================================
proc MOM_workpiece_takeover { } {
#=============================================================
   global mom_spindle_2_position
   global mom_takeover_csys
}


#=============================================================
proc MOM_workpiece_unload { } {
#=============================================================
   global mom_spindle_number
}


#=============================================================
proc MOM_zero { } {
#=============================================================
   global mom_work_coordinate_number
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
   global mom_tool_number mom_next_tool_number
   if { ![info exists mom_next_tool_number] } {
      set mom_next_tool_number $mom_tool_number
   }

   PB_CMD_beforetoolchange
   MOM_do_template auto_tool_change_1
   MOM_force Once T M
   MOM_do_template tool_change_1
   MOM_force Once G_mode
   MOM_do_template auto_tool_change_3
   MOM_force Once G_adjust S M_spindle
   MOM_do_template auto_tool_change
   MOM_force Once M_coolant
   MOM_do_template auto_tool_change_2
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_feedrates { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
  global mom_sys_first_linear_move

  # Set this variable to signal 1st linear move has been handled.
   set mom_sys_first_linear_move 1

}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   PB_CMD_tool_change_force_addresses
   MOM_do_template stop
}


#=============================================================
proc PB_retract_move { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc PB_start_of_program { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }

   MOM_set_seq_off
   PB_CMD_init_vars
   PB_CMD_replacement_procedures
   PB_CMD_program_header
   PB_CMD__combine_rotary_init
   MOM_force Once G_mode G_plane G_cutcom G_motion
   MOM_do_template absolute_mode
   MOM_do_template start_of_program_4
   MOM_do_template start_of_program_5
   MOM_do_template start_of_program_6
   PB_CMD_coordinate_offset
   PB_CMD_fix_RAPID_SET
   PB_CMD_threadmill_handler
   PB_CMD_NPARSE

   if [llength [info commands PB_CMD_kin_start_of_program_2] ] {
      PB_CMD_kin_start_of_program_2
   }
}


#=============================================================
proc PB_user_def_axis_limit_action { args } {
#=============================================================
}


#=============================================================
proc PB_CMD_ATC { } {
#=============================================================
global mom_tool_number
global mom_tool_name
global mom_tool_catalog_number
global mom_tool_diameter
global prev_tool
global cur_tool
global prev_tool_size
global tlo
global tmax
global dupa
set dupa 0

set prev_tool_size $mom_tool_diameter

global tix

if {$mom_tool_number < 10} {
set tlo "T0"
append tlo $mom_tool_number
} else {
set tlo "T"
append tlo $mom_tool_number
}

MOM_output_literal "\n( TOOL CHANGE === $tlo ============)"
MOM_output_literal "( NEW TOOL NAME __ $mom_tool_name )"
MOM_output_literal "( DIAMETER _______ [format "%-5.4f" $mom_tool_diameter] )"
MOM_output_literal "( CATLOG NUMBER __ $mom_tool_catalog_number )"
MOM_output_literal "(=================================)\n"


set prev_tool $mom_tool_number

PB_CMD_TOOL_CHECK

set prev_tool $cur_tool
#======================================================================================
#   CREATING TOOL LIST ONE LINE AT A TIME
#======================================================================================

global licznik
incr licznik 1

if {$mom_tool_number > $tmax} {
set dupa 1
}

set tix(1,$licznik) $tlo
set tix(2,$licznik) $mom_tool_name
set tix(3,$licznik) $mom_tool_catalog_number
}


#=============================================================
proc PB_CMD_AUGER-FORWARD { } {
#=============================================================
MOM_output_literal "M31 "  ;#auger start forward
}


#=============================================================
proc PB_CMD_Approach { } {
#=============================================================
# conditionally rapid to x0y0 after tchange if name includes "PROBE"

global mom_tool_name global mom_fixture_offset js_fixoff pn_tool_adjust_register

# MOM_output_literal "$mom_tool_name"

if {  [string first "PROBE" $mom_tool_name ]  < 0 } { return }

PB_CMD_fixupH  ;# set special H for probe

MOM_output_literal "G$js_fixoff G43 G0 X0.0 Y0.0 H$pn_tool_adjust_register "
}


#=============================================================
proc PB_CMD_FEEDRATE_NUMBER { } {
#=============================================================
#
#  This custom command allows you to modify the feed rate number
#  after it has been calculated by the system
#
   global mom_feed_rate_number

   set mom_sys_frn_factor 1.0

   if { [info exists mom_feed_rate_number] } {
      return [expr $mom_feed_rate_number * $mom_sys_frn_factor]
   } else {
      return 0.0
   }
}


#=============================================================
proc PB_CMD_G00_G90_G80_G40 { } {
#=============================================================
global licznik

MOM_output_literal "G103 P1"
MOM_output_literal "#592 = $licznik"
MOM_output_literal "N$licznik G00 G90 G80 G40"
MOM_output_literal "G103"
}


#=============================================================
proc PB_CMD_GIVE_ME_TIME { } {
#=============================================================
#   this procedure is intended to calculate total machining time
#   author: Michal Wagrodzki
#   date: January 2007
#   exclusive property of Michal Wagrodzki

global mom_machine_time
global mt_real
global temp
global real_factor
global my_h
global my_m
global my_s
global extra_time

set real_factor 1.2125
set mt_real [ expr { $real_factor * $mom_machine_time }]
set temp [ expr { int($mt_real) } ]

set my_h [ expr { int($mt_real / 60) } ]
set my_s [ expr { int(60 * ($mt_real - $temp)) } ]
set my_m [ expr { int($temp-60*$my_h) } ]

#set two digit output for hours
if { $my_h < 10 } {
set my_h "0$my_h"
}

#set two digit output for minutes
if { $my_m < 10 } {
set my_m "0$my_m"
}

#set two digit output for seconds
if { $my_s < 10 } {
set my_s "0$my_s"
}

MOM_output_literal "\n(CALCULATED MACHINING TIME IS)"
MOM_output_literal "(   [format "%-2s" $my_h] HOURS  )"
MOM_output_literal "(   [format "%-2s" $my_m] MINUTES)"
MOM_output_literal "(   [format "%-2s" $my_s] SECONDS)"
MOM_output_literal "( MEASURED CYCLE TIME IS: )"
MOM_output_literal "(   00 HOURS  )"
MOM_output_literal "(   00 MINUTES)"
MOM_output_literal "(   00 SECONDS)\n"
}


#=============================================================
proc PB_CMD_G_adjust { } {
#=============================================================

MOM_force once G_adjust H
#MOM_output_literal " trace for G adjust "
}


#=============================================================
proc PB_CMD_HEADER { } {
#=============================================================
global mom_output_file_basename            # nc tape name
global mom_logname                # computer username
global mom_part_name                # file name of UG part
global mom_date                    # output date
global mom_ug_version                # UG version
global mom_output_unit                # defines output unit as inch or metric
global mom_sys_unit_code            # defines G code for code output, uses
global mom_output_unit                # mom_output_unit as variable

global login                    # friendly name for logname
global date                    # formatted date holder
global file_name                # formatted file name holder
global day_name                    # formatted day name
global month                    # formatted month name
global day_num                    # formatted day date
global time                    # formatted time

global lao
global year                    # year holder
global hours                    # formatted hour
global minutes                    # minute holder
global seconds                    # seconds holder
global pm_flag                    # flag to check if am or pm
global autor                    # my name or any login
global extra_time
set extra_time 0
global min_size
global prev_tool; set prev_tool 0
global cur_tool; set cur_tool 0
set min_size 0.039

set pm_flag 0


# set login to be all capital letters
set login [string toupper $mom_logname]

# break up the date stamp into elements
scan $mom_date %s%s%s%s%s day_name month day_num time year

# break up time into elements
scan $time %d:%d:%d hours minutes seconds

# format minutes if less than 10
if {$minutes < 10 } {
  set minutes "0$minutes"
}

# format hours into non-military time
if { $hours > 12 } {
  set hours [expr {$hours - 0}]
  set pm_flag 1
} else {
  set pm_flag 0
}

# rebuild time
set time $hours
append time "."
append time $minutes
if { $pm_flag == 1 } {
  append time " "
} else {
  append time " "
}

# rebuild date
set date $day_name
append date " " $month " " $day_num " " $year " AT " $time

# set date to all capital letters
set date [string toupper $date]

# remove all backslashes from file name, replace with a dash,
# and capitalize all letters, then place result in file_name
regsub -all {\\} $mom_part_name {-} file_name
regsub -all {:} $file_name { } file_name

# set file_name to all capital letters
# set file_name [string toupper $file_name]

set autor $login
if { $login == "UGQUAD3A"} {
set autor "MICHAL WAGRODZKI"
}
if {$login == "UGQUAD2"} {
set autor "NATE SMITH"
}
if {$login == "ENG3"} {
set autor "DELL MARTIN"
}

# HEADER OUTPUT

MOM_output_literal "O$mom_output_file_basename ()"
#MOM_output_literal "(PART REVISION ---- )"
MOM_output_literal "(PROGRAM REVISION - )"
MOM_output_literal "(CUSTOMER --------- )\n"
MOM_output_literal "( - SETUP INFO - )\n"
MOM_output_literal "(IF THIS IS A FIRST PIECE)"
MOM_output_literal "(SET #592 TO 0 - NO RETURN)"
MOM_output_literal "(AND #593 TO 1 - PROBING ON)\n"
MOM_output_literal "(ATTENTION)"
MOM_output_literal "\n(KEEP ALL TOOLS CLEAN)"
MOM_output_literal "(AND FREE OF ACCUMULATED CHIPS)"
MOM_output_literal "(BLOW CHIPS AWAY FROM ALL FIXTURES)"
MOM_output_literal "(COLLETS AND OTHER SENSITIVE AREAS)\n"


MOM_output_literal "( --- PROGRAM BY === $autor )"
MOM_output_literal "( --- $date --------------- )"
MOM_output_literal "( --- DEW TECHNOLOGIES, INC. ------------------ )"
MOM_output_literal "( --- 1 HERALD SQUARE, FAIRBORN, OH, 45324, USA )"
MOM_output_literal "( --- OLD HAAS VF3 - WITH HAAS CONTROLLER ----- )"
MOM_output_literal "( --- OUTPUT UNITS --- $mom_output_unit --------------------- )\n"
MOM_output_literal "( --- POST VERSION -- 000034 -- JULY-11-2009 -- )"
MOM_output_literal "( --- BY --- MIKE WAGRODZKI ------------------- )\n"
MOM_output_literal "( P_R_O_G_R_A_M___S_T_A_R_T )\n"
MOM_output_literal "G20 (INCH MODE)\n"
PB_CMD_fix_RAPID_SET
MOM_output_literal "#5=0.004 (TOOL CHECK TOLERANCE)"



################################################
# marking all toolchange points
################################################

global licznik
set licznik 0
MOM_output_literal "\rIF\[#592NE0\]GOTO#592"

#################################################
#setting maximum number of tools in tool changer
#################################################
global tmax
set tmax 250

################################################
# presetting tool list variable array
################################################
global tix
global tink
global ta
global tb
set ta "T0"
set tb "T"


for {set tink 1} {$tink <= $tmax} {incr tink 1} {
if {$tink < 10} {
set tix(1,$tink) "$ta$tink"
} else {
set tix(1,$tink) "$tb$tink"
}
set tix(2,$tink) "EMPTY"
set tix(3,$tink) "EMPTY"
}

set lao 0.0
}


#=============================================================
proc PB_CMD_HON_codes { } {
#=============================================================
# part of toolchange - used in rapid
global mom_operation_type
global js_HON_waiting

set js_HON_waiting "FALSE"             ;# FALSE for drilling

if {[ string first "Point to Point" $mom_operation_type ] < 0 } {
    set js_HON_waiting "TRUE"     ;# TRUE for milling
}
}


#=============================================================
proc PB_CMD_INFO { } {
#=============================================================
global mom_sys_control_in mom_sys_control_out mom_operation_name
global mom_tool_name mom_tool_number
global mom_tool_diameter mom_tool_flute_length

set co $mom_sys_control_out
set ci $mom_sys_control_in

MOM_output_literal "$co ************************************* $ci"
MOM_output_literal "$co *** OPERATION: $mom_operation_name $ci"
MOM_output_literal "$co *** TOOL NUMBER:  $mom_tool_number $ci"
MOM_output_literal "$co *** TOOL TYPE:  $mom_tool_name $ci"
MOM_output_literal "$co *** TOOL DIAMETER: [format %3.2f $mom_tool_diameter] $ci"
MOM_output_literal "$co *** TOOL FLUTE LENGTH:  [format %3.2f $mom_tool_flute_length] $ci"
MOM_output_literal "$co ************************************* $ci"
}


#=============================================================
proc PB_CMD_LAST_TOOL_CHECK { } {
#=============================================================
global prev_tool
global min_size
global prev_tool_size

if {$prev_tool_size < $min_size} {
   if {$prev_tool > 0} {

      MOM_output_literal "G65 P9853 T$prev_tool B1 H#5"
   }
}
}


#=============================================================
proc PB_CMD_MIKES_TOOL_LIST { } {
#=============================================================
############################################
# TOOL LIST OUTPUT AT THE END OF POSTED CODE
############################################

global tix
global tink
global tmax
global dupa


MOM_output_literal "(==LIST OF TOOLS AS THEY APPEAR IN THE PROGRAM==)"

for {set tink 1} {$tink <=$tmax} {incr tink 1} {
if { $tix(2,$tink) != "EMPTY"} {
MOM_output_literal "( $tix(1,$tink) $tix(2,$tink) == $tix(3,$tink) )"
}
}

if {$dupa == 1} {
MOM_output_literal "( TOO LARGE TOOL NUMBER DECLARED )"
}


MOM_output_literal "(========END OF TOOL LIST ========)"
}


#=============================================================
proc PB_CMD_MOM_clamp { } {
#=============================================================
# Default handler for UDE MOM_clamp
# - Do not attach it to any event!
#

  global mom_clamp_axis mom_clamp_status mom_sys_auto_clamp

   if { ![string compare "AUTO" $mom_clamp_axis] } {

      if { ![string compare "ON" $mom_clamp_status] } {
         set mom_sys_auto_clamp "ON"
      } elseif { ![string compare "OFF" $mom_clamp_status] } {
         set mom_sys_auto_clamp "OFF"
      }
   } else {
      CATCH_WARNING "$mom_clamp_axis not handled in current implementation!"
   }
}


#=============================================================
proc PB_CMD_MOM_insert { } {
#=============================================================
# This procedure is executed when the Insert command is activated.
#
   global mom_Instruction
   MOM_output_literal "$mom_Instruction"
}


#=============================================================
proc PB_CMD_MOM_lock_axis { } {
#=============================================================
# Default handler for UDE MOM_lock_axis
# - Do not attach it to any event!
#

  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status

   set status [SET_LOCK axis plane value]

   # Handle "error" condition returned from SET_LOCK
   # - Message in mom_warning_info
   if { ![string compare "error" $status] } {
      global mom_warning_info
      CATCH_WARNING $mom_warning_info

      set mom_sys_lock_status OFF
   } else {
      set mom_sys_lock_status $status
      if { [string compare "OFF" $status] } {
         set mom_sys_lock_axis $axis
         set mom_sys_lock_plane $plane
         set mom_sys_lock_value $value

         LOCK_AXIS_INITIALIZE
      }
   }
}


#=============================================================
proc PB_CMD_MOM_operator_message { } {
#=============================================================
# This procedure is executed when the Operator Message command is activated.
#
   global mom_operator_message mom_operator_message_defined
   global mom_operator_message_status
   global ptp_file_name group_output_file mom_group_name
   global mom_sys_commentary_output
   global mom_sys_control_in
   global mom_sys_control_out
   global mom_sys_ptp_output

   if { [info exists mom_operator_message_defined] } {
      if { $mom_operator_message_defined == 0 } {
return
      }
   }

   if { $mom_operator_message != "ON" && $mom_operator_message != "OFF" } {

      set brac_start [string first \( $mom_operator_message]
      set brac_end   [string last \) $mom_operator_message]

      if { $brac_start != 0 } {
         set text_string "("
      } else {
         set text_string ""
      }

      append text_string $mom_operator_message

      if { $brac_end != [expr [string length $mom_operator_message] - 1] } {
         append text_string ")"
      }

      MOM_close_output_file   $ptp_file_name

      if { [hiset mom_group_name] } {
         if { [hiset group_output_file($mom_group_name)] } {
            MOM_close_output_file $group_output_file($mom_group_name)
         }
      }

      MOM_output_text      $text_string

      if { $mom_sys_ptp_output == "ON" } {
         MOM_open_output_file    $ptp_file_name
      }

      if { [hiset mom_group_name] } {
         if { [hiset group_output_file($mom_group_name)] } {
            MOM_open_output_file $group_output_file($mom_group_name)
         }
      }

      set need_commentary $mom_sys_commentary_output
      set mom_sys_commentary_output OFF
      regsub -all {[)]} $text_string $mom_sys_control_in text_string
      regsub -all {[(]} $text_string $mom_sys_control_out text_string

      MOM_output_literal $text_string

      set mom_sys_commentary_output $need_commentary

   } else {
      set mom_operator_message_status $mom_operator_message
   }
}


#=============================================================
proc PB_CMD_MOM_opskip_off { } {
#=============================================================
# This procedure is executed when the Optional skip command is activated.
#
   global mom_sys_opskip_block_leader
   MOM_set_line_leader off  $mom_sys_opskip_block_leader
}


#=============================================================
proc PB_CMD_MOM_opskip_on { } {
#=============================================================
# This procedure is executed when the Optional skip command is activated.
#
   global mom_sys_opskip_block_leader
   MOM_set_line_leader always  $mom_sys_opskip_block_leader
}


#=============================================================
proc PB_CMD_MOM_pprint { } {
#=============================================================
# This procedure is executed when the PPrint command is activated.
#
   global mom_pprint_defined

   if { [info exists mom_pprint_defined] } {
      if { $mom_pprint_defined == 0 } {
return
      }
   }

   PPRINT_OUTPUT
}


#=============================================================
proc PB_CMD_MOM_rotate { } {
#=============================================================
# Default handler for UDE MOM_rotate
# - Do not attach it to any event!
#

## <rws 04-11-2008>
## If in TURN mode and user invokes "Flip tool around Holder" a MOM_rotate event is generated
## When this happens ABORT this event via return
##

   global mom_machine_mode


   if { [info exists mom_machine_mode] && [string match "TURN" $mom_machine_mode] } {
      if [CMD_EXIST PB_CMD_handle_lathe_flash_tool] {
         PB_CMD_handle_lathe_flash_tool
      }
return
   }


   global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
   global mom_rotation_angle mom_rotation_reference_mode
   global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
   global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
   global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
   global mom_out_angle_pos
   global unlocked_prev_pos mom_sys_leader
   global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
   global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit
   global mom_prev_pos
   global mom_prev_rot_ang_4th mom_prev_rot_ang_5th


   if { ![info exists mom_rotation_angle] } {
     # Should the event be aborted here???
return
   }


   if { ![info exists mom_kin_5th_axis_direction] } {
      set mom_kin_5th_axis_direction "0"
   }


  #
  #  Determine which rotary axis the UDE has specifid - fourth(3), fifth(4) or invalid(0)
  #
  #
   if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {

      switch $mom_rotate_axis_type {
         CAXIS -
         FOURTH_AXIS -
         TABLE {
            set axis 3
         }
         default {
            set axis 0
         }
      }

   } else {

      switch $mom_rotate_axis_type {
         AAXIS -
         BAXIS -
         CAXIS {
            set axis [AXIS_SET $mom_rotate_axis_type]
         }
         HEAD {
            if { ![string compare "5_axis_head_table" $mom_kin_machine_type] || ![string compare "5_AXIS_HEAD_TABLE" $mom_kin_machine_type] } {
               set axis 4
            } else {
               set axis 3
            }
         }
         FIFTH_AXIS {
            set axis 4
         }
         FOURTH_AXIS -
         TABLE -
         default {
            set axis 3
         }
      }
   }

   if { $axis == 0 } {
      CATCH_WARNING "Invalid rotary axis"
      MOM_abort_event
   }

   switch $mom_rotation_mode {
      NONE -
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }

   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }

   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang

   if { $axis == "3" } { ;# Rotate 4th axis

      if { ![info exists mom_prev_rot_ang_4th] } {
         set mom_prev_rot_ang_4th [MOM_ask_address_value fourth_axis]
      }
      if { [string length [string trim $mom_prev_rot_ang_4th]] == 0 } {
         set mom_prev_rot_ang_4th 0.0
      }

      set prev_angles(0) $mom_prev_rot_ang_4th

   } elseif { $axis == "4" } { ;# Rotate 5th axis

      if { ![info exists mom_prev_rot_ang_5th] } {
         set mom_prev_rot_ang_5th [MOM_ask_address_value fifth_axis]
      }
      if { [string length [string trim $mom_prev_rot_ang_5th]] == 0 } {
         set mom_prev_rot_ang_5th 0.0
      }

      set prev_angles(1) $mom_prev_rot_ang_5th
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]

   if { $axis == 3  &&  [string match "MAGNITUDE_DETERMINES_DIRECTION" $mom_kin_4th_axis_direction] } {

      set dirtype "MAGNITUDE_DETERMINES_DIRECTION"

      global mom_sys_4th_axis_dir_mode

      if { [info exists mom_sys_4th_axis_dir_mode] && ![string compare "ON" $mom_sys_4th_axis_dir_mode] } {

         set del $dir
         if { $del == 0 } {
            set del [expr $ang - $mom_prev_pos(3)]
            if { $del >  180.0 } { set del [expr $del - 360.0] }
            if { $del < -180.0 } { set del [expr $del + 360.0] }
         }

         global mom_sys_4th_axis_cur_dir
         global mom_sys_4th_axis_clw_code mom_sys_4th_axis_cclw_code

         if { $del > 0.0 } {
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_clw_code
         } elseif { $del < 0.0 } {
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_cclw_code
         }
      }

   } elseif { $axis == 4  &&  [string match "MAGNITUDE_DETERMINES_DIRECTION" $mom_kin_5th_axis_direction] } {

      set dirtype "MAGNITUDE_DETERMINES_DIRECTION"

      global mom_sys_5th_axis_dir_mode

      if { [info exists mom_sys_5th_axis_dir_mode] && ![string compare "ON" $mom_sys_5th_axis_dir_mode] } {

         set del $dir
         if { $del == 0 } {
            set del [expr $ang - $mom_prev_pos(4)]
            if { $del >  180.0 } { set del [expr $del - 360.0] }
            if { $del < -180.0 } { set del [expr $del + 360.0] }
         }

         global mom_sys_5th_axis_cur_dir
         global mom_sys_5th_axis_clw_code mom_sys_5th_axis_cclw_code

         if { $del > 0.0 } {
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_clw_code
         } elseif { $del < 0.0 } {
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_cclw_code
         }
      }

   } else {

      set dirtype "SIGN_DETERMINES_DIRECTION"
   }

   if { $mode == 1 } {

      set mom_out_angle_pos($a) $angle

   } elseif { [string match "MAGNITUDE_DETERMINES_DIRECTION" $dirtype] } {

      if { $axis == 3 } {
         set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis) $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis) $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
      }

   } elseif { [string match "SIGN_DETERMINES_DIRECTION" $dirtype] } {

      if { $dir == -1 } {
         if { $axis == 3 } {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif { $dir == 0 } {
         if { $axis == 3 } {
            set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis) $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis) $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
         }
      } elseif { $dir == 1 } {
         set mom_out_angle_pos($a) $ang
      }
   }


  #<04-25-2013 gsl> No clamp code output when rotation is ref only.
   if { ![string compare "OFF" $mom_rotation_reference_mode] } {
      global mom_sys_auto_clamp

      if { [info exists mom_sys_auto_clamp] && [string match "ON" $mom_sys_auto_clamp] } {

         set out1 "1"
         set out2 "0"

         if { $axis == 3 } { ;# Rotate 4th axis
            AUTO_CLAMP_2 $out1
            AUTO_CLAMP_1 $out2
         } else {
            AUTO_CLAMP_1 $out1
            AUTO_CLAMP_2 $out2
         }
      }
   }


   if { $axis == 3 } {

      ####  <rws>
      ####  Use ROTREF switch ON to not output the actual 4th axis move

      if { ![string compare "OFF" $mom_rotation_reference_mode] } {
         PB_CMD_fourth_axis_rotate_move
      }

      if { ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_4th_axis_direction] } {
         set mom_prev_rot_ang_4th [expr abs($mom_out_angle_pos(0))]
      } else {
         set mom_prev_rot_ang_4th $mom_out_angle_pos(0)
      }

      MOM_reload_variable mom_prev_rot_ang_4th

   } else {

      if { [info exists mom_kin_5th_axis_direction] } {

         ####  <rws>
         ####  Use ROTREF switch ON to not output the actual 5th axis move

         if { ![string compare "OFF" $mom_rotation_reference_mode] } {
            PB_CMD_fifth_axis_rotate_move
         }

         if { ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_5th_axis_direction] } {
            set mom_prev_rot_ang_5th [expr abs($mom_out_angle_pos(1))]
         } else {
            set mom_prev_rot_ang_5th $mom_out_angle_pos(1)
         }

         MOM_reload_variable mom_prev_rot_ang_5th
      }
   }

  #<05-10-06 sws> pb351 - Uncommented next 3 lines
  #<01-07-10 wbh> Reset mom_prev_pos using the variable mom_out_angle_pos
  # set mom_prev_pos($axis) $ang
   set mom_prev_pos($axis) $mom_out_angle_pos([expr $axis-3])
   MOM_reload_variable -a mom_prev_pos
   MOM_reload_variable -a mom_out_angle_pos
}


#=============================================================
proc PB_CMD_MOM_text { } {
#=============================================================
# This procedure is executed when the Text command is activated.
#
   global mom_user_defined_text mom_record_fields
   global mom_sys_control_out mom_sys_control_in
   global mom_record_text mom_pprint set mom_Instruction mom_operator_message
   global mom_pprint_defined mom_operator_message_defined

   switch $mom_record_fields(0) {
   "PPRINT"
         {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
         }
   "INSERT"
         {
           set mom_Instruction $mom_record_text
           MOM_insert
         }
   "DISPLY"
         {
           set mom_operator_message_defined 1
           set mom_operator_message $mom_record_text
           MOM_operator_message
         }
   default
         {
           if {[info exists mom_user_defined_text]} {
             MOM_output_literal "${mom_sys_control_out}${mom_user_defined_text}${mom_sys_control_in}"
           }
         }
   }
}


#=============================================================
proc PB_CMD_NPARSE { } {
#=============================================================
# --------------------------
proc NPARSE { input_string startpos index_of_numeric_field }   {
# --------------------------
# returns fff'th numeric out of string of numbers and letters starting at sss'th char

# usage  set returnval   [ NPARSE ttt sss  fff  ]
# where           ttt = text_string to parse
#          sss = starting character pos in string 0 == first char
#        fff = index of numeric field_to_get  0 == first numeric field
#

  set ttt $input_string ; set sss $startpos ; set fff $index_of_numeric_field

  set nums 1234567890.+-            ;# numeric characters
  set s2 ""                    ;# target return string

  if { $sss > 0 } { set ttt [string range $ttt $sss end] } ;# remove unwanted left hand chars

  #  character-by-character in  $text
  set j -1                     ;# no. of numeric fields found-and-begun so far
  set k 0                     ;# am(not) reading numbers right now

  for { set i 0 } { $i < [string length $ttt ] } { incr i }  {

     set ch [ string index $ttt $i ]        ;# get character from string
     if { [ string first $ch $nums]  >= 0 } {    ;# if char is a number
    if { $k == 0 } {            ;# if i wasn't reading numbers
        set k 1                ;# ...then i am now
        incr j                ;# ... the index of the new number-field
    }
    if { $j == $fff }  {            ;# if the index is the one we want
        set s2 $s2$ch            ;# add char to return string
    }
     }  else {
    set k 0                 ;# no nonger numeric
    if { $j == $fff  }  {            ;# index is one we want _and_ nolonger numeric
       break                 ;# out of for-loop - contiguous finished
    }
     } ;# end if numeric
  }    ;# end of for-loop
  if { $s2 == "" } { set s2 "err" }          ;# no numeric string found
  return $s2

} ;# END OF NPARSE
}


#=============================================================
proc PB_CMD_NormalB { } {
#=============================================================
#  to re-zero B axis at end of VARIABLE   path - otherwise NO-OP

global mom_operation_type

if { [string first "Variable" $mom_operation_type ] > -1 } {
# end of VAP or Variable-contour - won't do many revs with Sequential
     PB_CMD_nBwork
}
}


#=============================================================
proc PB_CMD_OPERNAME { } {
#=============================================================


}


#=============================================================
proc PB_CMD_OPST { } {
#=============================================================
global mom_tool_number
global mom_operation_name
global mom_tool_name
#global prev_tool
global cur_tool
#global min_size
global beep
set cur_tool $mom_tool_number
set beep ""
global mom_fixture_offset_value
global mom_operation_type

# MOM_output_literal "($mom_operation_type)"

if {$mom_tool_number < 10} {
set beep "T0"
} else {
set beep "T"
}

PB_CMD_TOOL_CHECK
#MOM_output_literal "\n"
MOM_output_literal "\n( == OPERATION --- $mom_operation_name)"


if {$mom_operation_type != "Mill Machine Control"} {

MOM_output_literal "( == $beep$mom_tool_number == $mom_tool_name)\n"
PB_CMD_SPINDLE_SPEED_ZERO
PB_CMD_SPINDLE_SPEED_MAX

   if { $mom_tool_number <= 0 } {
   MOM_output_literal "( == UNDEFINED TOOL == )"
   }

   if {$mom_fixture_offset_value <= 0} {
   MOM_output_literal "( == UNDEFINED WORK OFFSET == )\n"
   } else {
   MOM_output_literal "G00 G90 G$mom_fixture_offset_value"
   }
}


}


#=============================================================
proc PB_CMD_SPINDLE_SPEED_MAX { } {
#=============================================================
global mom_spindle_speed
global mom_sys_spindle_direction_code
global mom_spindle_direction
global spitout
global trix

set trix [expr int ($mom_spindle_speed)]
if {$mom_spindle_speed > 10000} {
MOM_output_literal "(SPINDLE SPEED DECLARED IS $trix RPM)"
set mom_spindle_speed 10000
MOM_output_literal "(SPINDLE SPEED CORRECTED)"
}
}


#=============================================================
proc PB_CMD_SPINDLE_SPEED_ZERO { } {
#=============================================================
global mom_spindle_speed
global mom_sys_spindle_direction_code
global mom_spindle_direction


if {$mom_spindle_speed == 0} {
MOM_output_literal "M00"
MOM_output_literal "\n(====================)"
MOM_output_literal "( YOU FORGOT TO SET_ )"
MOM_output_literal "( SPINDLE SPEED YOU_ )"
MOM_output_literal "( D--U--M--B--A--S--S)"
MOM_output_literal "(====================)\n"
}
}


#=============================================================
proc PB_CMD_STARTPROC { } {
#=============================================================
#
# Add to start of path procedure
#
global mom_path_name mom_part_material_description
global mom_tool_name mom_oper_method mom_tool_catalog_number
global mom_sys_control_in mom_sys_control_out mom_tool_name
global mom_tool_number
#
# call in the control in & out codes
#
set ci " "
set co " "
if {[info exists mom_sys_control_in] == 1 } { set ci $mom_sys_control_in }
if {[info exists mom_sys_control_out] == 1 } { set co $mom_sys_control_out }
set cat_info "NONE ENTERED"
if {[info exists mom_tool_catalog_number] == 1} {set cat_info\
$mom_tool_catalog_number}
MOM_set_seq_off
MOM_output_literal "$co PATH NAME : [string toupper $mom_path_name]\
WITH TOOL NO: [string toupper $mom_tool_number] $ci"
MOM_output_literal "$co TOOL NAME : [string toupper $mom_tool_name]\
TOOL CATALOG NO. [string toupper $cat_info] $ci"
MOM_output_literal "$co METHOD : [string toupper $mom_oper_method]\
$ci"
MOM_set_seq_on
}


#=============================================================
proc PB_CMD_TOOLCHANGE { } {
#=============================================================
# fixed format - before subsequent toolchange
global js_HON_status  js_superstop_flag  pn_just_toolchanged
if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED OFF ) "
}

set js_HON_status "FALSE"

MOM_output_literal "G91 G28 Z0. "

;# TBD
#MOM_output_literal "M11 "
;# stand trunnion up do_rotary_axes after tc



MOM_output_literal "M09 "
MOM_output_literal "M05 "

if { $js_superstop_flag == 0 } {
    MOM_output_literal "M1 "
} else {
    # conditional delayed inspection stop
    set js_superstop_flag 0

    global mom_superstop_type          ;# stop/opstop
     if {[info exists mom_superstop_type ] } {
        if { $mom_superstop_type == "OPTIONALSTOP"  } {
            MOM_output_literal "M01 "
        } else {
            MOM_output_literal "M00 "
        }
    } else {
        # no type, old ude
        MOM_output_literal "M00 "
    }

    global mom_superstop_text
    if {[info exists mom_superstop_text ] } {
       if { $mom_superstop_text != "" } {
         MOM_output_literal " ( [string toupper $mom_superstop_text ] ) "
       }    ;# end of text not ""
    }     ;# end of info exists superstop_text
}         ;# end of else

MOM_output_literal "   "

set pn_just_toolchanged "TRUE"
}


#=============================================================
proc PB_CMD_TOOL_CHECK { } {
#=============================================================
global mom_tool_number
global mom_tool_name
global mom_tool_diameter
global prev_tool
global cur_tool
global min_size
global tolerance
global prev_tool_size

if {$prev_tool > 0} {
   if {$prev_tool != $cur_tool} {
      if {$prev_tool_size < $min_size} {
      MOM_output_literal "G65 P9853 T$prev_tool B1 H#5"
      }
   }
}
}


#=============================================================
proc PB_CMD_TOOL_INFO { } {
#=============================================================
proc PLM_SD_Save_Tool_Info {} {;# globals omitted for brevity
if {![hiset mom_tool_name]} { return }
set plm_sd_tool_no($mom_tool_name) $mom_tool_number
if {[hiset mom_tool_adjust_register]} {
# this stores ONE value - You will probably want to store
# all values, then sort/ uniqeify in output routine
set plm_sd_tl_adj($mom_tool_name) "$mom_tool_adjust_register"
}
if {[hiset mom_tool_catalog_number]} {
set plm_sd_tl_catno($mom_tool_name) "$mom_tool_catalog_number"
}
if {[hiset mom_attr_TOOL_DESCR]} {
set plm_sd_tool_descr($mom_tool_name) "$mom_attr_TOOL_DESCR"
unset mom_attr_TOOL_DESCR ;#
# clear this variable here
}
}
}


#=============================================================
proc PB_CMD_TOOL_LIST { } {
#=============================================================
############################################
# TOOL LIST OUTPUT AT THE END OF POSTED CODE
############################################

global tix
global tink
global tmax
global dupa


MOM_output_literal "(======== LIST OF TOOLS ========)"

for {set tink 1} {$tink <=$tmax} {incr tink 1} {
if { $tix(2,$tink) != "EMPTY"} {
MOM_output_literal "( $tix(1,$tink) $tix(2,$tink) == $tix(3,$tink) )"
}
}

if {$dupa == 1} {
MOM_output_literal "( TOO LARGE TOOL NUMBER DECLARED )"
}


MOM_output_literal "(======== END OF TOOL LIST ========)"
}


#=============================================================
proc PB_CMD_TST1 { } {
#=============================================================
global mom_sys_lock_status
global mom_sys_lock_axis
global lao
global mom_feed_approach_value
global mom_feed_departure_value


if {$mom_sys_lock_status=="ON"} {
set lao 1

MOM_output_literal "G93 (INVERSE TIME FEED)"
if {$mom_sys_lock_axis==0} {
MOM_output_literal "(X AXIS LOCKED)"
}
if {$mom_sys_lock_axis==1} {
MOM_output_literal "(Y AXIS LOCKED)"
}
if {$mom_sys_lock_axis==2} {
MOM_output_literal "(Z AXIS LOCKED)"
}
if {$mom_sys_lock_axis==3} {
MOM_output_literal "(A AXIS LOCKED)"
}
if {$mom_sys_lock_axis==4} {
MOM_output_literal "(B AXIS LOCKED)"
}

if {$mom_feed_approach_value==0.00000000000000000} {
set mom_feed_approach_value 500.00000000000000000
}
if {$mom_feed_departure_value==0.00000000000000000} {
set mom_feed_departure_value 500.00000000000000000
}

#MOM_output_literal "($mom_feed_approach_value)"
#MOM_output_literal "($mom_feed_departure_value)"

} else {
set lao 0
}
}


#=============================================================
proc PB_CMD_TST2 { } {
#=============================================================
global lao

if {$lao==1} {
MOM_output_literal "G94 (BACK TO IPM FEEDS)"
}
set lao 0
}


#=============================================================
proc PB_CMD_TST3 { } {
#=============================================================
global mom_sys_lock_status
global lao

if {$mom_sys_lock_status=="ON"} {
set lao 1
}
if {$mom_sys_lock_status=="OFF"} {
set lao 0
}
}


#=============================================================
proc PB_CMD__combine_rotary_check { } {
#=============================================================
# Combine consecutive rotary moves
#
#
# These custom commands will allow you to combine consecutive
# rotary moves into a single move when there is no change in
# X, Y and Z.
#
# ==> This function will only work in NX3 or later.
#
# - Add PB_CMD__combine_rotary_init to Start of Program marker
# - Add PB_CMD__combine_rotary_output to Linear Move event before output block
# - Call PB_CMD__combine_rotary_check in custom command PB_CMD_before_motion
#
# The combining of blocks will terminate when the rotary axis
# being combined reverses or the total number of degrees of
# the combined rotary move would have exceeded 180 degrees.
#
# The current linear move will be suppressed if the current and the
# next motion are either CUT or FIRSTCUT and both are linear
# moves.
#
#-------------------------------------------------------------
# 27-Jul-2010 gsl - Added comments and rewrote by removing
#                   the need of "format" commands, number of
#                   decimal places and some funny logics
# 30-Apr-2013 gsl - Added use of ROUND (ugpost_base)
# 13-Jun-2013 gsl - Preserve or recompute feedrate when moves are combined
#

   # Skip execution, if function of combining rotary moves is not activated.
   #
    global mom_sys_combine_rotary_mode
    if { ![info exists mom_sys_combine_rotary_mode] } {
return
    }


   # This command should be called by PB_CMD_before_motion
   #
    if { [string compare "PB_CMD_before_motion" [info level -1]] } {
return
    }


    global mom_sys_skip_move

    global mom_nxt_pos
    global mom_pos
    global mom_prev_pos
    global mom_nxt_motion_type
    global mom_motion_type

    global prev_4th_output
    global prev_5th_output
    global last_4th_output
    global last_5th_output
    global last_4th_dir
    global last_5th_dir


    set mom_sys_skip_move "NO"


   # Read-ahead must be enabled
   #
    if { [info exists mom_nxt_pos] && [info exists mom_nxt_motion_type] } {

        global mom_kin_machine_resolution
        global mom_kin_4th_axis_min_incr
        global mom_kin_5th_axis_min_incr

        set tolm $mom_kin_machine_resolution
        set tol4 $mom_kin_4th_axis_min_incr
        set tol5 $mom_kin_5th_axis_min_incr

       # Initialize previous position
        if { ![info exists prev_4th_output] } { set prev_4th_output [ROUND $mom_pos(3) $tol4] }
        if { ![info exists prev_5th_output] } { set prev_5th_output [ROUND $mom_pos(4) $tol5] }

       # Retain previous position
        set P4 $prev_4th_output
        set P5 $prev_5th_output

        set prev_4th_output [ROUND $mom_pos(3) $tol4]
        set prev_5th_output [ROUND $mom_pos(4) $tol5]

       # Initialize last position
        if { ![info exists last_4th_output] } { set last_4th_output $P4 }
        if { ![info exists last_5th_output] } { set last_5th_output $P5 }

       # Initialize last direction indicator
        if { ![info exists last_4th_dir] } { set last_4th_dir 0 }
        if { ![info exists last_5th_dir] } { set last_5th_dir 0 }


        set PX [ROUND $mom_prev_pos(0) $tolm]
        set PY [ROUND $mom_prev_pos(1) $tolm]
        set PZ [ROUND $mom_prev_pos(2) $tolm]

        set NX [ROUND $mom_nxt_pos(0) $tolm]
        set NY [ROUND $mom_nxt_pos(1) $tolm]
        set NZ [ROUND $mom_nxt_pos(2) $tolm]

        set N4 [ROUND $mom_nxt_pos(3) $tol4]
        set N5 [ROUND $mom_nxt_pos(4) $tol5]

        set CX [ROUND $mom_pos(0) $tolm]
        set CY [ROUND $mom_pos(1) $tolm]
        set CZ [ROUND $mom_pos(2) $tolm]

        set C4 [ROUND $mom_pos(3) $tol4]
        set C5 [ROUND $mom_pos(4) $tol5]

        set D4 [expr $C4 - $P4]

        if [EQ_is_equal $D4 0] {
            set cur_4th_dir 0
        } elseif { ([EQ_is_gt $D4 -180] && [EQ_is_lt $D4 0]) || [EQ_is_gt $D4 180] } {
            set cur_4th_dir -1
        } else {
            set cur_4th_dir 1
        }

        set T4 [expr $N4 - $last_4th_output]

        if [EQ_is_equal $T4 0] {
            set tot_4th_dir 0
        } elseif { ([EQ_is_gt $T4 -180] && [EQ_is_lt $T4 0]) || [EQ_is_gt $T4 180] } {
            set tot_4th_dir -1
        } else {
            set tot_4th_dir 1
        }

        if { [EQ_is_lt [expr $cur_4th_dir * $last_4th_dir] 0] ||\
             [EQ_is_lt [expr $cur_4th_dir * $tot_4th_dir] 0] } {
            set switch_dir_4th "YES"
        } else {
            set switch_dir_4th "NO"
        }

        set D5 [expr $C5 - $P5]

        if [EQ_is_equal $D5 0] {
            set cur_5th_dir 0
        } elseif { ([EQ_is_gt $D5 -180] && [EQ_is_lt $D5 0]) || [EQ_is_gt $D5 180] } {
            set cur_5th_dir -1
        } else {
            set cur_5th_dir 1
        }

        set T5 [expr $N5 - $last_5th_output]

        if [EQ_is_equal $T5 0] {
            set tot_5th_dir 0
        } elseif { ([EQ_is_gt $T5 -180] && [EQ_is_lt $T5 0]) || [EQ_is_gt $T5 180] } {
            set tot_5th_dir -1
        } else {
            set tot_5th_dir 1
        }

        if { [EQ_is_lt [expr $cur_5th_dir * $last_5th_dir] 0] ||\
             [EQ_is_lt [expr $cur_5th_dir * $tot_5th_dir] 0] } {
            set switch_dir_5th "YES"
        } else {
            set switch_dir_5th "NO"
        }


        set tol [expr 0.501*$mom_kin_machine_resolution]

        if { (![string compare "CUT"      $mom_motion_type] && ![string compare "CUT"      $mom_nxt_motion_type]) ||\
             (![string compare "FIRSTCUT" $mom_motion_type] && ![string compare "FIRSTCUT" $mom_nxt_motion_type]) ||\
             (![string compare "STEPOVER" $mom_motion_type] && ![string compare "STEPOVER" $mom_nxt_motion_type]) } {

            if { [EQ_is_equal $PX $CX] && [EQ_is_equal $PY $CY] && [EQ_is_equal $PZ $CZ] &&\
                 [EQ_is_equal $NX $CX] && [EQ_is_equal $NY $CY] && [EQ_is_equal $NZ $CZ] } {

                if {![EQ_is_equal $P4 $C4] && [EQ_is_equal $P5 $C5] &&\
                    ![EQ_is_equal $N4 $C4] && [EQ_is_equal $N5 $C5] &&\
                     $mom_sys_combine_rotary_mode != 5 && ![string compare "NO" $switch_dir_4th] } {

                    set mom_sys_skip_move "YES"
                    MOM_force once fourth_axis
                    set mom_sys_combine_rotary_mode "4"

                } elseif\
                   { [EQ_is_equal $P4 $C4] && ![EQ_is_equal $P5 $C5] &&\
                     [EQ_is_equal $N4 $C4] && ![EQ_is_equal $N5 $C5] &&\
                     $mom_sys_combine_rotary_mode != 4 && ![string compare "NO" $switch_dir_5th] } {

                    set mom_sys_skip_move "YES"
                    MOM_force once fifth_axis
                    set mom_sys_combine_rotary_mode "5"
                }
            }
        }


       # Skip next output -
       # Preserve current feedrate
        global mom_user_combined_rotary_feed feed
        global mom_sys_contour_feed_mode

        if { ![string compare $mom_sys_skip_move "YES"] } {

          # Recompute feedrate, if it's FRN
           if { [string match "FRN" $mom_sys_contour_feed_mode(ROTARY)] } {
              if { ![info exists mom_user_combined_rotary_feed] } {
                 set mom_user_combined_rotary_feed 0.0
              }

              set mom_user_combined_rotary_feed \
                  [expr $mom_user_combined_rotary_feed*$feed / ($mom_user_combined_rotary_feed+$feed)]

           } else {
              if { ![info exists mom_user_combined_rotary_feed] } {
                 set mom_user_combined_rotary_feed $feed
              }
           }
return
        }

        if { [info exists mom_user_combined_rotary_feed] } {
           set feed $mom_user_combined_rotary_feed
           unset mom_user_combined_rotary_feed
        }

        set mom_sys_combine_rotary_mode "1"

        set last_4th_output $C4
        set last_5th_output $C5
        set last_4th_dir $cur_4th_dir
        set last_5th_dir $cur_5th_dir
    }
}


#=============================================================
proc PB_CMD__combine_rotary_init { } {
#=============================================================
# This command should only be called in "Start of Program"
#
#-------------------------------------------------------------
# 06-May-2013 gsl - Added ROUND, if not present, to work with older NX/Post
#

# ==> Uncomment next statement to disable the combine-rotary function
# return


   # This command should be called by PB_start_of_program
   #
    if { ![CALLED_BY "PB_start_of_program"] } {
return
    }


   # Function of combining rotary moves can only be used when
   # "MOM_abort_event" is available (NX3 & up).
   #
    if { ![CMD_EXIST MOM_abort_event] } {
        CATCH_WARNING "MOM_abort_event is an invalid command.  You must use NX3 or later."
return
    }



   #<04-30-2013 gsl> This version only works when ROUND command is available.
   #
    if ![CMD_EXIST ROUND] {

    uplevel #0 {
       #===============================================================================
       proc ROUND { value {resol 1} } {
       #===============================================================================
       # This command rounds off a number by the given output resolution.
       # When the resolution is not specified, it rounds the number to an integer.
       #
       #<04-24-2013 gsl> Initial implementation
       #
          set ret_val $value

          # Perform regular rounding when output resolution is "1".
          if { [EQ_is_equal $resol 1] } \
          {
             return [expr round( $value )]
          }

          # When the output resolution is near "0", the original value is returned.
          if { ![EQ_is_zero $resol] } \
          {
              if [EQ_is_zero $value] \
              {
                 set ret_val 0.0

              } else \
              {
                 set sign 1

                 set x [expr $value / $resol]

                 # Either value or resol can be negative; and that will cause x to be negative.
                 if [expr $x < 0.0] \
                 {
                    set sign -1
                 }

                 # To compensate for the loss of floating point accuracy
                 set x [expr floor( abs($x) + 0.501 )]

                 set ret_val [expr $sign * $x * $resol]
              }
           }

           return $ret_val
       }

    } ;# uplevel
    }



   # Clear possible residual
    global mom_sys_combine_rotary_mode mom_sys_skip_move

    if { [info exists mom_sys_combine_rotary_mode] } {
        unset mom_sys_combine_rotary_mode
    }

    if { [info exists mom_sys_skip_move] } {
        unset mom_sys_skip_move
    }


   # Enable combining rotary moves with read-ahead function
   #
    global mom_kin_read_ahead_next_motion

    set mom_sys_combine_rotary_mode     "1"
    set mom_kin_read_ahead_next_motion  "TRUE"

    MOM_reload_kinematics
}


#=============================================================
proc PB_CMD__combine_rotary_output { } {
#=============================================================
# This command should be called by Linear Move event to skip the output
# when consecutive rotary moves can be combined.
#

   # Skip execution, if function of combining rotary moves is not activated.
   #
    global mom_sys_combine_rotary_mode
    if { ![info exists mom_sys_combine_rotary_mode] } {
return
    }


   # This command should be called by MOM_linear_move
   #
    if { ![CALLED_BY "MOM_linear_move"] } {
return
    }


   # Flag set in PB_CMD__combine_rotary_check to tell if next block should be combined.
   #
    global mom_sys_skip_move

   # Need to skip output, exchange the end point info then abort
   #
    if { ![string compare $mom_sys_skip_move "YES"] } {

        global mom_pos mom_prev_pos
        global mom_mcs_goto mom_prev_mcs_goto

        VMOV 5 mom_prev_pos mom_pos
        VMOV 3 mom_prev_mcs_goto mom_mcs_goto

        MOM_reload_variable -a mom_pos
        MOM_reload_variable -a mom_mcs_goto

        MOM_abort_event
    }
}


#=============================================================
proc PB_CMD__log_revisions { } {
#=============================================================
# Dummy command to log changes in this post --
#
# 02-26-09 gsl - Initial version
#
}


#=============================================================
proc PB_CMD__manage_part_attributes { } {
#=============================================================
# This command allows the user to manage the MOM variables
# generated for the part attributes, in case of conflicts.
#
# ==> This command is executed automatically when present in
#     the post. DO NOT add or call it in any event or command.
#

  # This command should only be called by MOM__part_attributes!
   if { ![CALLED_BY "MOM__part_attributes"] } {
return
   }

}


#=============================================================
proc PB_CMD_abort_event { } {
#=============================================================
# This command can be called to abort an event based on the
# flag being set by other handler under certain conditions,
# such as an invalid tool axis vector.
#
# Users can set the global variable mom_sys_abort_next_event to
# different severity levels throughout the post and designate
# how to handle different conditions in this command.
#
# - Rapid, linear, circular and cycle move events have this trigger
#   built in by default in PB6.0.
#

   global mom_sys_abort_next_event

   if { [info exists mom_sys_abort_next_evnet] } {

      switch $mom_sys_abort_next_evnet {
        1 -
        2 {
           unset mom_sys_abort_next_evnet
           CATCH_WARNING "Event aborted!"

           MOM_abort_event
        }
        default {
           CATCH_WARNING "Event warned!"
        }
      }
   }
}


#=============================================================
proc PB_CMD_ask_machine_type { } {
#=============================================================
# Utility to return machine type per mom_kin_machine_type
#
# Revisions:
#-----------
# 02-26-09 gsl - Initial version
#
   global mom_kin_machine_type

   if { [string match "*wedm*" $mom_kin_machine_type] } {
return WEDM
   } elseif { [string match "*axis*" $mom_kin_machine_type] } {
return MILL
   } elseif { [string match "*lathe*" $mom_kin_machine_type] } {
return TURN
   } else {
return $mom_kin_machine_type
   }
}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
PB_CMD__combine_rotary_check
}


#=============================================================
proc PB_CMD_before_output { } {
#=============================================================
# This command allows users to massage the NC data (mom_o_buffer) before
# it finally gets output.  If present in the post, this command gets executed
# by MOM_before_output automatically.
#
# - DO NOT overload MOM_before_output! All customization should be done here!
# - DO NOT call any MOM output commands in this command, it will become cyclicle!
# - No need to attach this command to any event marker.
#

   global mom_o_buffer
   global mom_sys_leader
   global mom_sys_control_out mom_sys_control_in
}


#=============================================================
proc PB_CMD_beforetoolchange { } {
#=============================================================
# fixed format - before subsequent toolchange
global js_HON_status  js_superstop_flag  pn_just_toolchanged
if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED OFF ) "
    MOM_output_literal "G187 "
}

set js_HON_status "FALSE"

MOM_output_literal "G91 G28 Z0. "

;# TBD
#MOM_output_literal "M11 "
;# stand trunnion up do_rotary_axes after tc



MOM_output_literal "M09 "
MOM_output_literal "M05 "

if { $js_superstop_flag == 0 } {
    MOM_output_literal "M1 "
} else {
    # conditional delayed inspection stop
    set js_superstop_flag 0

    global mom_superstop_type          ;# stop/opstop
     if {[info exists mom_superstop_type ] } {
        if { $mom_superstop_type == "OPTIONALSTOP"  } {
            MOM_output_literal "M01 "
        } else {
            MOM_output_literal "M00 "
        }
    } else {
        # no type, old ude
        MOM_output_literal "M00 "
    }

    global mom_superstop_text
    if {[info exists mom_superstop_text ] } {
       if { $mom_superstop_text != "" } {
         MOM_output_literal " ( [string toupper $mom_superstop_text ] ) "
       }    ;# end of text not ""
    }     ;# end of info exists superstop_text
}         ;# end of else

MOM_output_literal "   "

set pn_just_toolchanged "TRUE"
}


#=============================================================
proc PB_CMD_changeHON { } {
#=============================================================
# this allows user to change HON <-> HOF <-> HON using UDE away from t/change

global js_HON_status js_HON_waiting mom_HighSpeed   mom_operation_type

set js_HON_waiting "FALSE"    ;# flag to trigger HON/HOF codes at start of next op.

if {$mom_HighSpeed == "OFF" && $js_HON_status == "TRUE"} { ;# Currently-on, but UDE off
    set js_HON_waiting "TRUE"
}

if {$mom_HighSpeed == "ON" && $js_HON_status == "FALSE"} {  ;# currently OFF but UDE on ( or default )
    if {[ string first "Point to Point" $mom_operation_type ] < 0 } { ;# AND Milling operation
    set js_HON_waiting "TRUE"
    }
}
}


#=============================================================
proc PB_CMD_clamp_fifth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to clamp the fifth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
  MOM_output_literal "M12"
}


#=============================================================
proc PB_CMD_clamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to clamp the fourth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
  MOM_output_literal "M10"
}


#=============================================================
proc PB_CMD_conditional_HON { } {
#=============================================================
global js_HON_status js_HON_waiting mom_HighSpeed

if { $js_HON_waiting == "TRUE" } {     ;# if just toolchanged

    if { $mom_HighSpeed == "OFF" } {     ;# only if disabled from UDE
     if {  $js_HON_status == "TRUE" } {
      MOM_output_literal "  ( HIGH SPEED OFF ) "
          MOM_output_literal "G187 "   ;# for haas set to default
           }
    set js_HON_status "FALSE"
    } else {
    MOM_output_literal "  ( HIGH SPEED MACHINING ON ) "
        MOM_output_literal "G187 E.05  "   ;# for haas set high speed accuracy


    set js_HON_status "TRUE"
    }
}

set js_HON_waiting "FALSE"
}


#=============================================================
proc PB_CMD_conditional_forceF { } {
#=============================================================
global feed_mode
#   needs F on every block if G93

if { $feed_mode == "FRN" } { MOM_force once F }
}


#=============================================================
proc PB_CMD_conditional_unclamp { } {
#=============================================================
# unclamp rotary axes if reqd, ie. if multax-ing


global mom_out_angle_pos
global js_lastB js_lastA

set indexflag 0                            ;# default dont unclamp

if {![info exists js_lastB] } { set js_lastB -999 }
if {![info exists js_lastA] } { set js_lastA -999 }

if { $js_lastA != $mom_out_angle_pos(0) } { set indexflag 1 }    ;# index if changed
if { $js_lastB != $mom_out_angle_pos(1) } { set indexflag 1 }

if { $indexflag } {
   #MOM_do_template AClampOff    ;#    M11
   #MOM_do_template BClampOff    ;#    M13
 }
}


#=============================================================
proc PB_CMD_coordinate_offset { } {
#=============================================================
#
# custom command to output a G54 thru G59 coordinate
# offset
#
uplevel #0 {
proc MOM_csys_load { } {
global mom_csys_register
MOM_output_literal "G$mom_csys_register"
}
}
}


#=============================================================
proc PB_CMD_create_tool_list { } {
#=============================================================
#  Place this custom command in either the start of program
#  or the end of program event marker to generate a tool list
#  in your NC file.
#
#  The Shop Doc template file "pb_post_tool_list.tpl" distributed with
#  Post Builder in "POSTBUILD/pblib/misc" directory can be copied
#  to the "mach/resource/postprocessor" or "mach/resource/shop_docs" directory,
#  in case that your UG runtime environment does not have access to the
#  Post Builder installation.
#
#  Accessing "pb_post_tool_list.tpl" in other location can also be accomplished
#  by changing the code below titled "Generate tool list data" in this proc.
#
#  The variable "mom_sys_tool_list_output_type" set in this proc allows you
#  to select the type of tool list to be generated.
#  The options are:
#
#    "ORDER_IN_USE"     - List tools used in the program in the order of operations.
#    "ALL_UNIQUE"       - List all unique tools once for each in the order of use.
#    "GROUP_BY_TYPE"    - List tools in groups of different tool types.
#
#  The desired tool list type can be set by changing the code below.
#  The default is set to "GROUP_BY_TYPE".
#

   global mom_sys_tool_list_initialized
   global mom_sys_tool_list_output_type


   if { ![info exists mom_sys_tool_list_initialized] || !$mom_sys_tool_list_initialized } {
      MOM_output_to_listing_device "proc PB_CMD_init_tool_list must be executed in the\
                                    Start of Program before PB_CMD_create_tool_list is called."
return
   }


  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  # Set mom_sys_tool_list_output_type to the desired output fashion.
  #
  #   "ORDER_IN_USE"     - List tools used in the program in the order of operations.
  #   "ALL_UNIQUE"       - List all unique tools once for each in the order of use.
  #   "GROUP_BY_TYPE"    - List tools in groups of different tool types.
  #
  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  # set mom_sys_tool_list_output_type "ORDER_IN_USE"
  # set mom_sys_tool_list_output_type "ALL_UNIQUE"
   set mom_sys_tool_list_output_type "GROUP_BY_TYPE"


   global mom_sys_control_out mom_sys_control_in
   global current_program_name
   global mom_tool_number mom_tool_length_adjust_register mom_tool_name


  #----------------------------------------------------------------------------
  # Save info for the currently active tool in the program being post-prcessed
  # before starting Shop Doc mechanism for tool list generation.
  #----------------------------------------------------------------------------
   if [llength [info commands PB_CMD_save_active_oper_tool_data] ] {
      PB_CMD_save_active_oper_tool_data
   }


  #-----------------------------------------------------------
  # Create tool list per selected top-level group.
  # Group name is set to blank if no group has been selected.
  #-----------------------------------------------------------
   global mom_parent_group_name

   if [info exists mom_parent_group_name] {
      set current_program_name $mom_parent_group_name
   } else {
      set current_program_name ""
   }


   set ci " "
   set co " "

   if [info exists mom_sys_control_in] { set ci $mom_sys_control_in }
   if [info exists mom_sys_control_out] { set co $mom_sys_control_out }


  #*************************
  # Generate tool list data
  #*************************
   set template_file pb_post_tool_list.tpl

   global tcl_platform
   if [string match "windows" $tcl_platform(platform)] {
      set pb_lib_misc_dir [MOM_ask_env_var UGII_BASE_DIR]\\postbuild\\pblib\\misc\\
   } else {
      set pb_lib_misc_dir [MOM_ask_env_var UGII_BASE_DIR]/postbuild/pblib/misc/
   }

   set cam_post_dir     [MOM_ask_env_var UGII_CAM_POST_DIR]
   set cam_shop_doc_dir [MOM_ask_env_var UGII_CAM_SHOP_DOC_DIR]

   if { [file exists ${pb_lib_misc_dir}${template_file}] } {

      MOM_do_template_file ${pb_lib_misc_dir}${template_file}

   } elseif { [file exists ${cam_post_dir}${template_file}] } {

      MOM_do_template_file ${cam_post_dir}${template_file}

   } elseif { [file exists ${cam_shop_doc_dir}${template_file}] } {

      MOM_do_template_file ${cam_shop_doc_dir}${template_file}

   } else {

      MOM_output_to_listing_device \
         "ERROR : Template file $template_file is not found in the following directories:\
          \n\
          \n          $pb_lib_misc_dir\
          \n          $cam_post_dir\
          \n          $cam_shop_doc_dir\
          \n\
          \n        Tool list cannot be generated.\n"
return
   }



  #------------------
  # Tool list header
  #------------------
   shop_doc_output_literal "$co===============================================================================================$ci"
   shop_doc_output_literal "$co                                   T O O L   L I S T                                           $ci"
   shop_doc_output_literal "$co===============================================================================================$ci"


  #------------------
  # Output tool list
  #------------------
   global tool_data_buffer
   global mom_sys_tool_stack

   switch $mom_sys_tool_list_output_type {

      "ORDER_IN_USE" {
         set tool_list $mom_sys_tool_stack(IN_USE)
      }

      "GROUP_BY_TYPE" {
         set tool_list [concat $mom_sys_tool_stack(LATHE) \
                               $mom_sys_tool_stack(DRILL) \
                               $mom_sys_tool_stack(MILL)]
      }

      default {
         set tool_list $mom_sys_tool_stack(ALL)
      }
   }


   set prev_tool_type ""

   foreach tool $tool_list {

      set tool_type $tool_data_buffer($tool,type)

     # Output tool type header if it changes.
      if { ![string match "$tool_type" $prev_tool_type] } {
         if { [info exists tool_data_buffer($tool_type,header)] && \
              [string length $tool_data_buffer($tool_type,header)] != 0 } {
            shop_doc_output_literal "$tool_data_buffer($tool_type,header)"
         }
      }

      if [info exists tool_data_buffer($tool,output)] {
         shop_doc_output_literal "$tool_data_buffer($tool,output)"
      }
      set prev_tool_type $tool_type
   }



  #------------------
  # Tool list footer
  #------------------
   shop_doc_output_literal "$co===============================================================================================$ci"


  #-------------------------------------------------------------------------------
  # Restore info for the currently active tool in the program being post-prcessed.
  #-------------------------------------------------------------------------------
   if [llength [info commands PB_CMD_restore_active_oper_tool_data] ] {
      PB_CMD_restore_active_oper_tool_data
   }
}


#=============================================================
proc PB_CMD_custom_command { } {
#=============================================================
once G_adjust H S
}


#=============================================================
proc PB_CMD_custom_command_1 { } {
#=============================================================
once G_cycle F
}


#=============================================================
proc PB_CMD_custom_command_2 { } {
#=============================================================
MOM_force once F
}


#=============================================================
proc PB_CMD_custom_command_3 { } {
#=============================================================
MOM_force once F
}


#=============================================================
proc PB_CMD_custom_command_4 { } {
#=============================================================
MOM_force once F
}


#=============================================================
proc PB_CMD_custom_command_5 { } {
#=============================================================
once G_motion F
}


#=============================================================
proc PB_CMD_custom_command_6 { } {
#=============================================================
MOM_force once G_motion F
}


#=============================================================
proc PB_CMD_custom_command_7 { } {
#=============================================================
MOM_force once G_motion F
}


#=============================================================
proc PB_CMD_cycle_nanny { } {
#=============================================================
global mom_cycle_retract_mode            ;# AUTO or MANUAL
global mom_clearance_plane_usage        ;# 1 == start and end
global mom_clearance_plane_status        ;# 1 == defined and active
global mom_operation_name
global mom_cycle_cam

set alarm 0
set em "\n\n Operation : $mom_operation_name  \n\n  "

if { $mom_cycle_retract_mode != "AUTO" } {
    incr alarm
    set tt "\n\n RTCTO Mode not set to AUTO \n\n "
     set em $em$tt
   }

if { $mom_clearance_plane_status != 1 } {
    incr alarm
    set tt "\n\n Clearance Plane not Defined and Active \n\n "
     set em $em$tt
   }

if { $mom_clearance_plane_usage != 1 } {
    incr alarm
    set tt "\n\n Clearance Plane not set to Start and End \n\n "
     set em $em$tt
   }


if {[ info exists mom_cycle_cam ]} {
   if { $mom_cycle_cam > 0 } {
        incr alarm
        set tt "\n\n Illegal CAM setting in canned cycle \n Set Spindle Speed on Feedrate Dialog \n\n "
         set em $em$tt
       }
    }

if { $alarm > 0 } { MOM_abort $em }
}


#=============================================================
proc PB_CMD_do_rotary_axes { } {
#=============================================================
# index rotary axes if reqd, retract first, restate TLO after
# this deliberately moves both axes - even if only one has moved
# called from rapid move

global mom_out_angle_pos
global js_lastB js_lastA
global mom_SafeIndex
global js_safe_once_count

set indexflag 0                    ;# default dont index

global just_indexed    ;# for emergency fix in conditional Z

if {![info exists js_lastA] } { set js_lastA -9999 }
if {![info exists js_lastB] } { set js_lastB -9999 }

if { $js_lastA != $mom_out_angle_pos(0) } { set indexflag 1 }    ;# index if A changed
if { $js_lastB != $mom_out_angle_pos(1) } { set indexflag 1 }

# ###################### version 0.1 ###################################
#        default is safe index. non-default was not safe index

if { $mom_SafeIndex == "ON" } {        ;# UDE can suppress safe index for 5x
  if { $indexflag == 1 } {

   MOM_force once fourth_axis fifth_axis

   PB_CMD_gohomeZonly            ;# set of retracts

   MOM_output_literal "  "
   MOM_output_literal "( TABLE INDEX ) "

   MOM_force once MA MB            ;#  ensure it really unclamps
   #MOM_do_template AClampOff        ;#  "M11"
   #MOM_do_template BClampOff        ;#  "M13"

   MOM_do_template AandBaxis

   #MOM_do_template BClampOn            ;#  "M12"
   #MOM_do_template AClampOn            ;#  "M10"
   MOM_output_literal "   "

   MOM_force once Z G_motion         ;# force out Z after index on next rapid
   set just_indexed 1
  }
}

# ###################### version 0.2 ###################################
#   ude == safe index OFF   make safe index first time after UDE or toolchange

if { $mom_SafeIndex == "OFF" } {    ;# UDE can suppress safe index for 5x

   if {![hiset js_safe_once_count ] } { set js_safe_once_count 0 } ;# _should_ be 0 after toolchange
   incr js_safe_once_count

   if { $js_safe_once_count == 1 } {
      if { $indexflag } {

        MOM_force once fourth_axis fifth_axis G
    MOM_output_literal "  "
        MOM_output_literal "( *** SAFE INDEX ONCE ONLY *** ) "

    PB_CMD_gohomeZonly

        MOM_output_literal "  "
       MOM_output_literal "( TABLE INDEX ) "

       #MOM_do_template AClampOff        ;#  "M11"
       #MOM_do_template BClampOff        ;#  "M13"

      MOM_force once MA MB            ;#  ensure it really unclamps
       MOM_do_template AandBaxis

       #MOM_do_template BClampOn            ;#  "M12"
       #MOM_do_template AClampOn            ;#  "M10"
       MOM_output_literal "   "

    MOM_force once Z G_motion        ;# force out Z
    set just_indexed 1
      }
  }
}

# ######################## end v1.5 #####################################

 #MOM_output_literal " do_rotary_axes proc end.."
 #MOM_output_literal "   "
}


#=============================================================
proc PB_CMD_drill_text { } {
#=============================================================
# MOM_output_literal "  PB_CMD_drill_text called   "
# called via handler from MOM_drill_text event
# this parses up string which looks like
#    INNER_ddd_hhhh_nnn_S_sss_X_xxx    # INNER OR OUTER

set bigerr        "\n *  INNER_ddd_hhhh_nnn_S_sss_X_xxx     INNER OR OUTER  "
set bigerr " $bigerr \n *     ddd is dia    "
set bigerr " $bigerr \n *     hhh is LEFT or RIGHT or R or L          ( default Right )"
set bigerr " $bigerr \n *     nnn is number of helix laps           ( default 2 ) "
set bigerr " $bigerr \n *     sss is value of stock to come off              ( default 0 ) "
set bigerr " $bigerr \n *     xxx is no. addit. passes on side of thread  ( default 0 ) "
set bigerr " $bigerr \n *  "
set bigerr " $bigerr \n *   Eg: IN_12.345_R_3_S_0.25_X_3  \n\n "

#
global mom_cycle_text mom_tool_type mom_tool_pitch mom_operation_name
global mom_prev_pos ZretBetweenHoles
global pn_tm_type
global mom_tool_diameter mom_tool_pitch
# "return variables"
global pn_threadmill_dia pn_thread_left pn_thread_pitches pn_threadmill_stock pn_threadmill_r_passes

set    ZretBetweenHoles $mom_prev_pos(2)        ;# used later drill_text_move

# sanity check text string

set err " \n \n  **** wrong text $mom_cycle_text ****\n\n**** must be IN or OUT ****\n "
set err " $err $bigerr "
set eflag 1
set pn_tm_type INNER
set test IN
if { [ string first $test $mom_cycle_text ] >=0 } { set eflag 0 }
set test OUT
if { [ string first $test $mom_cycle_text ] >=0 } { set eflag 0 ; set pn_tm_type OUTER }

if { $eflag == 1 } { MOM_abort $err }

if { $mom_tool_type != "Thread Mill" } {
set err " \n \n  **** threadmill attempted with wrong tool type ****\n**** must be THREAD MILL ****\n \n "
MOM_abort $err
}

# diameter #
set pn_threadmill_dia  [ NPARSE  $mom_cycle_text 0 0 ] ;# get first number

if { $pn_threadmill_dia  == "err" } {
        set err " \n \n  **** no diameter specified wrong text $mom_cycle_text  ****\n\n**** expected IN_12.345_R_3_S_0.25_X_3 **** \n **** where 9.876 is hole dia **** \n \n "
    set err " $err $bigerr "
    MOM_abort $err
}

set min "-"
if { [ string first $min $pn_threadmill_dia ]  >= 0 } {    ;# if negative sign
      set err " \n \n  **** Negative diameter $mom_cycle_text  ****\n**** expected IN_9.876_RIGHT_3 **** \n **** where 9.876 is hole dia **** \n \n "
      set err " $err $bigerr "
      MOM_abort $err
}

# hand of thread #
set  pn_thread_left 0    ;# NOT Left Hand ie. default Right Hand Thread
if { [ string first L  $mom_cycle_text ]  >= 0 } { set pn_thread_left 1 }

# number of pitches of helix #
set pn_thread_pitches  [ NPARSE  $mom_cycle_text 0 1 ]         ;# get 2ND number 1==2 in tcl <sigh>
if { $pn_thread_pitches == "err" } { set pn_thread_pitches 2 }     ;# default to 2 pitches-of-helix
if { $pn_thread_pitches <=0 } { set pn_thread_pitches 2 }     ;# not zero pitches-of-helix
set pn_thread_pitches [ expr int($pn_thread_pitches) ]         ;# force integer

# side stock #
set ss [ string first  S $mom_cycle_text ] ;# if string contains S for Stock
if { $ss >= 0 } {
    set pn_threadmill_stock [ NPARSE $mom_cycle_text $ss 0 ] ;#  user specified stock
} else {
    set pn_threadmill_stock  0             ;# default to zero stock ( == 1pass ) cut up thread
}

# no of rough-passes for thread #
set ss [ string first  X $mom_cycle_text ]     ;# if string contains X for TIMES
if { $ss >= 0 } {
    set pn_threadmill_r_passes [ NPARSE $mom_cycle_text $ss 0 ] ;#  user specified NO OF PASSES
} else {
    set pn_threadmill_r_passes  0         ;# default to zero rough passes ( == 1pass ) cut up thread
}
set  pn_threadmill_r_passes [ expr int($pn_threadmill_r_passes) ] ;# integer

MOM_output_literal " ( THREADMILL CYCLE FROM CYCLE TEXT $mom_cycle_text ) "
MOM_output_literal " ( DIAMETER $pn_threadmill_dia ) "
if { $pn_thread_left } {
    MOM_output_literal " ( LEFT HAND THREAD ) "
} else {
     MOM_output_literal " ( RIGHT HAND THREAD ) "
}
set inc [expr int($pn_thread_pitches) ]
MOM_output_literal " ( NUMBER OF LAPS IS  $inc ) "

MOM_output_literal " ( SIDE STOCK IS  $pn_threadmill_stock ) "
MOM_output_literal " ( NO OF ROUGH PASSES  $pn_threadmill_r_passes ) "

# V0.5 safety
set d [format  "%.3f" $mom_tool_diameter ]
set p [format  "%.3f" $mom_tool_pitch ]
MOM_output_literal " ( USING $d DIA TOOL WITH  $p PITCH ) "

if { $pn_tm_type == "OUTER" } { return }
# for INNER - check there's room  tool - given dia, pitch, and sidestock
  set min   $pn_threadmill_dia                 ;# begin
  set min [ expr $min - 2 * $pn_threadmill_stock ]    ;# sidestock
# set min [ expr $min - 2 * 0.6 * $mom_tool_pitch ]    ;# OFTEN _ISN'T_ room for pitch

if { $min < $mom_tool_diameter }  {
   set p  [ format  "%.3f" [ expr 0.6 * $mom_tool_pitch ]]
   set td [ format  "%.3f" $mom_tool_diameter ]
   set s  [ format "%.3f" $pn_threadmill_stock ]
   set dd [ format "%.3f" $pn_threadmill_dia ]
   set err "  \n \n    **** $mom_operation_name **** \n  "
   set err "$err \n    **** $mom_cycle_text           \n "
   set err "$err \n    **** tool                    $td  "
   set err "$err \n    **** sidestock               $s   "
   set err "$err \n\n    **** doesn't leave room for thread $dd **** \n \n "

   MOM_abort $err
}
}


#=============================================================
proc PB_CMD_drill_text_move { } {
#=============================================================
# called from threadmill_handler
global pn_tm_type

if { $pn_tm_type == "INNER" } {  PB_CMD_inner_text_move }
if { $pn_tm_type == "OUTER" } {  PB_CMD_outer_text_move }
}


#=============================================================
proc PB_CMD_enable_ball_center_output { } {
#=============================================================
# This command can be added to the Start-of-Program event marker
# to enable ball-center output for ANY milling operations that use
# one of the following 3 types (mom_tool_type) of tool:
#  a. "Milling Tool-Ball Mill"
#  b. "Spherical Mill"
#  c. "Milling Tool-5 Parameters" whose tool diameter is 2 times of the corner radius.
#
#  - Only qualified operations will cause NX/Post to produce ball-center outputs.
#  - The condition is verified for every operation.
#  - Ball centers are computed for every move including cutting and non-cutting motions in
#    either standard or turbo process mode.
#  - Legacy command "PB_CMD_center_of_ball_output", if present in the post, will be disabled.
#

   # This command should be called in the Start-of-Program event
   if { ![CALLED_BY "PB_start_of_program"] } {
return
   }

   # This command only works with NX9 & beyond.
   if { [expr [string trim [MOM_ask_env_var UGII_MAJOR_VERSION]] < 9] } {
      CATCH_WARNING "[info level 0] is only functional with NX9 and newer!"
return
   }

   # Disable legacy command
   if { [CMD_EXIST PB_CMD_center_of_ball_output] } {
    uplevel #0 {
      proc PB_CMD_center_of_ball_output { } { }
    }
   }


   # Enable new capability
   global mom_sys_enable_ball_center_output
   set mom_sys_enable_ball_center_output 1


   # Define event handler
   if $mom_sys_enable_ball_center_output {
    uplevel #0 {

      #-------------------------------------------------------------------------------
      proc MOM_ball_center_output { } {
         # This event will be triggered before Start-of-Path when
         # an operation is qualified to produce ball-center outputs.
         #
         # This command may be customized as needed.
         #
      }
      #-------------------------------------------------------------------------------

    }
   }

}


#=============================================================
proc PB_CMD_end_of_alignment_character { } {
#=============================================================
 # Return sequnece number back to orignal
 # This command may be used with the command "PM_CMD_start_of_alignment_character"

  global mom_sys_leader saved_seq_num
  if [info exists saved_seq_num] {
    set mom_sys_leader(N) $saved_seq_num
  }
}


#=============================================================
proc PB_CMD_endofeverything { } {
#=============================================================
global   js_HON_status
if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED OFF ) "
    MOM_output_literal "G187  "
}

MOM_output_literal "M09 "
MOM_output_literal "M05 "
MOM_output_literal "G28 G91 Z0. "
MOM_output_literal "G28 G91 Y0. "
#MOM_output_literal "M11  "
#MOM_output_literal "M13  "
MOM_output_literal "M33"    ;#auger off
MOM_output_literal "M30"
MOM_output_literal "% "
}


#=============================================================
proc PB_CMD_fifth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a
#  fifth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fifth_axis_rotary_move
#  block template.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#

  MOM_force once fifth_axis
  MOM_do_template fifth_axis_rotate_move
}


#=============================================================
proc PB_CMD_fix_G54 { } {
#=============================================================

# returns errorchecked fixture offset from system one..

global mom_fixture_offset_value
global js_fixoff

if { ![ info exists mom_fixture_offset_value ] } {  ;# if var not set
    set mom_fixture_offset_value 55
   }
if { $mom_fixture_offset_value == 0 } {  ;# if user not set
    set mom_fixture_offset_value 55
   }

if { ( $mom_fixture_offset_value > 6  && $mom_fixture_offset_value < 55 ) ||  ( $mom_fixture_offset_value > 59 ) } {

       MOM_output_literal " bad fixture offset number $mom_fixture_offset_value "
    MOM_abort "\n\n ***** bad fixture offset number $mom_fixture_offset_value  ***** \n\n"
   }

if { $mom_fixture_offset_value < 7 } {        ;# handle 1,2 for 54, 55
   set mom_fixture_offset_value [expr $mom_fixture_offset_value +53 ]
   }

 set js_fixoff $mom_fixture_offset_value
}


#=============================================================
proc PB_CMD_fix_RAPID_SET { } {
#=============================================================
# <02-18-08 gsl>
# This command is provided to overwrite the system RAPID_SET
# in order to correct the problem with workplane change that
# doesn't account for +/- directions along X or Y principal axes.
# It also fixes the problem that the First Move was never
# identified to force the output of the 1st point.
#
# - This command can be attached to the Start of Program event marker.
#

 # Only redefine RAPID_SET once, since ugpost_base is only loaded once.
 #
  if { [llength [info commands ugpost_RAPID_SET]] == 0 } {
     if { [llength [info commands RAPID_SET]] } {
        rename RAPID_SET ugpost_RAPID_SET
     }
  } else {
return
  }


uplevel #0 {

#====================
proc RAPID_SET { } {
#====================

  if { [llength [info commands PB_CMD_set_cycle_plane]] > 0 } {
    PB_CMD_set_cycle_plane
  }


  global mom_cycle_spindle_axis mom_sys_work_plane_change
  global traverse_axis1 traverse_axis2 mom_motion_event mom_machine_mode
  global mom_pos mom_prev_pos mom_from_pos mom_last_pos mom_sys_home_pos
  global mom_sys_tool_change_pos
  global spindle_first rapid_spindle_inhibit rapid_traverse_inhibit

  if { ![info exists mom_from_pos($mom_cycle_spindle_axis)] && [info exists mom_sys_home_pos($mom_cycle_spindle_axis)] } {

    set mom_from_pos(0) $mom_sys_home_pos(0)
    set mom_from_pos(1) $mom_sys_home_pos(1)
    set mom_from_pos(2) $mom_sys_home_pos(2)

  } elseif { ![info exists mom_sys_home_pos($mom_cycle_spindle_axis)] && [info exists mom_from_pos($mom_cycle_spindle_axis)] } {

    set mom_sys_home_pos(0) $mom_from_pos(0)
    set mom_sys_home_pos(1) $mom_from_pos(1)
    set mom_sys_home_pos(2) $mom_from_pos(2)

  } elseif { ![info exists mom_sys_home_pos($mom_cycle_spindle_axis)] && ![info exists mom_from_pos($mom_cycle_spindle_axis)] } {

    set mom_from_pos(0) 0.0 ; set mom_sys_home_pos(0) 0.0
    set mom_from_pos(1) 0.0 ; set mom_sys_home_pos(1) 0.0
    set mom_from_pos(2) 0.0 ; set mom_sys_home_pos(2) 0.0
  }

  if { ![info exists mom_sys_tool_change_pos($mom_cycle_spindle_axis)] } {
    set mom_sys_tool_change_pos($mom_cycle_spindle_axis) 100000.0
  }

  set is_first_move 0
  if { [string match "MOM_first_move" [MOM_ask_event_type]] } {
    set is_first_move 1
  }

  if { ![info exists mom_motion_event] } { set mom_motion_event "" }

  if { [string match "initial_move" $mom_motion_event] || $is_first_move } {
    set mom_last_pos($mom_cycle_spindle_axis) $mom_sys_tool_change_pos($mom_cycle_spindle_axis)
  } else {
    if { [info exists mom_last_pos($mom_cycle_spindle_axis)] == 0 } {
      set mom_last_pos($mom_cycle_spindle_axis) $mom_sys_home_pos($mom_cycle_spindle_axis)
    }
  }


  if { ![string match "MILL" $mom_machine_mode] && ![string match "DRILL" $mom_machine_mode] } {
return
  }


  WORKPLANE_SET

  set rapid_spindle_inhibit  FALSE
  set rapid_traverse_inhibit FALSE


  if { [EQ_is_lt $mom_pos($mom_cycle_spindle_axis) $mom_last_pos($mom_cycle_spindle_axis)] } {
    set going_lower 1
  } else {
    set going_lower 0
  }


  if { ![info exists mom_sys_work_plane_change] } {
    set mom_sys_work_plane_change 1
  }


 # Reverse workplane change direction per spindle axis
  global mom_spindle_axis

  if { [info exists mom_spindle_axis] } {

   #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   # User can force work plane change to be disabled for rapid move along non-principal
   # spindle axis even when work plane change has been set in the Rapid Move event.
   #
   # - This flag has no effect if the work plane change is not set.
   #
    set disable_non_principal_spindle 0


    switch $mom_cycle_spindle_axis {
      0 {
        if [EQ_is_lt $mom_spindle_axis(0) 0.0] {
          set going_lower [expr abs($going_lower - 1)]
        }
      }
      1 {
        if [EQ_is_lt $mom_spindle_axis(1) 0.0] {
          set going_lower [expr abs($going_lower - 1)]
        }
      }
      2 { ;# Multi-spindle machine
        if [EQ_is_lt $mom_spindle_axis(2) 0.0] {
          set going_lower [expr abs($going_lower - 1)]
        }
      }
    }


   # Per user's choice above, disable work plane change for non-principal spindle axis
   #
    if { $disable_non_principal_spindle } {

      if { ![EQ_is_equal $mom_spindle_axis(0) 1] && ![EQ_is_equal $mom_spindle_axis(1) 1] && ![EQ_is_equal $mom_spindle_axis(0) 1] } {

         global mom_user_work_plane_change
         global mom_user_spindle_first

         set mom_user_work_plane_change $mom_sys_work_plane_change
         set mom_sys_work_plane_change 0

         if [info exists spindle_first] {
           set mom_user_spindle_first $spindle_first
         } else {
           set mom_user_spindle_first NONE
         }
      }
    }
  }


  if { $mom_sys_work_plane_change } {

    if { $going_lower } {
      set spindle_first FALSE
    } else {
      set spindle_first TRUE
    }

   # Force output in Initial Move and First Move.
    if { ![string match "*initial_move*" $mom_motion_event] && !$is_first_move } {

       if { [EQ_is_equal $mom_pos($mom_cycle_spindle_axis) $mom_last_pos($mom_cycle_spindle_axis)] } {
         set rapid_spindle_inhibit TRUE
       } else {
         set rapid_spindle_inhibit FALSE
       }

       if { [EQ_is_equal $mom_pos($traverse_axis1) $mom_prev_pos($traverse_axis1)] && [EQ_is_equal $mom_pos($traverse_axis2) $mom_prev_pos($traverse_axis2)] && [EQ_is_equal $mom_pos(3) $mom_prev_pos(3)] && [EQ_is_equal $mom_pos(4) $mom_prev_pos(4)] } {

         set rapid_traverse_inhibit TRUE
       } else {
         set rapid_traverse_inhibit FALSE
       }
    }

  } else {
    set spindle_first NONE
  }

} ;# proc
} ;# uplevel
}


#=============================================================
proc PB_CMD_fixupD { } {
#=============================================================
#    reckon that we want cutcom register D output if :
#    mom_tool_cutcom_register is non-zero ( use user value )
#    or mom_tool_cutcom_register is zero  ( use tool value )
#    AND mom_cutcom_status is RIGHT or LEFT but not UNDEFINED or OFF

global mom_cutcom_status
global mom_tool_cutcom_register
global mom_tool_number

global js_cutcom_register     ;# return value

if [info exists js_cutcom_register ] { unset js_cutcom_register }

if { $mom_cutcom_status != "RIGHT" && $mom_cutcom_status != "LEFT" } { return }

set js_cutcom_register $mom_tool_number        ;# tool no. if not set

if { $mom_tool_cutcom_register != 0 }  {
   set js_cutcom_register $mom_tool_cutcom_register
}
MOM_force once D
}


#=============================================================
proc PB_CMD_fixupD_off { } {
#=============================================================
global js_cutcom_register

if [info exists js_cutcom_register ] { unset js_cutcom_register }
}


#=============================================================
proc PB_CMD_fixupH { } {
#=============================================================
global pn_tool_adjust_register mom_tool_adjust_register mom_tool_number

# use tool number same as H number unless specified different


set pn_tool_adjust_register $mom_tool_number

if { $mom_tool_adjust_register != 0      }  {

    ;# if the above  is true use the adjust number set in UG
        set pn_tool_adjust_register $mom_tool_adjust_register


}
}


#=============================================================
proc PB_CMD_force_tables { } {
#=============================================================
#  flick rotary table angles by setting bogus value for table after t/change
global js_lastB
set js_lastB -999
}


#=============================================================
proc PB_CMD_fourth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a
#  fourth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fourth_axis_rotary_move
#  block template.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#

  MOM_force once fourth_axis
  MOM_do_template fourth_axis_rotate_move
}


#=============================================================
proc PB_CMD_gohomeZonly { } {
#=============================================================
# several blocks used before index
# put into single calling routine for tidiness


MOM_force once G_mode G Z M_coolant
MOM_do_template gohome1            ;# G91 G28 Z0. M09

MOM_force once G_mode G Y
MOM_do_template gohome2            ;# G91 G28 Y0.

MOM_force once G_mode
MOM_do_template gohome3            ;# G90

MOM_force once G X Y             ;# re-force xy for next move

global spindle_first             ;# force XY before Z in next block
set spindle_first FALSE            ;# spindle_first setting used in mom_rapid_move
}


#=============================================================
proc PB_CMD_handle_sync_event { } {
#=============================================================
  global mom_sync_code
  global mom_sync_index
  global mom_sync_start
  global mom_sync_incr
  global mom_sync_max


  set mom_sync_start     99
  set mom_sync_incr       1
  set mom_sync_max    199


  if {![info exists mom_sync_code] } {
    set mom_sync_code $mom_sync_start
  }

  set mom_sync_code [expr $mom_sync_code + $mom_sync_incr]

  MOM_output_literal "M$mom_sync_code"
}


#=============================================================
proc PB_CMD_index_status { } {
#=============================================================
# trace index status
global mom_SafeIndex
global last_reported_status

# conditional ( now )

if { $mom_SafeIndex != "ON" } {
    MOM_output_literal "( SAFE INDEX STATUS  : $mom_SafeIndex )"
    set last_reported_status "OFF"
} else {

    if {[info exists last_reported_status]} {
    if { $last_reported_status == "OFF" } {
        # only if previous report was OFF - don't repeat...
        MOM_output_literal "( SAFE INDEX STATUS  : $mom_SafeIndex )"
        set last_reported_status "ON"
    }
     }
}
}


#=============================================================
proc PB_CMD_init_helix { } {
#=============================================================
uplevel #0 {
#
# This procedure will be executed automatically at the start of program and
# anytime it is loaded as a slave post of a linked post.
#
# This procedure can be used to enable your post to output helix.
# You can choose from the following options to format the circle
# block template to output the helix parameters.
#

set mom_sys_helix_pitch_type    "rise_radian"

#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
#
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.

#
#  The following variable deines the output mode for helical records.
#
#  FULL_CIRCLE  -- This mode will output a helix record for each 360
#                  degrees of the helix.
#  QUADRANT  --    This mode will output a helix record for each 90
#                  degrees of the helix.
#  LINEAR  --      This mode will output the entire helix as linear gotos.
#  END_POINT --    This mode will assume the control can define an entire
#                  helix in a single block.

   set mom_kin_helical_arc_output_mode FULL_CIRCLE

   MOM_reload_kinematics



#=============================================================
proc MOM_helix_move { } {
#=============================================================
   global mom_pos_arc_plane
   global mom_sys_cir_vector
   global mom_sys_helix_pitch_type
   global mom_helix_pitch
   global mom_prev_pos mom_pos_arc_center
   global PI

   switch $mom_pos_arc_plane {
      XY { MOM_suppress once K ; set cir_index 2 }
      YZ { MOM_suppress once I ; set cir_index 0 }
      ZX { MOM_suppress once J ; set cir_index 1 }
   }

   switch $mom_sys_helix_pitch_type {
      none { }
      rise_revolution { set pitch $mom_helix_pitch }
      rise_radian { set pitch [expr $mom_helix_pitch / ($PI * 2.0)]}
      other {
#
#    Place your custom helix pitch code here
#
      }
      default { set mom_sys_helix_pitch_type "none" }
   }

   MOM_force once X Y Z

   if {$mom_sys_helix_pitch_type != "none"} {
      MOM_force once I J K
      if {$mom_sys_cir_vector == "Vector - Arc Center to Start"} {
         set mom_prev_pos($cir_index) 0.0
         set mom_pos_arc_center($cir_index) $pitch
      } elseif {$mom_sys_cir_vector == "Vector - Arc Start to Center"} {
         set mom_prev_pos($cir_index) $pitch
         set mom_pos_arc_center($cir_index) 0.0
      } elseif {$mom_sys_cir_vector == "Unsigned Vector - Arc Center to Start"} {
         set mom_prev_pos($cir_index) 0.0
         set mom_pos_arc_center($cir_index) $pitch
      } elseif {$mom_sys_cir_vector == "Absolute Arc Center"} {
         set mom_pos_arc_center($cir_index) $pitch
      }
   }


#
# You may need to edit this line if you output more than one block
# or if you have changed the name of your circular_move block template
#
   MOM_do_template circular_move


} ;# MOM_helix_move


} ;# uplevel
}


#=============================================================
proc PB_CMD_init_oper_tool_time { } {
#=============================================================
#  This command will be executed automatically in the "Start of Path" marker
#  to reset the machining time for the operation.
#
#
   global mom_machine_time
   global mom_sys_prev_machine_time

   set mom_sys_prev_machine_time $mom_machine_time
}


#=============================================================
proc PB_CMD_init_rotary { } {
#=============================================================
uplevel #0 {

#
# Retract and Re-Engage Parameters
#
# This option is activated by setting the Axis Limit Violation
# Handling option on the Machine Tool dialog to Retract/Re-Engage.
#
# The sequence of actions that take place when a rotary limit violation
# occurs is a retract to the clearance geometry at the rapid feedrate,
# reposition the rotary axes so they do not violate, move back to
# the engage point at the retract feedrate and engage into the part again.
#
# You can set additional parameters that will control the retract
# and re-engage motion.
#
#
#  mom_kin_retract_type ------- specifies the method used to
#                               calculate the retract point.
#                               The method can be of
#
#    DISTANCE : The retract will be to a point at a fixed distance
#               along the spindle axis.
#
#    SURFACE  : For a 4-axis rotary head machine, the retract will
#               be to a cylinder.  For a 5-axis dual heads machine,
#               the retract will be to a sphere.  For machine with
#               only rotary table(s), the retract will be to a plane
#               normal & along the spindle axis.
#
#  mom_kin_retract_distance --- specifies the distance or radius for
#                               defining the geometry of retraction.
#
#  mom_kin_reengage_distance -- specifies the re-engage point above
#                               the part.
#

set mom_kin_retract_type                "DISTANCE"
set mom_kin_retract_distance            10.0
set mom_kin_reengage_distance           .20



#
# The following parameters are used by UG Post.  Do NOT change
# them unless you know what you are doing.
#
if { ![info exists mom_kin_spindle_axis] } {
  set mom_kin_spindle_axis(0)                    0.0
  set mom_kin_spindle_axis(1)                    0.0
  set mom_kin_spindle_axis(2)                    1.0
}

set spindle_axis_defined 1
if { ![info exists mom_sys_spindle_axis] } {
  set spindle_axis_defined 0
} else {
  if { ![array exists mom_sys_spindle_axis] } {
    unset mom_sys_spindle_axis
    set spindle_axis_defined 0
  }
}
if !$spindle_axis_defined {
  set mom_sys_spindle_axis(0)                    0.0
  set mom_sys_spindle_axis(1)                    0.0
  set mom_sys_spindle_axis(2)                    1.0
}

set mom_sys_lock_status                        "OFF"

} ;# uplevel
}


#=============================================================
proc PB_CMD_init_spindle_axis { } {
#=============================================================
#
# This procedure will be executed automatically at the start of program and
# anytime it is loaded as a slave post of a linked post.
#

  global mom_kin_spindle_axis mom_sys_spindle_axis

# This procedure can be used to set the spindle axis to
# an axis other than the Z axis of the MCS.  If you have
# a right angle head, then this vector needs to be
# changed.
#
  if {![info exists mom_kin_spindle_axis]} {
    set mom_kin_spindle_axis(0)                    0.0
    set mom_kin_spindle_axis(1)                    0.0
    set mom_kin_spindle_axis(2)                    1.0
  }

  if {![info exists mom_sys_spindle_axis]} {
    set mom_sys_spindle_axis(0)                    0.0
    set mom_sys_spindle_axis(1)                    0.0
    set mom_sys_spindle_axis(2)                    1.0
  }

}


#=============================================================
proc PB_CMD_init_tool_list { } {
#=============================================================
#  This command will be executed automatically at the "Start of Program" to
#  prepare for the tool list generation.
#
#  This command will add the shop doc event handlers to the post.
#  You may edit the proc MOM_TOOL_BODY to customize your tool list output.
#
#  Only the tools used in the program being post-processed will be listed.
#
#  In order to create the tool list, you MUST add the command
#  PB_CMD_create_tool_list to either the "Start of Program"
#  or the "End of Program" event marker depending on where
#  the tool list is to be output in your NC code.
#
#  The Shop Doc template file "pb_post_tool_list.tpl" residing in the
#  "postbuild/pblib/misc" directory is required for this service to work.
#  You may need to copy it to the "mach/resource/postprocessor"
#  or "mach/resource/shop_docs" directory, in case your UG runtime
#  environment does not have access to the Post Builder installation.
#
#-------------------------------------------------------------
# 01-11-13 gsl - ir2209290 Add Tap case in MAP_TOOL_TYPE proc
#                to list tapping tool of hole-making operation
#
#

   global mom_sys_tool_list_initialized


uplevel #0 {

proc MOM_TOOL_BODY { } {
   global mom_tool_name
   global mom_tool_number
   global mom_tool_diameter
   global mom_tool_length
   global mom_tool_type
   global mom_template_subtype
   global mom_tool_point_angle
   global mom_tool_flute_length
   global mom_tool_length_adjust_register
   global mom_tool_nose_radius
   global mom_tool_corner1_radius
   global mom_tool_flute_length
   global mom_tool_orientation
   global mom_sys_control_out mom_sys_control_in
   global cycle_program_name current_program_name
   global mom_sys_tool_stack

   global tool_data_buffer


  # Handle single operation case.
  # current_program_name will be blank when no group has been selected.

   if { [string length $current_program_name] != 0 } {
      set n1 [string toupper $cycle_program_name]
      set n2 [string toupper $current_program_name]
      if { [string compare $n1 $n2] && [string length $n1] != 0 } {
return
      }
   } else {

     # mom_sys_change_mach_operation_name is set in MOM_machine_mode
     # Use this variable to generate tool info for a single operation.

      global mom_sys_change_mach_operation_name mom_operation_name

      if [info exists mom_sys_change_mach_operation_name] {
         if { ![string match "$mom_operation_name" $mom_sys_change_mach_operation_name] } {
return
         }
      } else {
return
      }
   }


  #****************************
  # Collect various tool lists
  #****************************
   lappend mom_sys_tool_stack(IN_USE) $mom_tool_name

   set tool_type [MAP_TOOL_TYPE]

   if { [lsearch $mom_sys_tool_stack(ALL) $mom_tool_name] < 0 } {

      lappend mom_sys_tool_stack(ALL)         $mom_tool_name
      lappend mom_sys_tool_stack($tool_type)  $mom_tool_name
   }


  #*************************************************
  # Define data to be output for each tool per type
  #*************************************************
   set output ""

   set ci $mom_sys_control_in
   set co $mom_sys_control_out

   if { [string length $mom_template_subtype] == 0 } { set mom_template_subtype $mom_tool_type }

   set tool_name [string range $mom_tool_name 0 19]
   set template_subtype [string range $mom_template_subtype 0 19]

   switch $tool_type {

      "MILL" {


         set output [format "%-20s %-20s %-10.4f %-10.4f %-10.4f %-10d" \
                     $tool_name $template_subtype \
                     $mom_tool_diameter $mom_tool_corner1_radius \
                     $mom_tool_flute_length $mom_tool_length_adjust_register]
      }

      "DRILL" {

         set mom_tool_point_angle [expr (180.0 / 3.14159) * $mom_tool_point_angle]
         set output [format "%-20s %-20s %-10.4f %-10.4f %-10.4f %-10d" \
                     $tool_name $template_subtype \
                     $mom_tool_diameter $mom_tool_point_angle \
                     $mom_tool_flute_length $mom_tool_length_adjust_register]
      }

      "LATHE" {

         set pi [expr 2 * asin(1.0)]
         set tool_orient [expr (180. / 3.14159) * $mom_tool_orientation]
         set output [format "%-20s %-20s %-10.4f %-15.4f %-10d" \
                     $tool_name $template_subtype \
                     $mom_tool_nose_radius $tool_orient \
                     $mom_tool_length_adjust_register]
      }
   }


  #*******************************************************************************
  # Fetch tool time data from the post.
  # This info is only available when tool list is created at the end of a program.
  #*******************************************************************************
   global mom_sys_tool_list_output_type
   global mom_sys_tool_time
   global mom_operation_name

   set tool_time ""

   if [info exists mom_sys_tool_time] {

      switch $mom_sys_tool_list_output_type {
         "ORDER_IN_USE" {
           # Tool time per operations.
            set tool_time $mom_sys_tool_time($mom_tool_name,$mom_operation_name)
         }

         default {
           # Accumulate tool time from all operations using this tool.
            set tool_time 0
            if [info exists mom_sys_tool_time($mom_tool_name,oper_list)] {
               foreach oper $mom_sys_tool_time($mom_tool_name,oper_list) {
                  set tool_time [expr $tool_time + $mom_sys_tool_time($mom_tool_name,$oper)]
               }
            }
         }
      }
   }

   if { [string length $tool_time]  &&  $tool_time != 0 } {
      set tool_time [format "%-10.2f" $tool_time]
   }


  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  # Store data to be output or used in PB_CMD_create_tool_list.
  #
  # <Ex.>
  #  global mom_tool_number
  #   set tool_data_buffer($mom_tool_name,tool_number) $mom_tool_number
  #
  # If a BLOCK_TEMPLATE is used to output the data, the global varaibles
  # used in the expression of an Address need to be set accordingly
  # before "MOM_do_template" is called.
  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   set tool_data_buffer($mom_tool_name,output) "$co$output$tool_time$ci"
   set tool_data_buffer($mom_tool_name,type)   "$tool_type"
}


proc MOM_SETUP_HDR {} {
   global mom_sys_control_out mom_sys_control_in


  # Initialize various tool lists
   global mom_sys_tool_stack

   set mom_sys_tool_stack(IN_USE) [list]
   set mom_sys_tool_stack(ALL)    [list]
   set mom_sys_tool_stack(MILL)   [list]
   set mom_sys_tool_stack(DRILL)  [list]
   set mom_sys_tool_stack(LATHE)  [list]


   set ci $mom_sys_control_in
   set co $mom_sys_control_out


  #++++++++++++++++++++++++++++++++++++++++++
  # Define header to be output per tool type
  #++++++++++++++++++++++++++++++++++++++++++
   global tool_data_buffer

   set tool_desc   "DESCRIPTION"
   set tool_dia    "DIAMETER"
   set corner_rad  "COR RAD"
   set tip_ang     "TIP ANG"
   set flute_len   "FLUTE LEN"
   set adjust      "ADJ REG"
   set nose_dia    "NOSE RAD"
   set tool_orient "TOOL ORIENT"

  # Label title for tool time only when it exists.
   global mom_sys_tool_time
   if [info exists mom_sys_tool_time] {
      set mach_time   "MACH TIME"
   } else {
      set mach_time   ""
   }

     set tool_name   "DRILL"
     set output [format "%-20s %-20s %-10s %-10s %-10s %-9s %-10s" \
                         $tool_name $tool_desc \
                         $tool_dia $tip_ang $flute_len $adjust $mach_time]

     set header [list]
     lappend header "$co                                                                                               $ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"
     lappend header "$co$output$ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"

   set tool_data_buffer(DRILL,header) [join $header \n]


     set tool_name   "MILL"
     set output [format "%-20s %-20s %-10s %-10s %-10s %-9s %-10s" \
                         $tool_name $tool_desc \
                         $tool_dia $corner_rad $flute_len $adjust $mach_time]

     set header [list]
     lappend header "$co                                                                                               $ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"
     lappend header "$co$output$ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"

   set tool_data_buffer(MILL,header) [join $header \n]


     set tool_name   "LATHE"
     set output [format "%-20s %-20s %-10s %-15s %-9s %-10s" \
                         $tool_name $tool_desc $nose_dia $tool_orient $adjust $mach_time]

     set header [list]
     lappend header "$co                                                                                               $ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"
     lappend header "$co$output$ci"
     lappend header "$co-----------------------------------------------------------------------------------------------$ci"

   set tool_data_buffer(LATHE,header) [join $header \n]
}


proc MOM_PROGRAMVIEW_HDR {} {}
proc MOM_SETUP_FTR {} {}


proc MOM_MEMBERS_HDR {} {
   global mom_sys_program_stack cycle_program_name
   global current_program_name

   lappend mom_sys_program_stack $cycle_program_name

   if { [lsearch $mom_sys_program_stack "$current_program_name"] >= 0 } {
      set cycle_program_name $current_program_name
   }
}


proc MOM_MEMBERS_FTR {} {
   global mom_sys_program_stack cycle_program_name
   global current_program_name

   set mom_sys_program_stack [lreplace $mom_sys_program_stack end end]
   set cycle_program_name [lindex $mom_sys_program_stack end]

   if { [lsearch $mom_sys_program_stack "$current_program_name"] >= 0 } {
      set cycle_program_name $current_program_name
   }
}


proc MOM_PROGRAM_BODY {} {
   global mom_object_name cycle_program_name

   set cycle_program_name $mom_object_name
}


proc MOM_SETUP_BODY {} {}
proc MOM_OPER_BODY  {} {}
proc MOM_TOOL_HDR   {} {}
proc MOM_TOOL_FTR   {} {}
proc MOM_PROGRAMVIEW_FTR {} {}


proc MAP_TOOL_TYPE { } {
   global mom_tool_type

   if {[string match "Milling*" $mom_tool_type]} {
      return "MILL"
   } elseif { [string match "Turning*" $mom_tool_type]} {
      return "LATHE"
   } elseif { [string match "Grooving*" $mom_tool_type]} {
      return "LATHE"
   } elseif { [string match "Threading*" $mom_tool_type]} {
      return "LATHE"
   } elseif { [string match "Drilling*" $mom_tool_type]} {
      return "DRILL"
   } elseif { [string match "Tap*" $mom_tool_type]} {
      return "DRILL"
   } else {
      return ""
   }
}


proc shop_doc_output_literal { line } {
   global tool_list_commentary list_file

   set line_list [split $line \n]

   foreach line $line_list {

      if [info exists tool_list_commentary] {
         puts $list_file $line
      } else {
         MOM_output_literal $line
      }

   }
}


} ;# uplevel


   set mom_sys_tool_list_initialized 1

}


#=============================================================
proc PB_CMD_init_vars { } {
#=============================================================
global pn_fixture_offset_value    ; set pn_fixture_offset_value 54    ;# may make variable later

global js_HON_waiting ; set js_HON_waiting "FALSE"     ;# (not) waiting to be output
global js_HON_status  ; set js_HON_status  "FALSE"      ;# (not) output-and-not-cancelled

global mom_HighSpeed  ; set mom_HighSpeed  "OFF"     ;# or ON from UDE - USED TO BE ON


global mom_prog_name ; set mom_prog_name "O0666"    ;# initialised in init-vars
global mom_mam_prog_text ; set mom_mam_prog_text "NO DESCRIPTION "

global mom_mam_part_text ; set mom_mam_part_text -1     ;# from UDE

global mom_coolant_status ; set mom_coolant_status ON
global js_superstop_flag  ; set js_superstop_flag 0    ;# superstop waiting code

global js_blockno    ; set js_blockno 1        ;# for N-number

global mom_SafeIndex    ; set mom_SafeIndex "ON"     ;# FROM   UDE

global pn_just_toolchanged ; set pn_just_toolchanged "FALSE" ;# used/unset in PB_CMD_split_this_block

MOM_output_literal "%"

}


#=============================================================
proc PB_CMD_inner_text_move { } {
#=============================================================
# INNER - thread mill
# called for each hole  when we are at clearplane over first hole
# or after previous call to this proc. at previous hole

# works are moved to inner_text_pass - which we will call multiple
# times so Andy can make rough and finish cuts

global pn_threadmill_dia pn_thread_left pn_thread_pitches pn_threadmill_stock pn_threadmill_r_passes
global pn_this_dia

set inc 0
if { $pn_threadmill_r_passes > 0 } {         ;# pass size if any ...
   set inc [ expr 1.0 * $pn_threadmill_stock / ( 1.0 + $pn_threadmill_r_passes ) ]
}
# MOM_output_literal " inc $inc "

set pn_this_dia  [ expr $pn_threadmill_dia - 2.0 * $pn_threadmill_stock ]    ;# could be threadmill_dia

# MOM_output_literal " pn_this_dia before for loop inner dia $pn_this_dia "

for { set ii 0 } { $ii <  $pn_threadmill_r_passes } { incr ii } {
  set pn_this_dia [ expr $pn_this_dia + 2 * $inc ]
  #  MOM_output_literal " pn_this_dia $pn_this_dia "
  PB_CMD_inner_text_pass
}

set pn_this_dia $pn_threadmill_dia     ;#   final dia
MOM_output_literal " ( FINAL CUT $pn_this_dia DIA ) "
PB_CMD_inner_text_pass            ;# finish ( fundamental ) pass
}


#=============================================================
proc PB_CMD_inner_text_pass { } {
#=============================================================
# INNER pass for - thread mill
# called for each pass from inner_text_move
#  inner_text_move may call this several times with different dia to give rough and finsh

global pn_this_dia    ;# will be pn_threadmill_dia for last ( fundamental ) pass

global mom_pos mom_cycle_rapid_to feed mom_cycle_feed_to mom_prev_pos
global mom_tool_diameter mom_tool_pitch
global thX thY thZ thI thJ thF thG
global pn_threadmill_dia pn_thread_left pn_thread_pitches
global mom_cutcom_status
#

# set tr [ expr ( $pn_threadmill_dia - $mom_tool_diameter ) / 2 ] ;# toolpath rad
set tr   [ expr ( $pn_this_dia - $mom_tool_diameter ) / 2 ]       ;# thispass rad
set er [ expr $tr / 2 ]                          ;# engage retract rad
#

global mom_prev_pos ZretBetweenHoles
# ## set startZ $mom_prev_pos(2) ;# come back here at end
set startZ $ZretBetweenHoles      ;# set once and for all in PB_CMD_drill_text

# #### xy move to this  hole   #####
MOM_do_template RapXYforThread

# ####   z move to Rplane   #####
set thZ [ expr $mom_pos(2) + $mom_cycle_rapid_to]
MOM_do_template RapZforThread

# ####   z feed to btm      #####
set thF [ expr 0.5 * $feed ]         ;# slow down approach
# # mod - start 1/8pitch lower so full thread == programmed value
set thZ [ expr $mom_pos(2) + $mom_cycle_feed_to -( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
MOM_do_template FeedZforThread

# ### xy feed to start point at -45 ( or +45 degrees for LHThread ) ###
set thX [ expr $mom_pos(0) + $er ]
set thY [ expr $mom_pos(1) - $er ]
if { $pn_thread_left == 1 } { set thY [ expr $mom_pos(1) + $er ] }

set mom_cutcom_status LEFT
if { $pn_thread_left == 1 } { set mom_cutcom_status RIGHT }

PB_CMD_fixupD
MOM_do_template FeedXYforThread

#  ### G3 in (G2 for LHT )half rad to 3oclock posn. with Z lift  of 1/8pitch ###
set thG 3
set thX [ expr $mom_pos(0) + $tr ]
set thY  $mom_pos(1)
set thZ [ expr $runningZ + ( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
set thI 0
set thJ $er
if { $pn_thread_left == 1 } {    set thG 2 ; set thJ [expr -1.0 * $er ] }
# feedrate mod for engage
set thF [ expr 0.5 * $feed *  ( $pn_threadmill_dia - $mom_tool_diameter ) / $pn_threadmill_dia ]

MOM_force once G_motion X Y I J
MOM_do_template ArcForThread


#   ### n trips round with Z increment upwards by 1 pitch   ###
for { set i 1 } { $i <= $pn_thread_pitches } { incr i }  {
    set thG 3
    set thX [ expr $mom_pos(0) + $tr ]
    set thY  $mom_pos(1)
    set thZ [ expr $runningZ + $mom_tool_pitch ]
    set runningZ $thZ
    set thI [expr -1.0 * $tr ]
    set thJ 0
    if { $pn_thread_left == 1 } { set thG 2  }
    # feedrate mod for main cut
    set thF [ expr  $feed *  ( $pn_threadmill_dia - $mom_tool_diameter ) / $pn_threadmill_dia ]
    MOM_force once G_motion X Y I J
    MOM_do_template ArcForThread
}


#   ### arc out to end point at 45 ( or -45 degrees for LHThread ) ###
#       G3 out (G2 for LHT )half rad end pt with Z lift  of 1/8pitch
set thG 3
set thX [ expr $mom_pos(0) + $er ]
set thY [ expr $mom_pos(1) + $er ]
if { $pn_thread_left == 1 } { set thY [ expr $mom_pos(1) - $er ] }

set thZ [ expr $runningZ + ( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
set thI [expr -1.0 * $er ]
set thJ 0
if { $pn_thread_left == 1 } { set thG 2 }

MOM_force once G_motion X Y I J
MOM_do_template ArcForThread

#   ### xy feed to middle of hole  ###
set thX $mom_pos(0)
set thY $mom_pos(1)

set mom_cutcom_status OFF
PB_CMD_fixupD_off
MOM_do_template FeedXYforThread

#    ### Z rapid to clearplane    ###
set thZ $startZ
MOM_do_template RapZforThread
MOM_force once Z
}


#=============================================================
proc PB_CMD_kin_abort_event { } {
#=============================================================
   if { [llength [info commands PB_CMD_abort_event]] } {
      PB_CMD_abort_event
   }
}


#=============================================================
proc PB_CMD_kin_before_motion { } {
#=============================================================
#  This custom command is used by UG Post to support Set/Lock,
#  rotary axis limit violation retracts and auto clamping.
#
#  --> Do not change this command!  If you want to improve
#      performance, you may comment out any of these commands.
#
   global mom_kin_machine_type

   if { [info exists mom_kin_machine_type] } {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||\
           [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


  # Lock on and not circular move
   global mom_sys_lock_status  ;# Set in MOM_lock_axis
   global mom_current_motion
   if { [info exists mom_sys_lock_status] && ![string compare "ON" $mom_sys_lock_status] } {
      if { [info exists mom_current_motion] && [string compare "circular_move" $mom_current_motion] } {

         LOCK_AXIS_MOTION
      }
   }


  # Handle rotary over travel for linear moves (mom_sys_rotary_error set in PB_catch_warning)
   global mom_sys_rotary_error mom_motion_event
   if { [info exists mom_sys_rotary_error] } {
      if { $mom_sys_rotary_error != 0 && \
           [info exists mom_motion_event] && ![string compare "linear_move" $mom_motion_event] } {

         ROTARY_AXIS_RETRACT
      }

     # Error state s/b reset every time to avoid residual effect!
      UNSET_VARS mom_sys_rotary_error
   }


  # Auto clamp on
   global mom_sys_auto_clamp
   if { [info exists mom_sys_auto_clamp] && ![string compare "ON" $mom_sys_auto_clamp] } {

      AUTO_CLAMP
   }
}


#=============================================================
proc PB_CMD_kin_before_output { } {
#=============================================================
# Broker command ensuring PB_CMD_before_output,if present, gets executed
# by MOM_before_output.
#
   if [llength [info commands PB_CMD_before_output] ] {
      PB_CMD_before_output
   }
}


#=============================================================
proc PB_CMD_kin_end_of_path { } {
#=============================================================
  # Record tool time for this operation.
   if { [llength [info commands PB_CMD_set_oper_tool_time] ] } {
      PB_CMD_set_oper_tool_time
   }

  # Clear tool holder angle used in operation
   global mom_use_b_axis
   UNSET_VARS mom_use_b_axis
}


#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This command supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this command in the
# Event handlers.
#
# This command must be used in conjunction with ugpost_base.tcl.
#
   global   feed com_feed_rate
   global   mom_feed_rate_output_mode super_feed_mode feed_mode
   global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
   global   mom_cycle_feed_rate_per_rev
   global   mom_motion_type
   global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
   global   mom_sys_feed_param
   global   mom_sys_cycle_feed_mode


   set super_feed_mode $mom_feed_rate_output_mode

   set f_pm [ASK_FEEDRATE_FPM]
   set f_pr [ASK_FEEDRATE_FPR]

   switch $mom_motion_type {

      CYCLE {
         if { [info exists mom_sys_cycle_feed_mode] } {
            if { [string compare "Auto" $mom_sys_cycle_feed_mode] } {
               set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
            }
         }
         if { [info exists mom_cycle_feed_rate_mode] }    { set super_feed_mode $mom_cycle_feed_rate_mode }
         if { [info exists mom_cycle_feed_rate] }         { set f_pm $mom_cycle_feed_rate }
         if { [info exists mom_cycle_feed_rate_per_rev] } { set f_pr $mom_cycle_feed_rate_per_rev }
      }

      FROM -
      RETRACT -
      RETURN -
      LIFT -
      TRAVERSAL -
      GOHOME -
      GOHOME_DEFAULT -
      RAPID {
         SUPER_FEED_MODE_SET RAPID
      }

      default {
         if { [EQ_is_zero $f_pm] && [EQ_is_zero $f_pr] } {
            SUPER_FEED_MODE_SET RAPID
         } else {
            SUPER_FEED_MODE_SET CONTOUR
         }
      }
   }


   set feed_mode $super_feed_mode


  # Adjust feedrate format per Post output unit again.
   global mom_kin_output_unit
   if { ![string compare "IN" $mom_kin_output_unit] } {
      switch $feed_mode {
         MMPM {
            set feed_mode "IPM"
            CATCH_WARNING "Feedrate mode MMPM changed to IPM"
         }
         MMPR {
            set feed_mode "IPR"
            CATCH_WARNING "Feedrate mode MMPR changed to IPR"
         }
      }
   } else {
      switch $feed_mode {
         IPM {
            set feed_mode "MMPM"
            CATCH_WARNING "Feedrate mode IPM changed to MMPM"
         }
         IPR {
            set feed_mode "MMPR"
            CATCH_WARNING "Feedrate mode IPR changed to MMPR"
         }
      }
   }


   switch $feed_mode {
      IPM     -
      MMPM    { set feed $f_pm }
      IPR     -
      MMPR    { set feed $f_pr }
      DPM     { set feed [PB_CMD_FEEDRATE_DPM] }
      FRN     -
      INVERSE { set feed [PB_CMD_FEEDRATE_NUMBER] }
      default {
         CATCH_WARNING "INVALID FEED RATE MODE"
         return
      }
   }


  # Post Builder provided format for the current mode:
   if { [info exists mom_sys_feed_param(${feed_mode},format)] } {
      MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
   } else {
      switch $feed_mode {
         IPM     -
         MMPM    -
         IPR     -
         MMPR    -
         DPM     -
         FRN     { MOM_set_address_format F Feed_${feed_mode} }
         INVERSE { MOM_set_address_format F Feed_INV }
      }
   }

  # Commentary output
   set com_feed_rate $f_pm


  # Execute user's command, if any.
   if { [llength [info commands "PB_CMD_FEEDRATE_SET"]] } {
      PB_CMD_FEEDRATE_SET
   }
}


#=============================================================
proc PB_CMD_kin_handle_sync_event { } {
#=============================================================
   PB_CMD_handle_sync_event
}


#=============================================================
proc PB_CMD_kin_init_new_iks { } {
#=============================================================
   global mom_kin_machine_type
   global mom_new_iks_exists

  # Revert legacy dual-head kinematic parameters when new IKS is absent.
   if { [string match "5_axis_dual_head" $mom_kin_machine_type] } {
      if { ![info exists mom_new_iks_exists] } {
         set ugii_version [string trim [MOM_ask_env_var UGII_VERSION]]
         if { ![string match "v3" $ugii_version] } {

            if { [CMD_EXIST PB_CMD_revert_dual_head_kin_vars] } {
               PB_CMD_revert_dual_head_kin_vars
            }
return
         }
      }
   }

  # Initialize new IKS parameters.
   if { [CMD_EXIST PB_init_new_iks] } {
      PB_init_new_iks
   }

  # Users can provide next command to modify or disable new IKS options.
   if { [CMD_EXIST PB_CMD_revise_new_iks] } {
      PB_CMD_revise_new_iks
   }

  # Revert legacy dual-head kinematic parameters when new IKS is disabled.
   if { [string match "5_axis_dual_head" $mom_kin_machine_type] } {
      global mom_kin_iks_usage
      if { $mom_kin_iks_usage == 0 } {
         if { [CMD_EXIST PB_CMD_revert_dual_head_kin_vars] } {
            PB_CMD_revert_dual_head_kin_vars
         }
      }
   }
}


#=============================================================
proc PB_CMD_kin_init_probing_cycles { } {
#=============================================================
   set cmd PB_CMD_init_probing_cycles
   if { [CMD_EXIST "$cmd"] } {
      eval $cmd
   }
}


#=============================================================
proc PB_CMD_kin_init_rotary { } {
#=============================================================
#
# Following commands are defined (via uplevel) here:
#
#    MOM_clamp
#    MOM_rotate
#    AUTO_CLAMP
#    AUTO_CLAMP_1
#    AUTO_CLAMP_2
#    MOM_lock_axis
#    PB_catch_warning
#    MOM_lintol
#

   global mom_kin_machine_type

   if { [info exists mom_kin_machine_type] } {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||\
           [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   if { [llength [info commands PB_CMD_init_rotary] ] } {
      PB_CMD_init_rotary
   }


#***********
uplevel #0 {


#=============================================================
### This is the backup of original MOM_clamp handler.
###
### - New command PB_CMD_MOM_clamp is created with the
###   same content of the original command and executed
###   by the new MOM_clamp handler.
###
proc DUMMY_MOM_clamp { } {
#=============================================================
  global mom_clamp_axis mom_clamp_status mom_sys_auto_clamp

   if { ![string compare "AUTO" $mom_clamp_axis] } {

      if { ![string compare "ON" $mom_clamp_status] } {
         set mom_sys_auto_clamp "ON"
      } elseif { ![string compare "OFF" $mom_clamp_status] } {
         set mom_sys_auto_clamp "OFF"
      }
   } else {
      CATCH_WARNING "$mom_clamp_axis not handled in current implementation!"
   }
}


#=============================================================
### This is the backup of original MOM_rotate handler.
###
### - New command PB_CMD_MOM_rotate is created with the
###   same content of the original command and executed
###   by the new MOM_rotate handler.
###
proc DUMMY_MOM_rotate { } {
#=============================================================
## <rws 04-11-2008>
## If in TURN mode and user invokes "Flip tool around Holder" a MOM_rotate event is generated
## When this happens ABORT this event via return
##

   global mom_machine_mode


   if { [info exists mom_machine_mode] && [string match "TURN" $mom_machine_mode] } {
      if [CMD_EXIST PB_CMD_handle_lathe_flash_tool] {
         PB_CMD_handle_lathe_flash_tool
      }
return
   }


   global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
   global mom_rotation_angle mom_rotation_reference_mode
   global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
   global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
   global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
   global mom_out_angle_pos
   global unlocked_prev_pos mom_sys_leader
   global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
   global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit
   global mom_prev_pos
   global mom_prev_rot_ang_4th mom_prev_rot_ang_5th


   if { ![info exists mom_rotation_angle] } {
     # Should the event be aborted here???
return
   }


   if { ![info exists mom_kin_5th_axis_direction] } {
      set mom_kin_5th_axis_direction "0"
   }


  #
  #  Determine which rotary axis the UDE has specifid - fourth(3), fifth(4) or invalid(0)
  #
  #
   if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {

      switch $mom_rotate_axis_type {
         CAXIS -
         FOURTH_AXIS -
         TABLE {
            set axis 3
         }
         default {
            set axis 0
         }
      }

   } else {

      switch $mom_rotate_axis_type {
         AAXIS -
         BAXIS -
         CAXIS {
            set axis [AXIS_SET $mom_rotate_axis_type]
         }
         HEAD {
            if { ![string compare "5_axis_head_table" $mom_kin_machine_type] ||\
                 ![string compare "5_AXIS_HEAD_TABLE" $mom_kin_machine_type] } {
               set axis 4
            } else {
               set axis 3
            }
         }
         FIFTH_AXIS {
            set axis 4
         }
         FOURTH_AXIS -
         TABLE -
         default {
            set axis 3
         }
      }
   }

   if { $axis == 0 } {
      CATCH_WARNING "Invalid rotary axis"
      MOM_abort_event
   }

   switch $mom_rotation_mode {
      NONE -
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }

   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }

   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang

   if { $axis == "3" } { ;# Rotate 4th axis

      if { ![info exists mom_prev_rot_ang_4th] } {
         set mom_prev_rot_ang_4th [MOM_ask_address_value fourth_axis]
      }
      if { [string length [string trim $mom_prev_rot_ang_4th]] == 0 } {
         set mom_prev_rot_ang_4th 0.0
      }

      set prev_angles(0) $mom_prev_rot_ang_4th

   } elseif { $axis == "4" } { ;# Rotate 5th axis

      if { ![info exists mom_prev_rot_ang_5th] } {
         set mom_prev_rot_ang_5th [MOM_ask_address_value fifth_axis]
      }
      if { [string length [string trim $mom_prev_rot_ang_5th]] == 0 } {
         set mom_prev_rot_ang_5th 0.0
      }

      set prev_angles(1) $mom_prev_rot_ang_5th
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]

   if { $axis == 3  &&  [string match "MAGNITUDE_DETERMINES_DIRECTION" $mom_kin_4th_axis_direction] } {

      set dirtype "MAGNITUDE_DETERMINES_DIRECTION"

      global mom_sys_4th_axis_dir_mode

      if { [info exists mom_sys_4th_axis_dir_mode] && ![string compare "ON" $mom_sys_4th_axis_dir_mode] } {

         set del $dir
         if { $del == 0 } {
            set del [expr $ang - $mom_prev_pos(3)]
            if { $del >  180.0 } { set del [expr $del - 360.0] }
            if { $del < -180.0 } { set del [expr $del + 360.0] }
         }

         global mom_sys_4th_axis_cur_dir
         global mom_sys_4th_axis_clw_code mom_sys_4th_axis_cclw_code

         if { $del > 0.0 } {
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_clw_code
         } elseif { $del < 0.0 } {
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_cclw_code
         }
      }

   } elseif { $axis == 4  &&  [string match "MAGNITUDE_DETERMINES_DIRECTION" $mom_kin_5th_axis_direction] } {

      set dirtype "MAGNITUDE_DETERMINES_DIRECTION"

      global mom_sys_5th_axis_dir_mode

      if { [info exists mom_sys_5th_axis_dir_mode] && ![string compare "ON" $mom_sys_5th_axis_dir_mode] } {

         set del $dir
         if { $del == 0 } {
            set del [expr $ang - $mom_prev_pos(4)]
            if { $del >  180.0 } { set del [expr $del - 360.0] }
            if { $del < -180.0 } { set del [expr $del + 360.0] }
         }

         global mom_sys_5th_axis_cur_dir
         global mom_sys_5th_axis_clw_code mom_sys_5th_axis_cclw_code

         if { $del > 0.0 } {
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_clw_code
         } elseif { $del < 0.0 } {
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_cclw_code
         }
      }

   } else {

      set dirtype "SIGN_DETERMINES_DIRECTION"
   }

   if { $mode == 1 } {

      set mom_out_angle_pos($a) $angle

   } elseif { [string match "MAGNITUDE_DETERMINES_DIRECTION" $dirtype] } {

      if { $axis == 3 } {
         set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(0) $mom_kin_4th_axis_direction\
                                                $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                                $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(1) $mom_kin_5th_axis_direction\
                                                $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                                $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
      }

   } elseif { [string match "SIGN_DETERMINES_DIRECTION" $dirtype] } {

      if { $dir == -1 } {
         if { $axis == 3 } {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif { $dir == 0 } {
         if { $axis == 3 } {
            set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(0) $mom_kin_4th_axis_direction\
                                                   $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                                   $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang $prev_angles(1) $mom_kin_5th_axis_direction\
                                                   $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                                   $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
         }
      } elseif { $dir == 1 } {
         set mom_out_angle_pos($a) $ang
      }
   }


  #<04-25-2013 gsl> No clamp code output when rotation is ref only.
   if { ![string compare "OFF" $mom_rotation_reference_mode] } {
      global mom_sys_auto_clamp

      if { [info exists mom_sys_auto_clamp] && [string match "ON" $mom_sys_auto_clamp] } {

         set out1 "1"
         set out2 "0"

         if { $axis == 3 } { ;# Rotate 4th axis
            AUTO_CLAMP_2 $out1
            AUTO_CLAMP_1 $out2
         } else {
            AUTO_CLAMP_1 $out1
            AUTO_CLAMP_2 $out2
         }
      }
   }


   if { $axis == 3 } {

      ####  <rws>
      ####  Use ROTREF switch ON to not output the actual 4th axis move

      if { ![string compare "OFF" $mom_rotation_reference_mode] } {
         PB_CMD_fourth_axis_rotate_move
      }

      if { ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_4th_axis_direction] } {
         set mom_prev_rot_ang_4th [expr abs($mom_out_angle_pos(0))]
      } else {
         set mom_prev_rot_ang_4th $mom_out_angle_pos(0)
      }

      MOM_reload_variable mom_prev_rot_ang_4th

   } else {

      if { [info exists mom_kin_5th_axis_direction] } {

         ####  <rws>
         ####  Use ROTREF switch ON to not output the actual 5th axis move

         if { ![string compare "OFF" $mom_rotation_reference_mode] } {
            PB_CMD_fifth_axis_rotate_move
         }

         if { ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_5th_axis_direction] } {
            set mom_prev_rot_ang_5th [expr abs($mom_out_angle_pos(1))]
         } else {
            set mom_prev_rot_ang_5th $mom_out_angle_pos(1)
         }

         MOM_reload_variable mom_prev_rot_ang_5th
      }
   }

  #<05-10-06 sws> pb351 - Uncommented next 3 lines
  #<01-07-10 wbh> Reset mom_prev_pos using the variable mom_out_angle_pos
  # set mom_prev_pos($axis) $ang
   set mom_prev_pos($axis) $mom_out_angle_pos([expr $axis-3])
   MOM_reload_variable -a mom_prev_pos
   MOM_reload_variable -a mom_out_angle_pos
}


#=============================================================
proc AUTO_CLAMP { } {
#=============================================================
#  This command is used to automatically output clamp and unclamp
#  codes.  This command must be called in the the command
#  << PB_CMD_kin_before_motion >>.  By default this command will
#  output M10 or M11 to do clamping or unclamping for the 4th axis or
#  M12 or M13 for the 5th axis.
#

  # Must be called by PB_CMD_kin_before_motion
   if { ![CALLED_BY "PB_CMD_kin_before_motion"] } {
return
   }


   global mom_pos
   global mom_prev_pos

   global mom_sys_auto_clamp

   if { ![info exists mom_sys_auto_clamp] || ![string match "ON" $mom_sys_auto_clamp] } {
return
   }


   set rotary_out [EQ_is_equal $mom_pos(3) $mom_prev_pos(3)]

   AUTO_CLAMP_1 $rotary_out

   set rotary_out [EQ_is_equal $mom_pos(4) $mom_prev_pos(4)]

   AUTO_CLAMP_2 $rotary_out
}


#=============================================================
proc AUTO_CLAMP_1 { out } {
#=============================================================
# called by AUTO_CLAMP & MOM_rotate

   global clamp_rotary_fourth_status

   if { ![info exists clamp_rotary_fourth_status] ||\
       ( $out == 0 && ![string match "UNCLAMPED" $clamp_rotary_fourth_status] ) } {

      PB_CMD_unclamp_fourth_axis
      set clamp_rotary_fourth_status "UNCLAMPED"

   } elseif { $out == 1 && ![string match "CLAMPED" $clamp_rotary_fourth_status] } {

      PB_CMD_clamp_fourth_axis
      set clamp_rotary_fourth_status "CLAMPED"
   }
}


#=============================================================
proc AUTO_CLAMP_2 { out } {
#=============================================================
# called by AUTO_CLAMP & MOM_rotate

   global mom_kin_machine_type

   set machine_type [string tolower $mom_kin_machine_type]
   switch $machine_type {
      5_axis_dual_table -
      5_axis_dual_head  -
      5_axis_head_table { }

      default           {
return
      }
   }

   global clamp_rotary_fifth_status

   if { ![info exists clamp_rotary_fifth_status] ||\
        ( $out == 0 && ![string match "UNCLAMPED" $clamp_rotary_fifth_status] ) } {

      PB_CMD_unclamp_fifth_axis
      set clamp_rotary_fifth_status "UNCLAMPED"

   } elseif { $out == 1 && ![string match "CLAMPED" $clamp_rotary_fifth_status] } {

      PB_CMD_clamp_fifth_axis
      set clamp_rotary_fifth_status "CLAMPED"
   }
}


#=============================================================
### This is the backup of original MOM_lock_axis handler.
###
### - New command PB_CMD_MOM_lock_axis is created with the
###   same content of the original command and executed
###   by the new MOM_lock_axis handler.
###
proc DUMMY_MOM_lock_axis { } {
#=============================================================
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status

   set status [SET_LOCK axis plane value]

   # Handle "error" condition returned from SET_LOCK
   # - Message in mom_warning_info
   if { ![string compare "error" $status] } {
      global mom_warning_info
      CATCH_WARNING $mom_warning_info

      set mom_sys_lock_status OFF
   } else {
      set mom_sys_lock_status $status
      if { [string compare "OFF" $status] } {
         set mom_sys_lock_axis $axis
         set mom_sys_lock_plane $plane
         set mom_sys_lock_value $value

         LOCK_AXIS_INITIALIZE
      }
   }
}


#=============================================================
proc PB_catch_warning { } {
#=============================================================
# Called by MOM_catch_warning (ugpost_base.tcl)
#
# - String with "mom_warning_info" (come from event generator or handlers)
#   may be output by MOM_catch_warning to the message file.
#
# - "mom_warning_info" will be transfered to "mom_sys_rotary_error" for
#   PB_CMD_kin_before_motion to handle the error condition.
#

  global mom_sys_rotary_error mom_warning_info

   if { [string match "ROTARY CROSSING LIMIT." $mom_warning_info] } {
      set mom_sys_rotary_error $mom_warning_info
   }

   if { [string match "secondary rotary position being used" $mom_warning_info] } {
      set mom_sys_rotary_error $mom_warning_info
   }

   if { [string match "WARNING: unable to determine valid rotary positions" $mom_warning_info] } {

     # To abort the current event
     # - Whoever handles this condition MUST unset it to avoid any lingering effect!
     #
      global mom_sys_abort_next_event
      set mom_sys_abort_next_event 1
   }
}


#=============================================================
proc MOM_lintol { } {
#=============================================================
   global mom_kin_linearization_flag
   global mom_kin_linearization_tol
   global mom_lintol_status
   global mom_lintol

   if { ![string compare "ON" $mom_lintol_status] } {
      set mom_kin_linearization_flag "TRUE"
      if { [info exists mom_lintol] } {
         set mom_kin_linearization_tol $mom_lintol
      }
   } elseif { ![string compare "OFF" $mom_lintol_status] } {
      set mom_kin_linearization_flag "FALSE"
   }
}


} ;# uplevel
#***********

}


#=============================================================
proc PB_CMD_kin_set_csys { } {
#=============================================================
# - For mill post -
#

  # Output NC code according to CSYS
   if { [CMD_EXIST PB_CMD_set_csys] } {
      PB_CMD_set_csys
   }

  # Overload IKS params from machine model.
   PB_CMD_reload_iks_parameters

  # In case Axis Rotation has been set to "reverse"
   if { [CMD_EXIST PB_CMD_reverse_rotation_vector] } {
      PB_CMD_reverse_rotation_vector
   }
}


#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
# - For mill post -
#
#  This command is executed at the start of every operation.
#  It will verify if a new head (post) was loaded and will
#  then initialize any functionality specific to that post.
#
#  It will also restore the master Start of Program &
#  End of Program event handlers.
#
#  --> DO NOT CHANGE THIS COMMAND UNLESS YOU KNOW WHAT YOU ARE DOING.
#  --> DO NOT CALL THIS COMMAND FROM ANY OTHER CUSTOM COMMAND.
#
  global mom_sys_head_change_init_program

   if { [info exists mom_sys_head_change_init_program] } {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program


     # Load alternate units' parameters
      if [CMD_EXIST PB_load_alternate_unit_settings] {
         PB_load_alternate_unit_settings
         rename PB_load_alternate_unit_settings ""
      }


     # Execute start of head callback in new post's context.
      global CURRENT_HEAD
      if { [info exists CURRENT_HEAD] && [CMD_EXIST PB_start_of_HEAD__$CURRENT_HEAD] } {
         PB_start_of_HEAD__$CURRENT_HEAD
      }

     # Restore master start & end of program handlers
      if { [CMD_EXIST "MOM_start_of_program_save"] } {
         if { [CMD_EXIST "MOM_start_of_program"] } {
            rename MOM_start_of_program ""
         }
         rename MOM_start_of_program_save MOM_start_of_program
      }
      if { [CMD_EXIST "MOM_end_of_program_save"] } {
         if { [CMD_EXIST "MOM_end_of_program"] } {
            rename MOM_end_of_program ""
         }
         rename MOM_end_of_program_save MOM_end_of_program
      }

     # Restore master head change event handler
      if { [CMD_EXIST "MOM_head_save"] } {
         if { [CMD_EXIST "MOM_head"] } {
            rename MOM_head ""
         }
         rename MOM_head_save MOM_head
      }
   }

  # Overload IKS params from machine model.
   PB_CMD_reload_iks_parameters

  # Incase Axis Rotation has been set to "reverse"
   if { [CMD_EXIST PB_CMD_reverse_rotation_vector] } {
      PB_CMD_reverse_rotation_vector
   }

  # Initialize tool time accumulator for this operation.
   if { [CMD_EXIST PB_CMD_init_oper_tool_time] } {
      PB_CMD_init_oper_tool_time
   }

  # Force out motion G code at the start of path.
   MOM_force once G_motion
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#  This command will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to any command that you want executed when a linked post is
#  loaded.
#
#  Note when a linked post is called in, the Start of Program
#  event marker is not executed again.
#
#  --> DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#      WHAT YOU ARE DOING.
#  --> DO NOT CALL THIS PROCEDURE FROM ANY
#      OTHER CUSTOM COMMAND.
#
   global mom_kin_machine_type


   set command_list [list]

   if { [info exists mom_kin_machine_type] } {
      if { ![string match "*3_axis_mill*" $mom_kin_machine_type] &&\
           ![string match "*lathe*" $mom_kin_machine_type] } {

         lappend command_list  PB_CMD_kin_init_rotary
      }
   }

   lappend command_list  PB_CMD_kin_init_new_iks

   lappend command_list  PB_CMD_init_pivot_offsets
   lappend command_list  PB_CMD_init_auto_retract
   lappend command_list  PB_CMD_initialize_parallel_zw_mode
   lappend command_list  PB_CMD_init_parallel_zw_mode
   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_initialize_spindle_axis
   lappend command_list  PB_CMD_init_spindle_axis
   lappend command_list  PB_CMD_initialize_helix
   lappend command_list  PB_CMD_init_helix
   lappend command_list  PB_CMD_pq_cutcom_initialize
   lappend command_list  PB_CMD_init_pq_cutcom

   lappend command_list  PB_CMD_kin_init_probing_cycles

   lappend command_list  PB_DEFINE_MACROS

   if { [info exists mom_kin_machine_type] } {
      if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {

         lappend command_list  PB_CMD_kin_init_mill_xzc
         lappend command_list  PB_CMD_kin_mill_xzc_init
        # lappend command_list  PB_CMD_kin_init_mill_turn
         lappend command_list  PB_CMD_kin_mill_turn_initialize
      }
   }


   foreach cmd $command_list {

      if { [CMD_EXIST "$cmd"] } {

        # <PB v2.0.2>
        # Old init commands for XZC/MILL_TURN posts are not executed.
        # Parameters set by these commands in the v2.0 legacy posts
        # will need to be transfered to PB_CMD_init_mill_xzc &
        # PB_CMD_init_mill_turn commands respectively.

         switch $cmd {
            "PB_CMD_kin_mill_xzc_init" -
            "PB_CMD_kin_mill_turn_initialize" {}
            default { eval $cmd }
         }
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_limitA { } {
#=============================================================
# AXIS TRAVEL LIMIT ON A table is -120 to +122
# ( table can really go to +123 , but we choose not to  )

# mom_out_angle_pos doesn't output anything in overtravel so allow bigger
# limits in PB and check here

global   mom_out_angle_pos mom_operation_name

if { $mom_out_angle_pos(0) < 0 } {
  set err "\n\n\n *** ROTARY AXIS OVERTRAVEL IN OPERATION $mom_operation_name *** "
  set err "$err \n \n ***          A AXIS IS $mom_out_angle_pos(0)             *** "
  set err "$err \n \n ***          LIMITS ARE +122 TO 0                   *** "
  set err "$err \n \n \n "

  MOM_abort $err
}

if { $mom_out_angle_pos(0) > 122  } {
  set err "\n\n\n *** ROTARY AXIS OVERTRAVEL IN OPERATION $mom_operation_name *** "
  set err "$err \n \n ***          A AXIS IS $mom_out_angle_pos(0)           *** "
  set err "$err \n \n ***          LIMITS ARE +122 TO 0                   *** "
  set err "$err \n \n \n "

  MOM_abort $err
}
}


#=============================================================
proc PB_CMD_limitA_visible { } {
#=============================================================
# original command which made part rotate towards operator so he could see whats going on --grin
# used to use post builder axis travel limts on A set to Min -47 and Max +180.

# AXIS TRAVEL LIMIT ON A table is +120 to -46
# ( table can really go to -120 , but we choose not to  )

# mom_out_angle_pos doesn't output anything in overtravel so allow bigger
# limits in PB and check here

global   mom_out_angle_pos mom_operation_name

if { $mom_out_angle_pos(0) < -46 } {
  set err "\n\n\n *** ROTARY AXIS OVERTRAVEL IN OPERATION $mom_operation_name *** "
  set err "$err \n \n ***          A AXIS IS $mom_out_angle_pos(0)             *** "
  set err "$err \n \n ***          LIMITS ARE -46 TO +119                   *** "
  set err "$err \n \n \n "

  MOM_abort $err
}

if { $mom_out_angle_pos(0) > 119  } {
  set err "\n\n\n *** ROTARY AXIS OVERTRAVEL IN OPERATION $mom_operation_name *** "
  set err "$err \n \n ***          A AXIS IS $mom_out_angle_pos(0)           *** "
  set err "$err \n \n ***          LIMITS ARE -46 TO +119                   *** "
  set err "$err \n \n \n "

  MOM_abort $err
}
}


#=============================================================
proc PB_CMD_linear_move { } {
#=============================================================
#
# This procedure is used my many automatic postbuilder functions
# to output a linear move.  Do NOT add this block to events or
# markers.  It is a static block and it is not intended to be added
# to events.  Do NOT change the name of this procedure.
#
# If you need a custom command to be output with a linear move block,
# you must place a call to the custom command either before or after
# the MOM_do_template command.  You may need to edit the output
# line if you have changed the name of the linear move block.
#
# This proc is used for:
#     simulated cycles feed moves
#     mill/turn mill linearization
#     four and five axis retract and re-engage
#

  MOM_do_template linear_move
}


#=============================================================
proc PB_CMD_load_fixture_offset { } {
#=============================================================
  global mom_fixture_offset_value

  MOM_suppress always N
  MOM_output_literal "G$mom_fixture_offset_value"
  MOM_suppress off N
}


#=============================================================
proc PB_CMD_log_revisions { } {
#=============================================================
# Dummy command to log changes in this post --
#
# 02-26-09 gsl - Initial version
#
}


#=============================================================
proc PB_CMD_mmperminute { } {
#=============================================================
# only after tapping
global pn_tapflag
if [info exists pn_tapflag] {
   if {$pn_tapflag == 1 } {
      set pn_tapflag 0
     MOM_output_literal "G94" ;# back to mm/min
   }
}
}


#=============================================================
proc PB_CMD_nBwork { } {
#=============================================================
#  normalise B works - called from _normalB  and from _unwindB

global mom_operation_type
global mom_out_angle_pos mom_prev_out_angle_pos
global mom_pos mom_prev_pos

    # NOTE # mom_pos(3) is mom_out_angle_pos(0) normalised to value
    # between 0&360 - so gives "remainder" value after subtracting
    # multiples of 360 degrees.

    set mom_out_angle_pos(1) $mom_pos(4)
    set mom_prev_out_angle_pos(1) $mom_pos(4)

    # this "pushes back" the values to the event generator.
    # IMPORTANT not reload of mom_prev_pos as well

         MOM_reload_variable -a mom_prev_pos
       MOM_reload_variable -a mom_out_angle_pos

       # NormalBaxis does : " G92 B$mom_out_angle_pos(1) <remainder> "
    # which is VM/MAM style. Haas Reccomendation is to
    # use G28 which _may_ be : " G91 G28 B<remainder> "
    # if so - we'll change the NormalBaxis template

#############################haas recomendation########################
#... They can, however,
#program A99720.0 (nearest multiple of 360) then program G91 G28 A0.
#With setting 108 (QUICK ROTARY G28) set to ON and parameter 43 bit 10
#(A-AXIS CIRC. WRAP) set to 1, this will effectively reset the
#Machine Coordinate for A-axis back to zero without unwinding.
#They can then continue A-axis rotation from zero.
#############################haas recomendation########################

     MOM_force once fourth_axis G fifth_axis
     MOM_do_template NormalBaxis
}


#=============================================================
proc PB_CMD_negate_R_value { } {
#=============================================================
# This command negates the value of radius when the included angle
# of an arc is greater than 180.
#
# ==> This comamnd may be added to the Circular Move event for a post
#     of Fanuc controller when the R-style circular output format is used.
#
# 10-05-11 gsl - (pb801 IR2178985) Initial version
#

   global mom_arc_angle mom_arc_radius

   if [expr $mom_arc_angle > 180.0] {
      set mom_arc_radius [expr -1*$mom_arc_radius]
   }
}


#=============================================================
proc PB_CMD_normalB { } {
#=============================================================
#  to re-zero B axis at end of VARIABLE   path - otherwise NO-OP

global mom_operation_type

set xx "Variable-axis Surface Contouring"
if { $mom_operation_type == $xx } {
  # if this is end of variable new op - normalize B

  PB_CMD_nBwork

}
}


#=============================================================
proc PB_CMD_notes_on_post { } {
#=============================================================
# qualified machine is only 3-axis

# new post
#
}


#=============================================================
proc PB_CMD_nurbs_end_of_program { } {
#=============================================================
  global nurbs_move_flag

  if {[info exists nurbs_move_flag]} {MOM_output_literal "G05 P0"}
}


#=============================================================
proc PB_CMD_nurbs_initialize { } {
#=============================================================
#
#  You will need to activate nurbs motion in Unigraphics CAM under
#  machine control to generate nurbs events.
#
#  This procedure is used to establish nurbs parameters.  It must be
#  placed in the Start of Program marker to output nurbs.
#

uplevel #0 {

  set mom_kin_nurbs_output_type              BSPLINE

  MOM_reload_kinematics

proc MOM_nurbs_move {} {
#_______________________________________________________________________________
# This procedure is executed for each nurbs move.
#_______________________________________________________________________________
  global mom_nurbs_knot_count
  global mom_nurbs_point_count
  global mom_nurbs_order

  global nurbs_knot_count
  global nurbs_precision
  global nurbs_move_flag
  global anchor_flag

  if {![info exists nurbs_move_flag]} {
    MOM_output_literal "G05 P10000"
    set nurbs_move_flag 1
  }

  FEEDRATE_SET
  if {![info exists anchor_flag]} {
    MOM_do_template anchor_point
    set anchor_flag 0
  }

  set nurbs_knot_count 0
  MOM_force once G_motion order X Y Z

  while {$nurbs_knot_count < $mom_nurbs_point_count} {
    MOM_do_template nurbs
    set nurbs_knot_count [expr $nurbs_knot_count + 1]
  }

  while {$nurbs_knot_count < $mom_nurbs_knot_count} {
    MOM_do_template knots
    set nurbs_knot_count [expr $nurbs_knot_count + 1]
  }
}




}
}


#=============================================================
proc PB_CMD_outer_text_move { } {
#=============================================================
# OUTER - thread mill
# called for each hole  when we are at clearplane over first hole
# or after previous call to this proc. at previous hole

# working parts are moved to outer_text_pass procedure - called multiple times
#
global pn_threadmill_dia pn_thread_left pn_thread_pitches pn_threadmill_stock pn_threadmill_r_passes
global pn_this_dia

set inc 0
if { $pn_threadmill_r_passes > 0 } {         ;# pass size if any ...
   set inc [ expr 1.0 * $pn_threadmill_stock / ( 1.0 + $pn_threadmill_r_passes ) ]
}
# MOM_output_literal " inc $inc "

set pn_this_dia  [ expr $pn_threadmill_dia + 2.0 * $pn_threadmill_stock ]    ;# could be threadmill_dia

# MOM_output_literal " pn_this_dia before for loop inner dia $pn_this_dia "

for { set ii 0 } { $ii <  $pn_threadmill_r_passes } { incr ii } {
  set pn_this_dia [ expr $pn_this_dia - 2 * $inc ]
  # MOM_output_literal " pn_this_dia $pn_this_dia "
  PB_CMD_outer_text_pass
}

set pn_this_dia $pn_threadmill_dia     ;#   final dia
MOM_output_literal " ( FINAL CUT $pn_this_dia DIA ) "
PB_CMD_outer_text_pass            ;# finish ( fundamental ) pass
}


#=============================================================
proc PB_CMD_outer_text_pass { } {
#=============================================================
# OUTER - pass for thread mill
# called for each pass from outer_text_move

global pn_this_dia    ;# will be pn_threadmill_dia for last ( fundamental ) pass

global mom_pos mom_cycle_rapid_to feed mom_cycle_feed_to mom_prev_pos
global mom_tool_diameter mom_tool_pitch
global thX thY thZ thI thJ thF thG
global pn_threadmill_dia pn_thread_left pn_thread_pitches
global mom_cutcom_status

#
set tr [ expr ( $pn_this_dia + $mom_tool_diameter ) / 2 ] ;# OUTER toolpath rad
# set er [ expr $tr / 2 ]
set er 3.0                 ;# OUTER engage retract rad hardwired for now
#

global mom_prev_pos ZretBetweenHoles
# ## set startZ $mom_prev_pos(2) ;# come back here at end
set startZ $ZretBetweenHoles      ;# set once and for all in PB_CMD_drill_text

# #### xy move over centre this OUTER   #####
MOM_do_template RapXYforThread

# move to point at 3 o'clock 6mm beyond stud diameter
set deltapos  [ expr $mom_pos(0) + $tr + $er + $er   ] ;# delta move destination

# temporarily change mom_pos to make output easier
set saved_mom_pos $mom_pos(0)    ;# store X of hole centre
set mom_pos(0) $deltapos    ;# delta position

MOM_do_template RapXYforThread  ;# move over delta point

# ####   z move to Rplane   #####
set thZ [ expr $mom_pos(2) + $mom_cycle_rapid_to]
MOM_do_template RapZforThread

# ####   z feed to btm      #####
set thF $feed
# # mod - start 1/8pitch lower so full thread == programmed value
set thZ [ expr $mom_pos(2) + $mom_cycle_feed_to -( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
MOM_do_template FeedZforThread

# ### xy feed to OUTER start point at -135 ( or +135 degrees for LHThread ) ###
set thX [ expr $mom_pos(0) - $er ]
set thY [ expr $mom_pos(1) - $er ]
if { $pn_thread_left == 1 } { set thY [ expr $mom_pos(1) + $er ] }

set mom_cutcom_status RIGHT    ;# reversed for OUTER
if { $pn_thread_left == 1 } { set mom_cutcom_status LEFT }
PB_CMD_fixupD
MOM_do_template FeedXYforThread

#  ### G2 in OUTER (G3 for LHT )half rad to 3oclock posn. with Z lift  of 1/8pitch ###
set thG 2

set mom_pos(0) $saved_mom_pos        ;# RESTORE hole centre

set thX [ expr $mom_pos(0) + $tr ]
set thY  $mom_pos(1)
set thZ [ expr $runningZ + ( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
set thI 0
set thJ $er
if { $pn_thread_left == 1 } { set thG 3 ; set thJ [expr -1.0 * $er ] }
# feedrate mod for engage
set thF [ expr 0.5 * $feed ]        ;# half specified feedrate entry

MOM_force once G_motion X Y I J
MOM_do_template ArcForThread

#   ### n trips round with Z increment upwards by 1 pitch   ###
for { set i 1 } { $i <= $pn_thread_pitches } { incr i }  {
    set thG 3            ;# OUTER - main cut goes opposite to arc in/out
    set thX [ expr $mom_pos(0) + $tr ]
    set thY  $mom_pos(1)
    set thZ [ expr $runningZ + $mom_tool_pitch ]
    set runningZ $thZ
    set thI [expr -1.0 * $tr ]
    set thJ 0
    if { $pn_thread_left == 1 } { set thG 2  }
    # feedrate mod for main cut
    set thF [ expr  $feed ]
    MOM_force once G_motion X Y I J
    MOM_do_template ArcForThread
}

#   ### arc out to end point at 45 ( or -45 degrees for LHThread ) ###
#       G2 out (G3 for LHT )half rad end pt with Z lift  of 1/8pitch
set thG 2    ;# OUTER

set thX [ expr $mom_pos(0) + $tr + $er ]
set thY [ expr $mom_pos(1) + $er ]
if { $pn_thread_left == 1 } { set thY [ expr $mom_pos(1) - $er ] }

set thZ [ expr $runningZ + ( $mom_tool_pitch / 8 ) ]
set runningZ $thZ
set thI [expr $er ] ;# bugfix 16nov
set thJ 0
if { $pn_thread_left == 1 } { set thG 3 }

MOM_force once G_motion X Y I J
MOM_do_template ArcForThread

#   ### xy feed to start of hole  ###
set thX  $deltapos
set thY $mom_pos(1)

set mom_cutcom_status OFF
PB_CMD_fixupD_off
MOM_do_template FeedXYforThread

#    ### Z rapid to clearplane    ###
set thZ $startZ
MOM_do_template RapZforThread
}


#=============================================================
proc PB_CMD_partno { } {
#=============================================================
# PROGRAM HEADER HERE - can't see UDE in start of program.

global mom_prog_name        ;# initialised in init-vars
global mom_mam_prog_text mom_mam_part_text ;# from UDE
global mom_path_name

global mom_parent_group_name  mom_part_name
global mom_date pn_version    mom_G10lines

# tce partno start
# if mom_part_name contains literal string "%" it's come from TCE


set percent \%

if { [string first $percent $mom_part_name ] >= 0 } {
    # TCE
    set start [expr [string first PN= $mom_part_name] + 3 ]    ;# loc of PN= in string
    set end [string range $mom_part_name $start 999]        ;# tail of string
    set blank "\ "
    set blankpos [string first $blank $end ]                ;# loc of space in string
    set partno [string toupper [string range $end 0 $blankpos]]    ;# bit from PN= to space

}  else {
    # NATIVE
    set partno [ string toupper [ file rootname [ file tail $mom_part_name ] ] ]
}

# tce partno end

MOM_output_literal "%"
MOM_output_literal "O$mom_prog_name  ( $partno ) "        ;# O1999 or UDE Val

set mom_mam_part_text [ string toupper $mom_mam_part_text   ]    ;# FIRST comment
set mom_mam_prog_text [ string toupper $mom_mam_prog_text   ]    ;# second comment

MOM_output_literal "( $mom_mam_part_text  ISSUE: $mom_mam_prog_text )"

if {[info exists mom_parent_group_name]} {set identifier_text $mom_parent_group_name} else {set identifier_text $mom_path_name}
MOM_output_literal "( NX4 Operation  $identifier_text ) "
MOM_output_literal "( [ string toupper $mom_date ] ) "
MOM_output_literal "( HAAS VF2_3axis POSTPROCESSOR VERSION $pn_version ) "

#MOM_output_literal "M98 P9000 "
MOM_do_template absolute_mode     ;# G90 etc..
MOM_output_literal "G187"     ;#

MOM_output_literal "   "        ;#
MOM_output_literal "G91 G28 Z0.0 M09 "
MOM_output_literal "G90 "
#MOM_output_literal "M11 "
#MOM_output_literal "M13 "
#MOM_output_literal "G0 A0.0 B0.0 "
MOM_output_literal "    "
}


#=============================================================
proc PB_CMD_pause { } {
#=============================================================
  set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]

  if { [file exists ${cam_aux_dir}ugwish.exe] && [file exists ${cam_aux_dir}mom_pause.tcl] } {
    exec ${cam_aux_dir}ugwish.exe ${cam_aux_dir}mom_pause.tcl
  }
}


#=============================================================
proc PB_CMD_program_header { } {
#=============================================================
#
#  This procedure will output a program header with the following format:
#
#       Attribute assigned to program (Name of program group)
#
#       Example: O0001 (NC_PROGRAM)
#
#
#  Place this custom command in the start of program event marker.  This
#  custom command must be placed after any initial codes (such as #).  The
#  custom command MOM_set_seq_off must precede this custom command to
#  prevent sequence numbers from being output with the program number.
#
#  If you are adding this custom command to a linked post, this custom
#  command must be added to the main post only.  It will not be output by
#  any subordinate posts.
#
#  If there is no attribute assigned to the program group, the string O0001
#  will be used.  In any case the name of the program in Program View will
#  be output as a comment.
#
#  To assign an attribute to the program, right click on the program.  Under
#  properties, select attribute.  Use the string "program_number" as the
#  title of the attribute.  Enter the string you need for the program
#  name, O0010 for example, as the value of the attribute.  Use type string for the
#  the attribute.  Each program group can have a unique program number.
#


global mom_attr_PROGRAMVIEW_PROGRAM_NUMBER
global mom_group_name

if {![info exists mom_group_name]} {set mom_group_name ""}
if {![info exists mom_attr_PROGRAMVIEW_PROGRAM_NUMBER]} {set mom_attr_PROGRAMVIEW_PROGRAM_NUMBER "O0$mom_group_name"}
MOM_output_literal "$mom_attr_PROGRAMVIEW_PROGRAM_NUMBER"
}


#=============================================================
proc PB_CMD_rapid_nanny { } {
#=============================================================
# called from first-move, initial-move,
# to prevent user programming moves which are normally Rapid at Feedrate
# which can lead to variables not being initialised the post.
#
# this could be called from ordinary linear feedrate move as well.
# # not done to keep linear uncluttered #
# use in first- and initial-move traps case where user sets Rapid == Feed
# for whole operation.
# other possibly case is where ( say ) non-cutting moves for Check avoidance
# are programmed for feedrate, not rapid. that's not a problem - as everything
# will be initialised by then...

global mom_motion_type mom_operation_name mom_programmed_feed_rate feed

if { $mom_motion_type != "RAPID" } {  return }

if { $mom_programmed_feed_rate != 0 } {
      set err "\n\n\n *** ILLEGAL RAPID FEEDRATE IN $mom_operation_name *** "
      set err " $err  \n\n\n *** RAPID FEEDRATE SET TO $feed *** "
      set err " $err \n *** SHOULD BE SET TO 0 IN THIS POST *** "
      set err "$err \n \n \n "

    MOM_abort $err
}
}


#=============================================================
proc PB_CMD_reload_iks_parameters { } {
#=============================================================
# This command overloads new IKS params from a machine model.(NX4)
# It will be executed automatically at the start of each path
# or when CSYS has changed.
#
   global mom_csys_matrix
   global mom_kin_iks_usage

  #----------------------------------------------------------
  # Set a classification to fetch kinematic parameters from
  # a particular set of K-components of a machine.
  # - Default is NONE.
  #----------------------------------------------------------
   set custom_classification NONE

   if { [info exists mom_kin_iks_usage] && $mom_kin_iks_usage == 1 } {
      if [info exists mom_csys_matrix] {
         if [llength [info commands MOM_validate_machine_model] ] {
            if { [MOM_validate_machine_model] == "TRUE" } {
               MOM_reload_iks_parameters "$custom_classification"
               MOM_reload_kinematics
            }
         }
      }
   }
}


#=============================================================
proc PB_CMD_replacement_procedures { } {
#=============================================================
# modified standard procedures

proc MOM_catch_warning {} {
#_______________________________________________________________________________
# This procedure generates the warnings for missing procedures and values
# falling out of MIN/MAX.
#_______________________________________________________________________________
  global mom_warning_info
  global warn_file list_file warn_count
  global group_warn_file group_list_file group_warn_count
  global mom_sequence_mode mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_motion_type

  if {[regexp "MOM_msys" $mom_warning_info] == 1} { return }
  if {[regexp "MOM_machine_mode" $mom_warning_info] == 1} { return }
  if {[regexp "MOM_origin" $mom_warning_info] == 1} { return }
  if {[regexp "MOM_translate" $mom_warning_info] == 1} { return }
  if {[regexp "MOM_lintol" $mom_warning_info] == 1} { return }
  if {[regexp "MOM_tlset" $mom_warning_info] == 1} { return }

  if {![info exists mom_motion_type]} { set mom_motion_type "UNSET" }
  if { $mom_motion_type == "RAPID" && [regexp "FEED RATE LIMIT" $mom_warning_info] == 1} { return }

  # if {[regexp "FEED RATE LIMIT" $mom_warning_info] == 1} {
#    MOM_output_literal " ( FEED RATE LIMIT HERE ) "
#     MOM_output_literal " ( FEED RATE LIMIT HERE ) "
#     MOM_output_literal " ( FEED RATE LIMIT HERE ) "
#     MOM_output_literal " ( FEED RATE LIMIT HERE ) "
#
#   return }


  catch {PB_catch_warning}

  if { [regexp  "mom_seqnum" $mom_warning_info] == 1 } {
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency
  }

  if {[hiset warn_file]} {
    puts $warn_file "$mom_warning_info " ; incr warn_count +1
    if {[hiset list_file]} {puts $list_file "$mom_warning_info "}
  }
  if {[hiset group_warn_file]} {
    puts $group_warn_file "$mom_warning_info " ; incr group_warn_count +1
    if {[hiset group_list_file]} {puts $group_list_file "$mom_warning_info "}
  }
}

proc MOM_SafeIndex {} { # no-op }
proc MOM_prog_identifier { } { # no-op }
}


#=============================================================
proc PB_CMD_reposition_move { } {
#=============================================================
#
#  This procedure is used by rotary axis retract to reposition the
#  rotary axes after the tool has been fully retracted.
#
#  You can modify the this procedure to customize the reposition move.
#  If you need a custom command to be output with this block,
#  you must place a call a the custom command either before or after
#  the MOM_do_template command.
#
   MOM_suppress once X Y Z
   MOM_do_template rapid_traverse
}


#=============================================================
proc PB_CMD_restore_active_oper_tool_data { } {
#=============================================================
#  This command restores the attributes of the tool used in the current operation
#  to be post-processed before the generation of the tool list.
#  The attributes have been saved in proc PB_CMD_save_active_oper_tool_data.
#
#  This command wil be executed automatically in PB_CMD_create_tool_list.
#
#-------------------------------------------------------------
# 04-30-13 gsl - Enhanced to handle array variables
#

   global mom_sys_oper_tool_attr_list
   global mom_sys_oper_tool_attr_saved_arr

   foreach mom_var $mom_sys_oper_tool_attr_list {
      global $mom_var
      if [info exists mom_sys_oper_tool_attr_saved_arr($mom_var)] {
         if [array exists $mom_var] {
           array set $mom_var $mom_sys_oper_tool_attr_saved_arr($mom_var)
         } else {
           set $mom_var $mom_sys_oper_tool_attr_saved_arr($mom_var)
         }
      }
   }
}


#=============================================================
proc PB_CMD_restore_work_plane_change { } {
#=============================================================
#<02-18-08 gsl> Restore work plane change flag, if being disabled due to a simulated cycle.

  global mom_user_work_plane_change mom_sys_work_plane_change
  global mom_user_spindle_first spindle_first

  if { [info exists mom_user_work_plane_change] } {
    set mom_sys_work_plane_change $mom_user_work_plane_change
    set spindle_first $mom_user_spindle_first
    unset mom_user_work_plane_change
    unset mom_user_spindle_first
  }
}


#=============================================================
proc PB_CMD_retract_move { } {
#=============================================================
#
#  This procedure is used by rotary axis retract to move away from
#  the part.  This move is a three axis move along the tool axis at
#  a retract feedrate.
#
#  You can modify the this procedure to customize the retract move.
#  If you need a custom command to be output with this block,
#  you must place a call to the custom command either before or after
#  the MOM_do_template command.
#
#  If you need to modify the x,y or z locations you will need to do the
#  following.  (without the #)
#
#  global mom_pos
#  set mom_pos(0) 1.0
#  set mom_pos(1) 2.0
#  set mom_pos(2) 3.0

   MOM_do_template linear_move
}


#=============================================================
proc PB_CMD_reverse_rotation_vector { } {
#=============================================================
# This command fixes the vectors of rotary axes.
# It will be executed automatically when present.
# Do not attach it with any Event markers.
#

  global mom_kin_iks_usage
  global mom_csys_matrix

   set reverse_vector 0

   if { [info exists mom_kin_iks_usage] && $mom_kin_iks_usage == 1 } {
      if { [info exists mom_csys_matrix] } {
         if { [llength [info commands MOM_validate_machine_model] ] } {
            if { [MOM_validate_machine_model] == "TRUE" } {
               set reverse_vector 1
            }
         }
      }
   }

   if $reverse_vector {

     global mom_kin_4th_axis_vector mom_kin_5th_axis_vector
     global mom_kin_4th_axis_rotation mom_kin_5th_axis_rotation

      foreach axis { 4th_axis 5th_axis } {

         if { [info exists mom_kin_${axis}_rotation] && [string match "reverse" [set mom_kin_${axis}_rotation]] } {

            if { [info exists mom_kin_${axis}_vector] } {
               foreach i { 0 1 2 } {
                  set mom_kin_${axis}_vector($i) [expr -1 * [set mom_kin_${axis}_vector($i)]]
               }
            }
         }
      }

      MOM_reload_kinematics
   }
}


#=============================================================
proc PB_CMD_revert_dual_head_kin_vars { } {
#=============================================================
# Only dual-head 5-axis mill posts will be affected by this
# command.
#
# This command reverts kinematic parameters for dual-head 5-axis
# mill posts to maintain compatibility and to allow the posts
# to run in UG/Post prior to NX3.
#
# Attributes of the 4th & 5th Addresses, their locations in
# the Master Word Sequence and all the Blocks that use these
# Addresses will be reconditioned with call to
#
#     PB_swap_dual_head_elements
#
#-------------------------------------------------------------
# 04-15-05 gsl - Added for PB v3.4
#-------------------------------------------------------------

  global mom_kin_machine_type


  if { ![string match  "5_axis_dual_head"  $mom_kin_machine_type] } {
return
  }


  set var_list { ang_offset center_offset(0) center_offset(1) center_offset(2) direction incr_switch leader limit_action max_limit min_incr min_limit plane rotation zero }

  set center_offset_set 0

  foreach var $var_list {
    # Global declaration
    if { [string match "center_offset*" $var] } {
      if { !$center_offset_set } {
         global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
         set center_offset_set 1
      }
    } else {
      global mom_kin_4th_axis_[set var] mom_kin_5th_axis_[set var]
    }

    # Swap values
    set val [set mom_kin_4th_axis_[set var]]
    set mom_kin_4th_axis_[set var] [set mom_kin_5th_axis_[set var]]
    set mom_kin_5th_axis_[set var] $val
  }

  # Update kinematic parameters
  MOM_reload_kinematics


  # Swap address leaders
  global mom_sys_leader

  set val $mom_sys_leader(fourth_axis)
  set mom_sys_leader(fourth_axis) $mom_sys_leader(fifth_axis)
  set mom_sys_leader(fifth_axis)  $val

  # Swap elements in definition file
  if { [llength [info commands PB_swap_dual_head_elements] ] } {
     PB_swap_dual_head_elements
  }
}


#=============================================================
proc PB_CMD_revise_new_iks { } {
#=============================================================
# This command is executed automatically, which allows you
# to change the default IKS parameters or disable the IKS
# service completely.
#
# *** Do not attach this command to any event marker! ***
#
   global mom_kin_iks_usage
   global mom_kin_rotary_axis_method
   global mom_kin_spindle_axis
   global mom_kin_4th_axis_vector
   global mom_kin_5th_axis_vector


  # Uncomment next statement to disable new IKS service
  # set mom_kin_iks_usage           0


  # Uncomment next statement to change rotary solution method
  # set mom_kin_rotary_axis_method  "ZERO"


  # Uncomment next statement, if any parameter above has changed.
  # MOM_reload_kinematics
}


#=============================================================
proc PB_CMD_sameTool_superstop { } {
#=============================================================
# conditinally between two ops with same tool - if user programs superstop
# triggers a bogus toolchange

# this 5x version returns some axes to original positions ( 3x doesn't )

# reinstated...

global js_HON_status js_superstop_flag js_blockno

if { $js_superstop_flag == 0 } { return }
set js_superstop_flag 0

if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED OFF ) "
    MOM_output_literal "G187 "  ;# for haas set high speed default

}

global mom_pos mom_out_angle_pos
global sstX sstY sstA sstB    ;# positions of ab xy at end of prev. op

MOM_output_literal "G91 G28 Z0. "
MOM_output_literal "G28 Y0. "    ;# 3 line gohome

MOM_output_literal "M09 "
MOM_output_literal "M05 "
MOM_output_literal "   "

global mom_superstop_type

#MOM_do_template AClampOff    ;# M13
#MOM_do_template BClampOff    ;# M11

if {[info exists mom_superstop_type ] } {
    if { $mom_superstop_type == "OPTIONALSTOP"  } {
        MOM_output_literal "M01 "
    } else {
        MOM_output_literal "M00 "
    }
} else {
    # no type, old ude
    MOM_output_literal "M00 "
}

global mom_superstop_text
if {[info exists mom_superstop_text ] } {
   if { $mom_superstop_text != "" } {
     MOM_output_literal " ( [string toupper $mom_superstop_text ] ) "
   }
}
MOM_output_literal "   "

# Restate tool change  here
PB_CMD_setN        ;# will give N2701
MOM_force once M
MOM_do_template tool_change_1
MOM_do_template tool_change_2

if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED ON ) "
        MOM_output_literal "G187 E0.5 "  ;#  for haas set high speed on
}
MOM_output_literal "G90  "

# RESTORE LAST KNOWN A THEN B THEN XY NOW5x only
set  mom_pos(0) $sstX        ;# restore last known pos from proc superstop
set  mom_pos(1) $sstY
set  mom_out_angle_pos(0) $sstA ;# restore  pos
set  mom_out_angle_pos(1) $sstB

MOM_force once G_motion fourth_axis fifth_axis
#MOM_do_template AClampOff        ;#  M11
#MOM_do_template BClampOff        ;#  M13

MOM_do_template Aaxis        ;# return to last known posn
MOM_force once G_motion
MOM_do_template Baxis        ;# in case user's been jogging

#MOM_do_template AClampOn       ;# M10
#MOM_do_template BClampOn       ;# M12

MOM_force once G_motion X Y
MOM_do_template RapXYforThread    ;# misnomer here G0 X Y
# END RESTORE

MOM_force once X Y Z R F  S M_spindle
}


#=============================================================
proc PB_CMD_save_active_oper_tool_data { } {
#=============================================================
#  This command saves the attributes of the tool used in the current operation
#  to be post-processed before the generation of the tool list.
#
#  This command will be executed automatically in PB_CMD_create_tool_list.
#
#  You may add any desired MOM variable to the list below to be restored
#  later in your post.
#
#-------------------------------------------------------------
# 04-30-13 gsl - Enhanced to handle array variables
#

   global mom_sys_oper_tool_attr_list
   global mom_sys_oper_tool_attr_saved_arr


  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  # You may add any MOM variables that need to be retained for
  # the operation to the list below (using lappend command).
  #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   set mom_sys_oper_tool_attr_list [list]

    lappend mom_sys_oper_tool_attr_list  mom_tool_number
    lappend mom_sys_oper_tool_attr_list  mom_tool_length_adjust_register
    lappend mom_sys_oper_tool_attr_list  mom_tool_name
    lappend mom_sys_oper_tool_attr_list  mom_operation_name


   foreach mom_var $mom_sys_oper_tool_attr_list {
      global $mom_var
      if [info exists $mom_var] {
         if [array exists $mom_var] {
            set mom_sys_oper_tool_attr_saved_arr($mom_var) [array get $mom_var]
         } else {
            set mom_sys_oper_tool_attr_saved_arr($mom_var) [eval format %s $$mom_var]
         }
      }
   }
}


#=============================================================
proc PB_CMD_save_tablepos { } {
#=============================================================
# Save last known table pos - at end of rapid, linear
global js_lastB js_lastA mom_out_angle_pos

set js_lastA $mom_out_angle_pos(0)
set js_lastB $mom_out_angle_pos(1)
}


#=============================================================
proc PB_CMD_setN { } {
#=============================================================
# This command sets block no. for output on toolchange only

global js_blockno mom_tool_number
global pn_used_tool_numbers             ;# array for used numbers

if { ![info exists pn_used_tool_numbers] } {      ;# first time only
    set i 0                    ;# initialise all to zero
    while { $i < 100 } {
    set pn_used_tool_numbers($i) 0
    incr i
   }
}
set counter 0                     ;# start of array
set repeat_no 0                    ;# added to Nnumber
while { $pn_used_tool_numbers($counter) != 0 } { ;# check each pre-used toolno.

    if { $pn_used_tool_numbers($counter) == $mom_tool_number } {
        incr repeat_no            ;# if seen before need a repeat no
    }

    incr counter
    }

# add _current_ toolno to array for checking next time
set pn_used_tool_numbers($counter) $mom_tool_number

# calculate tool number including borrowed repeat no.)
set js_blockno [expr 100 * $mom_tool_number + $repeat_no ]


#V0.10 don't presel tool in spindle
global mom_next_tool_number pn_next_tool_number

set pn_next_tool_number $mom_next_tool_number
if { $mom_next_tool_number == $mom_tool_number } { set pn_next_tool_number 24 }
}


#=============================================================
proc PB_CMD_set_csys { } {
#=============================================================
#  This custom command is provided as the default to nullify
#  the same command in a linked post that may have been
#  imported from pb_cmd_coordinate_system_rotation.tcl.
}


#=============================================================
proc PB_CMD_set_cycle_plane { } {
#=============================================================
#
# Use this command to determine and output proper plane code
# when G17/18/19 is used in the cycle definition.
#


 #+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 # Next option can be set to 1, if the address of cycle's
 # principal axis needs to be suppressed. (Ex. siemens controller)
 #+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  set suppress_principal_axis 0


 #++++++++++++++++++++++++++++++++++++++++++++++++++++++
 # Next option can be set to 1, if the plane code needs
 # to be forced out @ the start of every set of cycles.
 #++++++++++++++++++++++++++++++++++++++++++++++++++++++
  set force_plane_code 0


  global mom_kin_machine_type
  global mom_kin_4th_axis_type mom_kin_4th_axis_plane
  global mom_kin_5th_axis_type
  global mom_tool_axis mom_sys_spindle_axis mom_kin_spindle_axis
  global mom_pos
  global mom_cycle_spindle_axis mom_cutcom_plane mom_pos_arc_plane


 # Default cycle spindle axis to Z
  set mom_cycle_spindle_axis 2


  if { ![string match "*3_axis_mill*" $mom_kin_machine_type] } {

    if { $mom_kin_4th_axis_type == "Head" } {

      if [EQ_is_equal [expr abs($mom_tool_axis(0))] 1.0] {
        set mom_cycle_spindle_axis 0
      }

      if [EQ_is_equal [expr abs($mom_tool_axis(1))] 1.0] {
        set mom_cycle_spindle_axis 1
      }

      if { $mom_kin_5th_axis_type == "Table" } {

        if [EQ_is_equal [expr abs($mom_pos(3))] 90.0] {

          switch $mom_kin_4th_axis_plane {
            "YZ" {
              set mom_cycle_spindle_axis 1
            }
            "ZX" {
              set mom_cycle_spindle_axis 0
            }
          }
        }
      }
    }
  }


  switch $mom_cycle_spindle_axis {
    0 {
      set mom_cutcom_plane  YZ
      set mom_pos_arc_plane YZ
      set principal_axis X
    }
    1 {
      set mom_cutcom_plane  ZX
      set mom_pos_arc_plane ZX
      set principal_axis Y
    }
    2 {
      set mom_cutcom_plane  XY
      set mom_pos_arc_plane XY
      set principal_axis Z
    }
    default {
      set mom_cutcom_plane  UNDEFINED
      set mom_pos_arc_plane UNDEFINED
      set principal_axis ""
    }
  }


  if { $suppress_principal_axis && [string length $principal_axis] > 0 } {
    MOM_suppress once $principal_axis
  }


  if { $force_plane_code } {
    global cycle_init_flag

    if { [info exists cycle_init_flag] && [string match "TRUE" $cycle_init_flag] } {
      MOM_force once G_plane
    }
  }
}


#=============================================================
proc PB_CMD_set_oper_tool_time { } {
#=============================================================
#  This command will be executed automatically in the "End of Path" marker
#  to set the machining time accumulated on the tool used in the operation.
#
#
   global mom_machine_time
   global mom_tool_name mom_operation_name mom_sys_tool_time
   global mom_sys_prev_machine_time

   if { ![info exists mom_sys_prev_machine_time] } {
      set mom_sys_prev_machine_time 0
   }

   set curr_machine_time [expr $mom_machine_time - $mom_sys_prev_machine_time]
   set mom_sys_prev_machine_time $mom_machine_time

   set mom_sys_tool_time($mom_tool_name,$mom_operation_name) $curr_machine_time
   lappend mom_sys_tool_time($mom_tool_name,oper_list) $mom_operation_name
}


#=============================================================
proc PB_CMD_set_principal_axis { } {
#=============================================================
# This command can be used to determine the principal axis.
#
# <06-22-09 gsl> - Extracted from PB_CMD_set_cycle_plane
# <10-09-09 gsl> - Do not define mom_pos_arc_plane unless it doesn't exist.
# <03-10-10 gsl> - Respect tool axis for 3-axis & XZC cases
#

   global mom_cycle_spindle_axis
   global mom_spindle_axis
   global mom_cutcom_plane mom_pos_arc_plane


  # Initialization spindle axis
   global mom_kin_spindle_axis
   global mom_sys_spindle_axis
   if { ![info exists mom_kin_spindle_axis] } {
      set mom_kin_spindle_axis(0) 0.0
      set mom_kin_spindle_axis(1) 0.0
      set mom_kin_spindle_axis(2) 1.0
   }
   if { ![info exists mom_sys_spindle_axis] } {
      VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
   }
   if { ![info exists mom_spindle_axis] } {
      VMOV 3 mom_sys_spindle_axis mom_spindle_axis
   }


  # Default cycle spindle axis to Z
   set mom_cycle_spindle_axis 2


  #<03-10-10 gsl> pb751 - Respect tool axis for 3-axis & XZC
   global mom_kin_machine_type mom_tool_axis
   if [string match "3_axis*" $mom_kin_machine_type] {
      VMOV 3 mom_tool_axis spindle_axis
   } else {
      VMOV 3 mom_spindle_axis spindle_axis
   }


   if { [EQ_is_equal [expr abs($spindle_axis(0))] 1.0] } {
      set mom_cycle_spindle_axis 0
   }

   if { [EQ_is_equal [expr abs($spindle_axis(1))] 1.0] } {
      set mom_cycle_spindle_axis 1
   }


   switch $mom_cycle_spindle_axis {
      0 {
         set mom_cutcom_plane  YZ
      }
      1 {
         set mom_cutcom_plane  ZX
      }
      2 {
         set mom_cutcom_plane  XY
      }
      default {
         set mom_cutcom_plane  UNDEFINED
      }
   }


   if { ![info exists mom_pos_arc_plane] } {
      set mom_pos_arc_plane $mom_cutcom_plane
   }
}


#=============================================================
proc PB_CMD_sim_cycle_bore_back_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_cycle_feed_to_pos

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  SIM_RAPID mom_cycle_retract_to_pos
}


#=============================================================
proc PB_CMD_sim_cycle_bore_drag_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_cycle_feed_to_pos

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  MOM_do_template spindle_off
  SIM_RAPID mom_cycle_retract_to_pos
  MOM_force once M_spindle
  MOM_do_template spindle_rpm
}


#=============================================================
proc PB_CMD_sim_cycle_bore_dwell_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_cycle_feed_to_pos
  global sim_delay_value mom_cycle_delay

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos

  if {![info exists mom_cycle_delay]} {
    set mom_delay_value 2.0
  } else {
    set mom_delay_value $mom_cycle_delay
  }

  MOM_force once dwell G
  MOM_do_template delay
  SIM_FEED mom_cycle_rapid_to_pos
  SIM_RTRCTO
  MOM_force once M_spindle
  MOM_do_template spindle_rpm
}


#=============================================================
proc PB_CMD_sim_cycle_bore_manual_dwell_move { } {
#=============================================================
  global mom_cycle_feed_to_pos mom_cycle_rapid_to_pos
  global sim_delay_value mom_cycle_delay

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos

  if {![info exists mom_cycle_delay]} {
    set mom_delay_value 2.0
  } else {
    set mom_delay_value $mom_cycle_delay
  }

  MOM_force once dwell G
  MOM_do_template delay
  MOM_do_template stop
}


#=============================================================
proc PB_CMD_sim_cycle_bore_manual_move { } {
#=============================================================
  global mom_cycle_rapid_to_pos mom_cycle_feed_to_pos

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  MOM_do_template stop
}


#=============================================================
proc PB_CMD_sim_cycle_bore_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_cycle_feed_to_pos

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  SIM_FEED mom_cycle_rapid_to_pos
  SIM_RTRCTO
}


#=============================================================
proc PB_CMD_sim_cycle_bore_no_drag_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_sys_spindle_axis
  global nodrag_offset_move mom_cycle_feed_to_pos mom_cycle_orient
  global mom_cycle_retract_to mom_cycle_feed_to

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos

  if {![info exists mom_spindle_orient_code]} {
    set mom_spindle_orient_code 19
  }

  MOM_output_literal "M$mom_spindle_orient_code"
  if {![info exists mom_cycle_orient]} {set mom_cycle_orient .1}
  set ndv(0) 1.0
  set ndv(1) 0.0
  set ndv(2) 0.0
  set dot [VEC3_dot ndv mom_sys_spindle_axis]

  if {[EQ_is_equal [expr abs($dot)] 1.0]} {
    set ndv(0) 0.0
    set ndv(1) 1.0
  }

  VEC3_cross mom_sys_spindle_axis ndv offset

  for {set i 0} {$i < 3} {incr i} {
    set pos($i) [expr $mom_cycle_feed_to_pos($i) + $offset($i)*$mom_cycle_orient]
    set pos1($i) [expr $pos($i) + $mom_sys_spindle_axis($i)*($mom_cycle_retract_to+$mom_cycle_feed_to)]
  }

  SIM_RAPID pos
  SIM_RAPID pos1
  MOM_force once M_spindle
  MOM_do_template spindle_rpm
}


#=============================================================
proc PB_CMD_sim_cycle_drill_break_chip_move { } {
#=============================================================
  global mom_cycle_step1 top_of_hole mom_cycle_rapid_to mom_cycle_rapid_to_pos
  global mom_cycle_feed_to mom_sys_spindle_axis mom_cycle_retract_to_pos
  global mom_kin_machine_resolution mom_warning_info
#<sws 5100196>
  if {$mom_cycle_step1 < $mom_kin_machine_resolution} {
    set mom_warning_info "Cycle step increment not specified, Drilling cycle will be output."
    MOM_catch_warning
    PB_CMD_sim_cycle_drill_move
    return
  }
#<sws>

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos

  set deep_depth [expr -$mom_cycle_step1]
  set rapid_pos $mom_cycle_rapid_to

  while { $mom_cycle_feed_to < $deep_depth } {
    set deep_rapto [expr $deep_depth + $mom_cycle_rapid_to + $mom_cycle_step1 ]
    if { $rapid_pos > $deep_rapto } {
      for {set i 0} {$i < 3} {incr i} {
        set pos($i) [expr $top_of_hole($i) + $deep_rapto*$mom_sys_spindle_axis($i)]
      }
      SIM_RAPID pos
    }
    for {set i 0} {$i < 3} {incr i} {
      set pos($i) [expr $top_of_hole($i) + $deep_depth*$mom_sys_spindle_axis($i)]
    }
    SIM_FEED pos
    set deep_depth [expr $deep_depth - $mom_cycle_step1]
  }

  set deep_rapto [expr $deep_depth + $mom_cycle_rapid_to + $mom_cycle_step1 ]

  if { $rapid_pos > $deep_rapto } {
    for {set i 0} {$i < 3} {incr i} {
      set pos($i) [expr $top_of_hole($i) + $deep_rapto*$mom_sys_spindle_axis($i)]
    }
    SIM_RAPID pos
  }

  for {set i 0} {$i < 3} {incr i} {
#<sws 5100196>
    set pos($i) [expr $top_of_hole($i) + $mom_cycle_feed_to*$mom_sys_spindle_axis($i)]
  }

  SIM_FEED pos
  SIM_RAPID mom_cycle_retract_to_pos
}


#=============================================================
proc PB_CMD_sim_cycle_drill_deep_move { } {
#=============================================================
  global mom_cycle_step1 top_of_hole mom_cycle_rapid_to mom_cycle_rapid_to_pos
  global mom_cycle_feed_to mom_sys_spindle_axis mom_cycle_retract_to_pos
  global mom_kin_machine_resolution mom_warning_info

#<sws 5100196>
  if {$mom_cycle_step1 < $mom_kin_machine_resolution} {
    set mom_warning_info "Cycle step increment not specified, Drilling cycle will be output."
    MOM_catch_warning
    PB_CMD_sim_cycle_drill_move
    return
  }
#<sws 5100196>

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos

  set deep_depth [expr -$mom_cycle_step1]
  set rapid_pos $mom_cycle_rapid_to

  while { $mom_cycle_feed_to < $deep_depth } {
    set deep_rapto [expr $deep_depth + $mom_cycle_rapid_to + $mom_cycle_step1 ]
    if { $rapid_pos > $deep_rapto } {
      for {set i 0} {$i < 3} {incr i} {
        set pos($i) [expr $top_of_hole($i) + $deep_rapto*$mom_sys_spindle_axis($i)]
      }
      SIM_RAPID pos
    }
    for {set i 0} {$i < 3} {incr i} {
      set pos($i) [expr $top_of_hole($i) + $deep_depth*$mom_sys_spindle_axis($i)]
    }
    SIM_FEED pos
    SIM_RAPID mom_cycle_rapid_to_pos
    set deep_depth [expr $deep_depth - $mom_cycle_step1]
  }

  set deep_rapto [expr $deep_depth + $mom_cycle_rapid_to + $mom_cycle_step1 ]

  if { $rapid_pos > $deep_rapto } {
    for {set i 0} {$i < 3} {incr i} {
      set pos($i) [expr $top_of_hole($i) + $deep_rapto*$mom_sys_spindle_axis($i)]
    }
    SIM_RAPID pos
  }

  for {set i 0} {$i < 3} {incr i} {
#<sws 5100196>
    set pos($i) [expr $top_of_hole($i) + $mom_cycle_feed_to*$mom_sys_spindle_axis($i)]
  }

  SIM_FEED pos
  SIM_RAPID mom_cycle_retract_to_pos
}


#=============================================================
proc PB_CMD_sim_cycle_drill_dwell_move { } {
#=============================================================
  global mom_cycle_rapid_to_pos mom_cycle_feed_to_pos mom_cycle_rapid_to_pos
  global mom_delay_value mom_cycle_delay mom_cycle_retract_to_pos

  CYCLE_TOOL_AXIS
  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos

  if {![info exists mom_cycle_delay]} {
    set mom_delay_value 2.0
  } else {
    set mom_delay_value $mom_cycle_delay
  }

  MOM_force once dwell G
  MOM_do_template delay
  SIM_RAPID mom_cycle_retract_to_pos
}


#=============================================================
proc PB_CMD_sim_cycle_drill_move { } {
#=============================================================
  global mom_cycle_rapid_to_pos mom_cycle_feed_to_pos mom_cycle_retract_to_pos

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  SIM_RAPID mom_cycle_retract_to_pos
}


#=============================================================
proc PB_CMD_sim_cycle_tap_move { } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_cycle_feed_to_pos
  global mom_spindle_direction

  CYCLE_TOOL_AXIS

  SIM_RAPID_APPROACH mom_cycle_rapid_to_pos
  SIM_FEED mom_cycle_feed_to_pos
  MOM_do_template spindle_off
  set save_dir $mom_spindle_direction

  if { ![string compare "CLW" $mom_spindle_direction] } {
    set mom_spindle_direction "CCLW"
  } elseif { ![string compare "CCLW" $mom_spindle_direction] } {
    set mom_spindle_direction "CLW"
  }

  MOM_do_template spindle_rpm
  SIM_FEED mom_cycle_rapid_to_pos
  set mom_spindle_direction $save_dir
  SIM_RTRCTO
}


#=============================================================
proc PB_CMD_start_of_alignment_character { } {
#=============================================================
 # This command can be used to output a special sequence number character.
 # Replace the ":" with any character that you require.
 # You must use the command "PB_CMD_end_of_alignment_character" to reset
 # the sequence number back to the original setting.

  global mom_sys_leader saved_seq_num

  set saved_seq_num $mom_sys_leader(N)
  set mom_sys_leader(N) ":"
}


#=============================================================
proc PB_CMD_start_of_operation_force_addresses { } {
#=============================================================
MOM_force once X Y Z F R fourth_axis
}


#=============================================================
proc PB_CMD_superstop { } {
#=============================================================
# replace standard STOP code

proc  MOM_superstop {} {
    global js_superstop_flag mom_pos mom_out_angle_pos
    set js_superstop_flag 1

    # For 5x case only - need to store xy ab before-stop
    #  ie. at moment that superstop is called at end of previous operation
    # because same_tool_superstop proc restores them
    global sstX sstY sstA sstB

    set sstX $mom_pos(0)        ;# store present xypos
    set sstY $mom_pos(1)
    set sstA $mom_out_angle_pos(0)        ;# store present pos
    set sstB $mom_out_angle_pos(1)

}
}


#=============================================================
proc PB_CMD_superstop_old { } {
#=============================================================
# replace standard STOP code to do what user wants

proc  MOM_superstop {} {

global js_HON_status js_superstop_flag js_blockno

if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED OFF ) "
    MOM_output_literal "G187 "  ;# for haas set high speed
}

global mom_pos
set tX $mom_pos(0)        ;# store present pos
set tY $mom_pos(1)

set tA $mom_pos(3)        ;# store present pos
set tB $mom_pos(4)

MOM_output_literal "G91 G28 Z0. "
MOM_output_literal "G28 Y0. "    ;# 3 line gohome
# MOM_output_literal "G28 X0 "
MOM_output_literal "M09 "
MOM_output_literal "M05 "
MOM_output_literal "   "

global mom_superstop_type

MOM_do_template AClampOff    ;# M13
MOM_do_template BClampOff    ;# M11

 if {[info exists mom_superstop_type ] } {
    if { $mom_superstop_type == "OPTIONALSTOP"  } {
        MOM_output_literal "M01 "
    } else {
        MOM_output_literal "M00 "
    }
} else {
    # no type, old ude
    MOM_output_literal "M00 "
}

global mom_superstop_text
if {[info exists mom_superstop_text ] } {
   if { $mom_superstop_text != "" } {
     MOM_output_literal " ( [string toupper $mom_superstop_text ] ) "
   }
}
MOM_output_literal "   "

# Restate tool change  here
# incr js_blockno     ;# will give N2701
PB_CMD_setN

MOM_do_template tool_change_1
MOM_do_template tool_change_2

if { $js_HON_status == "TRUE" } {
    MOM_output_literal "  ( HIGH SPEED ON ) "
        MOM_output_literal "G187  "  ;#  for haas set high speed back to default
}
MOM_output_literal "G90  "

# 5x only return to
set  mom_pos(0) $tX    ;# restore last known pos
set  mom_pos(1) $tY
set  mom_pos(3) $tA      ;# restore  pos
set  mom_pos(4) $tB

MOM_force once G_motion fourth_axis fifth_axis
MOM_do_template AClampOff        ;#  M11
MOM_do_template BClampOff        ;#  M13

MOM_do_template Aaxis        ;# return to last known posn
MOM_force once G_motion
MOM_do_template Baxis        ;# in case user's been jogging

MOM_do_template AClampOn       ;# M10
MOM_do_template BClampOn       ;# M12

MOM_force once G_motion X Y
MOM_do_template RapXYforThread    ;# misnomer here G0 X Y

MOM_force once X Y Z R F  S M_spindle
MOM_force once Z
}
}


#=============================================================
proc PB_CMD_suppress_linear_block_plane_code { } {
#=============================================================
# This command is to be called in the linear move event to suppress
# G_plane address when the cutcom status has not changed.
# -- Assuming G_cutcom address is modal and G_plane exists in the block
#
#<10-11-09 gsl> New
#

  # Restrict this command to be executed only by MOM_linear_move
   if { [string compare "MOM_linear_move" [info level -1] ] } {
return
   }


   global mom_cutcom_status mom_user_prev_cutcom_status

   if { ![info exists mom_cutcom_status] } {
      set mom_cutcom_status UNDEFINED
   }

   if { ![info exists mom_user_prev_cutcom_status] } {
      set mom_user_prev_cutcom_status $mom_cutcom_status
   }

   if { [string match "UNDEFINED" $mom_cutcom_status] ||\
        [string match $mom_user_prev_cutcom_status $mom_cutcom_status] } {
     # It's better if we know next Block contains G_plane Address
      MOM_suppress once G_plane
   }

   if { ![string match $mom_user_prev_cutcom_status $mom_cutcom_status] } {
      set mom_user_prev_cutcom_status $mom_cutcom_status
   }
}


#=============================================================
proc PB_CMD_tapfix { } {
#=============================================================
global feed ;# mm/min
global pn_tapfeed mom_spindle_speed pn_tapflag mom_spindle_direction pn_tap_Gcode

set pn_tapfeed $feed

if ![info exists pn_tapflag] { set pn_tapflag 0 }

set pn_tapflag 1
set pn_tap_Gcode 84

if { $mom_spindle_direction == "CCLW"  } { set pn_tap_Gcode 74 }
}


#=============================================================
proc PB_CMD_threadmill_handler { } {
#=============================================================
# spots text cycle and calls PB procs

uplevel #0 {

    proc MOM_drill_text { } {
       PB_CMD_drill_text
    }

    proc MOM_drill_text_move { } {
       PB_CMD_drill_text_move
    }

}
}


#=============================================================
proc PB_CMD_tool_change_blocks { } {
#=============================================================
global licznik
global mom_tool_number

MOM_output_literal "N$licznik T$mom_tool_number M06"
}


#=============================================================
proc PB_CMD_tool_change_force_addresses { } {
#=============================================================
MOM_force once G_adjust Z H
}


#=============================================================
proc PB_CMD_trap_zeros { } {
#=============================================================
# trap zero tool number  and spindle speed

global mom_tool_number
global mom_spindle_speed
global mom_operation_name
global mom_operation_type
set xx "Mill Machine Control"

if { $mom_operation_type == $xx } { return }         ;# don't check machine controls

if { $mom_tool_number  == 0.0 } {
    MOM_output_literal " ( TOOL ZERO PROGRAMMED ) "
    MOM_output_literal " M00 "
    set errmes "\n\n *** Tool Number Not set    ***\n***  in operation $mom_operation_name  ***\n\n"
     MOM_abort "$errmes"
   }

if { $mom_spindle_speed == 0.0 } {
    MOM_output_literal " ( ZERO SPINDLE SPEED PROGRAMMED )"
    MOM_output_literal " M00 "
    set mom_spindle_speed 20.    ;# dodge div.by zero in tap
    set errmes "\n\n *** Spindle Speed Not set    ***\n***  in operation $mom_operation_name  ***\n\n"
     MOM_abort "$errmes"
   }

# VF2-TR Specific

if { $mom_spindle_speed > 15000 } {
    set errmes "\n\n *** Spindle Speed Over Max 15000    ***\n***  in operation $mom_operation_name  ***\n\n"
     MOM_abort "$errmes"
   }

if { $mom_spindle_speed < 50  } {
    set errmes "\n\n *** Spindle Speed Under Min 50    ***\n***  in operation $mom_operation_name  ***\n\n"
     MOM_abort "$errmes"
   }
}


#=============================================================
proc PB_CMD_unclamp_fifth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to unclamp the fifth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
  MOM_output_literal "M13"
}


#=============================================================
proc PB_CMD_unclamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to unclamp the fourth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
  MOM_output_literal "M11"
}


#=============================================================
proc PB_CMD_unwindB { } {
#=============================================================
# machine axis travel limit on B table is +/- 99999 (
# we set 99600 as limit in PB
# handle repos by non-PB means
set tangle 99400     ;# use 99400 here

 set tangle 2500     ;# test with small number
set mangle [ expr -1.0 * $tangle ]



global mom_out_angle_pos mom_operation_name mom_pos
global mom_prev_pos  mom_prev_out_angle_pos mom_feed_cut_value


#MOM_output_literal " tangle $tangle "
#MOM_output_literal " mangle $mangle "
#MOM_output_literal " anglepos $mom_out_angle_pos(1) "

# slight lift at feedrate G92 to unset and then carryon.

set windupflag 0
if { $mom_out_angle_pos(1) > $tangle } {
   set ba [format  "%.3f" $mom_out_angle_pos(1) ]
   set msg " ( B AXIS LIMIT REACHED $ba IN  $mom_operation_name ) "
   set windupflag 1
}

if { $mom_out_angle_pos(1) < $mangle } {
   set ba [format  "%.3f" $mom_out_angle_pos(1) ]
   set msg " ( B AXIS LIMIT REACHED $ba IN  $mom_operation_name ) "
   set windupflag 1
}

if { $windupflag } {

# allow natural move to take place ( before repos )

# save mom_pos etc
    set js_temp_saveZ $mom_pos(2)            ;# STORE Z

# save old feed
    global feed mom_sys_feed_rate_mode_code feed_mode
    set save_feed $feed

    # set saveMode $feed_mode
    # set saveG93 $mom_sys_feed_rate_mode_code($feed_mode)
    set feed 100                    ;# arbitrary
    set feed_mode "MMPM"

# godel Z 1.0 mm
### suspect we need to switch from G93 to G94 to do this ###
    set js_lift    1.0                ;# lift dimension 1.0mm
    set mom_pos(2) [ expr $mom_pos(2) + $js_lift ]    ;# SET NEW Z
    MOM_force once G_feed F
    MOM_do_template linear_move            ;# DO retract-LINEAR
    MOM_output_literal "    "
    MOM_output_literal $msg


# g92 block
    PB_CMD_nBwork

 # goto orig pos at feed
    set mom_pos(2) $js_temp_saveZ            ;# REINSTATE Z
    MOM_force once G_feed F
    MOM_do_template linear_move            ;# return
#
set feed $save_feed
# set mom_sys_feed_rate_mode_code($saveMode) $saveG93
MOM_force once G_feed F

}
}


#=============================================================
proc PB_CMD_version { } {
#=============================================================
global pn_version
set pn_version 1.0 ;# Generic 3 axis


##
}


#=============================================================
proc ANGLE_CHECK { a axis } {
#=============================================================
# called by ROTARY_AXIS_RETRACT
#
#   Return:
#     1: Within limits
#    -1: Out of limits
#     0: Special condition (0 ~ 360 & MAGNITUDE_DETERMINES_DIRECTION)
#

   upvar $a ang

   global mom_kin_4th_axis_max_limit
   global mom_kin_5th_axis_max_limit
   global mom_kin_4th_axis_min_limit
   global mom_kin_5th_axis_min_limit
   global mom_kin_4th_axis_direction
   global mom_kin_5th_axis_direction

   if { $axis == 4 } {
      set min $mom_kin_4th_axis_min_limit
      set max $mom_kin_4th_axis_max_limit
      set dir $mom_kin_4th_axis_direction
   } else {
      set min $mom_kin_5th_axis_min_limit
      set max $mom_kin_5th_axis_max_limit
      set dir $mom_kin_5th_axis_direction
   }

   if { [EQ_is_equal $min 0.0] && [EQ_is_equal $max 360.0] &&\
       ![string compare "MAGNITUDE_DETERMINES_DIRECTION" $dir] } {

      return 0

   } else {

      while { $ang > $max && $ang > [expr $min + 360.0] } { set ang [expr $ang - 360.0] }
      while { $ang < $min && $ang < [expr $max - 360.0] } { set ang [expr $ang + 360.0] }

      if { $ang > $max || $ang < $min } {

         return -1

      } else {

         return 1
      }
   }
}


#=============================================================
proc ARCTAN { y x } {
#=============================================================
   global PI

   if { [EQ_is_zero $y] } { set y 0 }
   if { [EQ_is_zero $x] } { set x 0 }

   if { [expr $y == 0] && [expr $x == 0] } {
      return 0
   }

   set ang [expr atan2($y,$x)]

   if { $ang < 0 } {
      return [expr $ang + $PI*2]
   } else {
      return $ang
   }
}


#=============================================================
proc ARR_sort_array_vals { ARR } {
#=============================================================
# This command will sort and return a list containing the indexed elements of an array.
#
   upvar $ARR arr

   set list [list]
   foreach a [lsort -dictionary [array names arr]] {
      if ![catch {expr $arr($a)}] {
         set val [format "%+.5f" $arr($a)]
      } else {
         set val $arr($a)
      }
      lappend list ($a) $val
   }

return $list
}


#=============================================================
proc AXIS_SET { axis } {
#=============================================================
# called by MOM_rotate & SET_LOCK

  global mom_sys_leader

   if { ![string compare "[string index $mom_sys_leader(fourth_axis) 0]AXIS" $axis] } {
      return 3
   } elseif { ![string compare "[string index $mom_sys_leader(fifth_axis) 0]AXIS" $axis] } {
      return 4
   } else {
      return 0
   }
}


#=============================================================
proc CALC_CYLINDRICAL_RETRACT_POINT { refpt axis dist ret_pt } {
#=============================================================
# called by ROTARY_AXIS_RETRACT

  upvar $refpt rfp ; upvar $axis ax ; upvar $ret_pt rtp

#
# Return 0: parallel or lies on plane
#        1: unique intersection
#


#
# Create plane canonical form
#
   VMOV 3 ax plane
   set plane(3) $dist

   set num [expr $plane(3) - [VEC3_dot rfp plane]]
   set dir [VEC3_dot ax plane]

   if { [EQ_is_zero $dir] } {
return 0
   }

   for { set i 0 } { $i < 3 } { incr i } {
      set rtp($i) [expr $rfp($i) + $ax($i)*$num/$dir]
   }

return [RETRACT_POINT_CHECK rfp ax rtp]
}


#=============================================================
proc CALC_SPHERICAL_RETRACT_POINT { refpt axis cen_sphere rad_sphere int_pts } {
#=============================================================
# called by ROTARY_AXIS_RETRACT

  upvar $refpt rp ; upvar $axis ta ; upvar $cen_sphere cs
  upvar $int_pts ip

   set rad [expr $rad_sphere*$rad_sphere]
   VEC3_sub rp cs v1

   set coeff(2) 1.0
   set coeff(1) [expr ($v1(0)*$ta(0) + $v1(1)*$ta(1) + $v1(2)*$ta(2))*2.0]
   set coeff(0) [expr $v1(0)*$v1(0) + $v1(1)*$v1(1) + $v1(2)*$v1(2) - $rad]

   set num_sol [SOLVE_QUADRATIC coeff roots iroots status degree]
   if { $num_sol == 0 } { return 0 }

   if { [expr $roots(0)] > [expr $roots(1)] || $num_sol == 1 } {
      set d $roots(0)
   } else {
      set d $roots(1)
   }

   set ip(0) [expr $rp(0) + $d*$ta(0)]
   set ip(1) [expr $rp(1) + $d*$ta(1)]
   set ip(2) [expr $rp(2) + $d*$ta(2)]

return [RETRACT_POINT_CHECK rp ta ip]
}


#=============================================================
proc CALLED_BY { caller {out_warn 0} args } {
#=============================================================
# This command can be used in the beginning of a command
# to designate a specific caller for the command in question.
#
# - Users can set the optional flag "out_warn" to "1" to output
#   warning message when a command is being called by a
#   non-designated caller. By default, warning message is suppressed.
#
#  Syntax:
#    if { ![CALLED_BY "cmd_string"] } { return ;# or do something }
#  or
#    if { ![CALLED_BY "cmd_string" 1] } { return ;# To output warning }
#
# Revisions:
#-----------
# 05-25-10 gsl - Initial implementation
# 03-09-11 gsl - Enhanced description
#

   if { ![string compare "$caller" [info level -2] ] } {
return 1
   } else {
      if { $out_warn } {
         CATCH_WARNING "\"[info level -1]\" can not be executed in \"[info level -2]\". \
                        It must be called by \"$caller\"!"
      }
return 0
   }
}


#=============================================================
proc CATCH_WARNING { msg {output 1} } {
#=============================================================
# This command is called in a post to spice up the message to be output to the warning file.
#
   global mom_warning_info
   global mom_motion_event
   global mom_event_number
   global mom_motion_type
   global mom_operation_name


   if { $output == 1 } {

      set level [info level]
      set call_stack ""
      for { set i 1 } { $i < $level } { incr i } {
         set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
      }

      global mom_o_buffer
      if { ![info exists mom_o_buffer] } {
         set mom_o_buffer ""
      }

      if { ![info exists mom_motion_event] } {
         set mom_motion_event ""
      }

      if { [info exists mom_operation_name] && [string length $mom_operation_name] } {
         set mom_warning_info "$msg\n\  Operation $mom_operation_name - Event $mom_event_number [MOM_ask_event_type] :\
                               $mom_motion_event ($mom_motion_type)\n\    $mom_o_buffer\n\      $call_stack"
      } else {
         set mom_warning_info "$msg\n\  Event $mom_event_number [MOM_ask_event_type] :\
                               $mom_motion_event ($mom_motion_type)\n\    $mom_o_buffer\n\      $call_stack"
      }

      MOM_catch_warning
   }

   # Restore mom_warning_info for subsequent use
   set mom_warning_info $msg
}


#=============================================================
proc CHECK_LOCK_ROTARY_AXIS { axis mtype } {
#=============================================================
# called by SET_LOCK

   global mom_sys_leader

   set is_valid 0
   set lock_axis_leader ""

   if { $mtype == 4 } {
      # For 4-axis machine, the locked rotary axis must be the fourth axis.
      if { [string match "FIFTH" $axis] } {
         return $is_valid
      }

      set lock_axis_leader [string index $mom_sys_leader(fourth_axis) 0]

   } elseif { $mtype == 5 } {
      # For 5-axis machine, the locked rotary axis must be the fifth axis.
      if { [string match "FOURTH" $axis] } {
         return $is_valid
      }

      set lock_axis_leader [string index $mom_sys_leader(fifth_axis) 0]

   } else {

      return $is_valid
   }

   # Handle the case when axis is "AAXIS", "BAXIS" or "CAXIS"
   set cur_axis_leader [string index $axis 0]
   switch $cur_axis_leader {
      A -
      B -
      C {
         if { [string match $lock_axis_leader $cur_axis_leader] } {
            # The specified rotary axis is valid
            set is_valid 1
         }
      }
      default {
         set is_valid 1
      }
   }

   return $is_valid
}


#=============================================================
proc CMD_EXIST { cmd {out_warn 0} args } {
#=============================================================
# This command can be used to detect the existence of a command
# before executing it.
# - Users can set the optional flag "out_warn" to "1" to output
#   warning message when a command to be called doesn't exist.
#   By default, warning message is suppressed.
#
#  Syntax:
#    if { [CMD_EXIST "cmd_string"] } { cmd_string }
#  or
#    if { [CMD_EXIST "cmd_string" 1] } { cmd_string ;# To output warning }
#
# Revisions:
#-----------
# 05-25-10 gsl - Initial implementation
# 03-09-11 gsl - Enhanced description
#

   if { [llength [info commands "$cmd"] ] } {
return 1
   } else {
      if { $out_warn } {
         CATCH_WARNING "Command \"$cmd\" called by \"[info level -1]\" does not exist!"
      }
return 0
   }
}


#=============================================================
proc CYCLE_SET {  } {
#=============================================================
}


#=============================================================
proc CYCLE_TOOL_AXIS {  } {
#=============================================================
  global mom_cycle_rapid_to_pos
  global mom_cycle_feed_to_pos
  global mom_cycle_retract_to_pos
  global mom_cycle_rapid_to
  global mom_cycle_feed_to
  global mom_cycle_rapid_to
  global mom_cycle_feed_to
  global mom_cycle_retract_to
  global mom_kin_4th_axis_type
  global mom_kin_5th_axis_type
  global mom_kin_4th_axis_plane
  global mom_kin_5th_axis_plane
  global top_of_hole
  global mom_tool_axis
  global mom_sys_spindle_axis
  global mom_motion_type
  global mom_kin_spindle_axis
  global mom_pos
  global DEG2RAD
  global mom_spindle_axis

  PB_CMD_init_spindle_axis

  set mom_motion_type "SIMULATED_CYCLES"

  if [info exists mom_spindle_axis] {
    VMOV 3 mom_spindle_axis mom_sys_spindle_axis
  } elseif { ![string compare "Table" $mom_kin_4th_axis_type] } {
    VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
  } elseif { ![string compare "Table" $mom_kin_5th_axis_type] } {
    VMOV 3 mom_tool_axis vec1
    set ang [expr -$mom_pos(4)*$DEG2RAD]
    if { ![string compare "XY" $mom_kin_5th_axis_plane] } {
    ROTATE_VECTOR 2 $ang vec1 vec
    } elseif { ![string compare "ZX" $mom_kin_5th_axis_plane] } {
      ROTATE_VECTOR 1 $ang vec1 vec
    } elseif { ![string compare "YZ" $mom_kin_5th_axis_plane] } {
      ROTATE_VECTOR 0 $ang vec1 vec
    }
    if { ![string compare "XY" $mom_kin_4th_axis_plane] } {
      set vec(2) 0.0
    } elseif { ![string compare "ZX" $mom_kin_4th_axis_plane] } {
      set vec(1) 0.0
    } elseif { ![string compare "YZ" $mom_kin_4th_axis_plane] } {
      set vec(0) 0.0
    }
    set l [VEC3_unitize vec mom_sys_spindle_axis]
    if [EQ_is_zero $l] {
      set mom_sys_spindle_axis(2) 1.0
    } else {
      VMOV 3 mom_tool_axis mom_sys_spindle_axis
    }
  }

  for {set i 0} {$i < 3} {incr i} {
    set top_of_hole($i) [expr $mom_cycle_rapid_to_pos($i) - $mom_cycle_rapid_to*$mom_sys_spindle_axis($i)]
  }

  for {set i 0} {$i < 3} {incr i} {
    set mom_cycle_rapid_to_pos($i) [expr $top_of_hole($i) + $mom_cycle_rapid_to*$mom_sys_spindle_axis($i)]
    set mom_cycle_feed_to_pos($i) [expr $top_of_hole($i) + $mom_cycle_feed_to*$mom_sys_spindle_axis($i)]
    set mom_cycle_retract_to_pos($i) [expr $top_of_hole($i) + $mom_cycle_retract_to*$mom_sys_spindle_axis($i)]
  }
}


#=============================================================
proc DELAY_TIME_SET {  } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}


#=============================================================
proc EQ_is_equal { s t } {
#=============================================================
return [EQ_is_zero [expr $s - $t]]
}


#=============================================================
proc EQ_is_zero { s } {
#=============================================================
   global mom_system_tolerance

   if { [info exists mom_system_tolerance] && [expr $mom_system_tolerance > 0.0] } {
      set tol $mom_system_tolerance
   } else {
      set tol 0.0000001
   }

   if { [expr abs($s) <= $tol] } { return 1 } else { return 0 }
}


#=============================================================
proc EXEC { command_string {__wait 1} } {
#=============================================================
# This command can be used in place of the intrinsic Tcl "exec" command
# of which some problems have been reported under Win64 O/S and multi-core
# processors environment.
#
#
# Input:
#   command_string -- command string
#   __wait         -- optional flag
#                     1 (default)   = Caller will wait until execution is complete.
#                     0 (specified) = Caller will not wait.
#
# Return:
#   Results of execution
#
#
# Revisions:
#-----------
# 05-19-10 gsl - Initial implementation
#

   global tcl_platform


   if { $__wait } {

      if { [string match "windows" $tcl_platform(platform)] } {

         global env mom_logname

        # Create a temporary file to collect output
         set result_file "$env(TEMP)/${mom_logname}__EXEC_[clock clicks].out"

        # Clean up existing file
         regsub -all {\\} $result_file {/}  result_file
        #regsub -all { }  $result_file {\ } result_file

         if { [file exists "$result_file"] } {
            file delete -force "$result_file"
         }

         set cmd [concat exec $command_string > \"$result_file\"]
         regsub -all {\\} $cmd {\\\\} cmd

         eval $cmd

        # Return results & clean up temporary file
         if { [file exists "$result_file"] } {
            set fid [open "$result_file" r]
            set result [read $fid]
            close $fid

            file delete -force "$result_file"

           return $result
         }

      } else {

         set cmd [concat exec $command_string]

        return [eval $cmd]
      }

   } else {

      if { [string match "windows" $tcl_platform(platform)] } {

         set cmd [concat exec $command_string &]
         regsub -all {\\} $cmd {\\\\} cmd

        return [eval $cmd]

      } else {

        return [exec $command_string &]
      }
   }
}




#=============================================================
proc GET_SPINDLE_AXIS { input_tool_axis } {
#=============================================================
# called by ROTARY_AXIS_RETRACT

   upvar $input_tool_axis axis

   global mom_kin_4th_axis_type
   global mom_kin_4th_axis_plane
   global mom_kin_5th_axis_type
   global mom_kin_spindle_axis
   global mom_sys_spindle_axis

   if { ![string compare "Table" $mom_kin_4th_axis_type] } {
      VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
   } elseif { ![string compare "Table" $mom_kin_5th_axis_type] } {
      VMOV 3 axis vec
      if { ![string compare "XY" $mom_kin_4th_axis_plane] } {
         set vec(2) 0.0
      } elseif { ![string compare "ZX" $mom_kin_4th_axis_plane] } {
         set vec(1) 0.0
      } elseif { ![string compare "YZ" $mom_kin_4th_axis_plane] } {
         set vec(0) 0.0
      }
      set len [VEC3_unitize vec mom_sys_spindle_axis]
      if { [EQ_is_zero $len] } { set mom_sys_spindle_axis(2) 1.0 }
   } else {
      VMOV 3 axis mom_sys_spindle_axis
   }
}


#=============================================================
proc INFO { args } {
#=============================================================
   MOM_output_to_listing_device [join $args]
}


#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================
   set a [expr fmod($a,360)]
   set a [expr ($a < 0) ? ($a + 360) : $a]

return $a
}


#=============================================================
proc LINEARIZE_LOCK_MOTION {  } {
#=============================================================
# called by LOCK_AXIS_MOTION
#
#  This command linearizes the move between two positions that
#  have both linear and rotary motion.  The rotary motion is
#  created by LOCK_AXIS from the coordinates in the locked plane.
#  The combined linear and rotary moves result in non-linear
#  motion.  This command will break the move into shorter moves
#  that do not violate the tolerance.
#
   global mom_pos
   global mom_prev_pos
   global unlocked_pos
   global unlocked_prev_pos
   global mom_kin_linearization_tol
   global mom_kin_machine_resolution
   global mom_out_angle_pos

   VMOV 5 mom_pos locked_pos
   VMOV 5 mom_prev_pos locked_prev_pos

   UNLOCK_AXIS locked_pos unlocked_pos
   UNLOCK_AXIS locked_prev_pos unlocked_prev_pos

   VMOV 5 unlocked_pos save_unlocked_pos
   VMOV 5 locked_pos save_locked_pos

   set loop 0
   set count 0

   set tol $mom_kin_linearization_tol

   while { $loop == 0 } {

      for { set i 3 } { $i < 5 } { incr i } {
         set del [expr $locked_pos($i) - $locked_prev_pos($i)]
         if { $del > 180.0 } {
            set locked_prev_pos($i) [expr $locked_prev_pos($i)+360.0]
         } elseif { $del < -180.0 } {
            set locked_prev_pos($i) [expr $locked_prev_pos($i)-360.0]
         }
      }

      set loop 1

      for { set i 0 } { $i < 5 } { incr i } {
         set mid_unlocked_pos($i) [expr ($unlocked_pos($i)+$unlocked_prev_pos($i))/2.0]
         set mid_locked_pos($i) [expr ($locked_pos($i)+$locked_prev_pos($i))/2.0]
      }

      UNLOCK_AXIS mid_locked_pos temp

      VEC3_sub temp mid_unlocked_pos work

      set error [VEC3_mag work]

      if { $count > 20 } {

         VMOV 5 locked_pos mom_pos
         VMOV 5 unlocked_pos mom_prev_pos

         LINEARIZE_LOCK_OUTPUT $count

      } elseif { $error < $tol } {

         VMOV 5 locked_pos mom_pos
         VMOV 5 unlocked_pos mom_prev_pos

         LINEARIZE_LOCK_OUTPUT $count

         VMOV 5 unlocked_pos unlocked_prev_pos
         VMOV 5 locked_pos locked_prev_pos

         if { $count != 0 } {
            VMOV 5 save_unlocked_pos unlocked_pos
            VMOV 5 save_locked_pos locked_pos
            set loop 0
            set count 0
         }

      } else {

         if { $error < $mom_kin_machine_resolution } {
            set error $mom_kin_machine_resolution
         }

         set error [expr sqrt($mom_kin_linearization_tol*.98/$error)]

         if { $error < .5 } { set error .5 }

         for { set i 0 } { $i < 5 } { incr i } {
            set locked_pos($i) [expr $locked_prev_pos($i)+($locked_pos($i)-$locked_prev_pos($i))*$error]
            set unlocked_pos($i) [expr $unlocked_prev_pos($i)+($unlocked_pos($i)-$unlocked_prev_pos($i))*$error]
         }

         LOCK_AXIS unlocked_pos locked_pos mom_outangle_pos

         set loop 0
         incr count
      }
   }
}


#=============================================================
proc LINEARIZE_LOCK_OUTPUT { count } {
#=============================================================
# called by LOCK_AXIS_MOTION & LINEARIZE_LOCK_MOTION

   global mom_out_angle_pos
   global mom_pos
   global mom_prev_rot_ang_4th
   global mom_prev_rot_ang_5th
   global mom_kin_4th_axis_direction
   global mom_kin_5th_axis_direction
   global mom_kin_4th_axis_leader
   global mom_kin_5th_axis_leader
   global mom_sys_leader
   global mom_prev_pos
   global mom_mcs_goto
   global mom_prev_mcs_goto
   global mom_motion_distance
   global mom_feed_rate_number
   global mom_feed_rate
   global mom_kin_machine_resolution
   global mom_kin_max_frn
   global mom_kin_machine_type
   global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
   global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit
   global mom_out_angle_pos
   global unlocked_pos unlocked_prev_pos


   set mom_out_angle_pos(0)  [ROTSET $mom_pos(3) $mom_prev_rot_ang_4th $mom_kin_4th_axis_direction\
                                     $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                     $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
   if { [info exists mom_kin_5th_axis_direction] } {
      set mom_out_angle_pos(1)  [ROTSET $mom_pos(4) $mom_prev_rot_ang_5th $mom_kin_5th_axis_direction\
                                        $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                        $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
   }

#
#  Re-calcualte the distance and feed rate number
#

   if { $count < 0 } {
      VEC3_sub mom_mcs_goto mom_prev_mcs_goto delta
   } else {
      VEC3_sub unlocked_pos unlocked_prev_pos delta
   }
   set mom_motion_distance [VEC3_mag delta]
   if { [EQ_is_lt $mom_motion_distance $mom_kin_machine_resolution] } {
      set mom_feed_rate_number $mom_kin_max_frn
   } else {
      set mom_feed_rate_number [expr $mom_feed_rate / $mom_motion_distance]
   }

   set mom_pos(3) $mom_out_angle_pos(0)

   FEEDRATE_SET

   if { $count > 0 } { PB_CMD_linear_move }

#   set mom_prev_pos(3) $mom_out_angle_pos(0)
}


#=============================================================
proc LOCK_AXIS { input_point output_point output_rotary } {
#=============================================================
# called by LOCK_AXIS_MOTION & LINEARIZE_LOCK_MOTION

   upvar $input_point ip ; upvar $output_point op ; upvar $output_rotary or

   global mom_kin_4th_axis_center_offset
   global mom_kin_5th_axis_center_offset
   global mom_sys_lock_value
   global mom_sys_lock_plane
   global mom_sys_lock_axis
   global mom_sys_unlocked_axis
   global mom_sys_4th_axis_index
   global mom_sys_5th_axis_index
   global mom_sys_linear_axis_index_1
   global mom_sys_linear_axis_index_2
   global mom_sys_rotary_axis_index
   global mom_kin_machine_resolution
   global mom_prev_lock_angle
   global mom_out_angle_pos
   global mom_prev_rot_ang_4th
   global mom_prev_rot_ang_5th
   global positive_radius
   global DEG2RAD
   global RAD2DEG
   global mom_kin_4th_axis_rotation
   global mom_kin_5th_axis_rotation

   if { ![info exists positive_radius] } { set positive_radius 0 }

   if { $mom_sys_rotary_axis_index == 3 } {
      if { ![info exists mom_prev_rot_ang_4th] } { set mom_prev_rot_ang_4th 0.0 }
      set mom_prev_lock_angle $mom_prev_rot_ang_4th
   } else {
      if { ![info exists mom_prev_rot_ang_5th] } { set mom_prev_rot_ang_5th 0.0 }
      set mom_prev_lock_angle $mom_prev_rot_ang_5th
   }

   if { ![info exists mom_kin_4th_axis_center_offset] } {
      set temp(0) $ip(0)
      set temp(1) $ip(1)
      set temp(2) $ip(2)
   } else {
      VEC3_sub ip mom_kin_4th_axis_center_offset temp
   }

   if { [info exists mom_kin_5th_axis_center_offset] } {
      VEC3_sub temp mom_kin_5th_axis_center_offset temp
   }

   set temp(3) $ip(3)
   set temp(4) $ip(4)

   if { $mom_sys_lock_axis > 2 } {
      set angle [expr ($mom_sys_lock_value-$temp($mom_sys_lock_axis))*$DEG2RAD]
      ROTATE_VECTOR $mom_sys_lock_plane $angle temp temp1
      VMOV 3 temp1 temp
      set temp($mom_sys_lock_axis) $mom_sys_lock_value
   } else {
      if { ![string compare $mom_sys_lock_plane $mom_sys_5th_axis_index] } {
         set angle [expr ($temp(4))*$DEG2RAD]

         # <03-11-10 wbh> 6308668 Check the rotation mode
         if [string match "reverse" $mom_kin_5th_axis_rotation] {
            set angle [expr -$angle]
         }

         ROTATE_VECTOR $mom_sys_5th_axis_index $angle temp temp1
         VMOV 3 temp1 temp
         set temp(4) 0.0
      }
      set rad [expr sqrt($temp($mom_sys_linear_axis_index_1)*$temp($mom_sys_linear_axis_index_1) +\
                         $temp($mom_sys_linear_axis_index_2)*$temp($mom_sys_linear_axis_index_2))]
      set angle [ARCTAN $temp($mom_sys_linear_axis_index_2) $temp($mom_sys_linear_axis_index_1)]

      # <03-11-10 wbh> 6308668 Check the rotation mode
      if { ![string compare $mom_sys_lock_plane $mom_sys_5th_axis_index] } {
         if [string match "reverse" $mom_kin_5th_axis_rotation] {
            set angle [expr -$angle]
         }
      } elseif { ![string compare $mom_sys_lock_plane $mom_sys_4th_axis_index] } {
         if [string match "reverse" $mom_kin_4th_axis_rotation] {
            set angle [expr -$angle]
         }
      }

      if { $rad < [expr abs($mom_sys_lock_value) + $mom_kin_machine_resolution] } {
         if { $mom_sys_lock_value < 0.0 } {
            set temp($mom_sys_lock_axis) [expr -$rad]
         } else {
            set temp($mom_sys_lock_axis) $rad
         }
      } else {
         set temp($mom_sys_lock_axis) $mom_sys_lock_value
      }

      set temp($mom_sys_unlocked_axis)  [expr sqrt($rad*$rad - $temp($mom_sys_lock_axis)*$temp($mom_sys_lock_axis))]

      VMOV 5 temp temp1
      set temp1($mom_sys_unlocked_axis) [expr -$temp($mom_sys_unlocked_axis)]
      set ang1 [ARCTAN $temp($mom_sys_linear_axis_index_2) $temp($mom_sys_linear_axis_index_1)]
      set ang2 [ARCTAN $temp1($mom_sys_linear_axis_index_2) $temp1($mom_sys_linear_axis_index_1)]
      set temp($mom_sys_rotary_axis_index) [expr ($angle-$ang1)*$RAD2DEG]
      set temp1($mom_sys_rotary_axis_index) [expr ($angle-$ang2)*$RAD2DEG]
      set ang1 [LIMIT_ANGLE [expr $mom_prev_lock_angle-$temp($mom_sys_rotary_axis_index)]]
      set ang2 [LIMIT_ANGLE [expr $mom_prev_lock_angle-$temp1($mom_sys_rotary_axis_index)]]
      if { $ang1 > 180.0 } { set ang1 [LIMIT_ANGLE [expr -$ang1]] }
      if { $ang2 > 180.0 } { set ang2 [LIMIT_ANGLE [expr -$ang2]] }
      if { $positive_radius == 0 } {
         if { $ang1 > $ang2 } {
            VMOV 5 temp1 temp
            set positive_radius "-1"
         } else {
            set positive_radius "1"
         }
      } elseif { $positive_radius == -1 } {
         VMOV 5 temp1 temp
      }

   }

   if { [info exists mom_kin_4th_axis_center_offset] } {
      VEC3_add temp mom_kin_4th_axis_center_offset op
   } else {
      set op(0) $temp(0)
      set op(1) $temp(1)
      set op(2) $temp(2)
   }

   if { [info exists mom_kin_5th_axis_center_offset] } {
      VEC3_add op mom_kin_5th_axis_center_offset op
   }

   if { ![info exists or] } {
      set or(0) 0.0
      set or(1) 0.0
   }

   set mom_prev_lock_angle $temp($mom_sys_rotary_axis_index)
   set op(3) $temp(3)
   set op(4) $temp(4)
}


#=============================================================
proc LOCK_AXIS_INITIALIZE {  } {
#=============================================================
# called by MOM_lock_axis
# ==> It's only used by MOM_lock_axis, perhaps it should be defined within.

   global mom_sys_lock_plane
   global mom_sys_lock_axis
   global mom_sys_unlocked_axis
   global mom_sys_unlock_plane
   global mom_sys_4th_axis_index
   global mom_sys_5th_axis_index
   global mom_sys_linear_axis_index_1
   global mom_sys_linear_axis_index_2
   global mom_sys_rotary_axis_index
   global mom_kin_4th_axis_plane
   global mom_kin_5th_axis_plane
   global mom_kin_machine_type

   if { $mom_sys_lock_plane == -1 } {
      if { ![string compare "XY" $mom_kin_4th_axis_plane] } {
         set mom_sys_lock_plane 2
      } elseif { ![string compare "ZX" $mom_kin_4th_axis_plane] } {
         set mom_sys_lock_plane 1
      } elseif { ![string compare "YZ" $mom_kin_4th_axis_plane] } {
         set mom_sys_lock_plane 0
      }
   }

   set mom_sys_4th_axis_index -1
   if { ![string compare "XY" $mom_kin_4th_axis_plane] } {
      set mom_sys_4th_axis_index 2
   } elseif { ![string compare "ZX" $mom_kin_4th_axis_plane] } {
      set mom_sys_4th_axis_index 1
   } elseif { ![string compare "YZ" $mom_kin_4th_axis_plane] } {
      set mom_sys_4th_axis_index 0
   }


  # Check whether the machine type is 5-axis.
   set mom_sys_5th_axis_index -1
   if { [string match "5_axis_*" $mom_kin_machine_type] && [info exists mom_kin_5th_axis_plane] } {
      if { ![string compare "XY" $mom_kin_5th_axis_plane] } {
         set mom_sys_5th_axis_index 2
      } elseif { ![string compare "ZX" $mom_kin_5th_axis_plane] } {
         set mom_sys_5th_axis_index 1
      } elseif { ![string compare "YZ" $mom_kin_5th_axis_plane] } {
         set mom_sys_5th_axis_index 0
      }
   }


   if { $mom_sys_lock_plane == 0 } {
      set mom_sys_linear_axis_index_1 1
      set mom_sys_linear_axis_index_2 2
   } elseif { $mom_sys_lock_plane == 1 } {
      set mom_sys_linear_axis_index_1 2
      set mom_sys_linear_axis_index_2 0
   } elseif { $mom_sys_lock_plane == 2 } {
      set mom_sys_linear_axis_index_1 0
      set mom_sys_linear_axis_index_2 1
   }

   if { $mom_sys_5th_axis_index == -1 } {
      set mom_sys_rotary_axis_index 3
   } else {
      set mom_sys_rotary_axis_index 4
   }

   set mom_sys_unlocked_axis [expr $mom_sys_linear_axis_index_1 + $mom_sys_linear_axis_index_2 - $mom_sys_lock_axis]
}


#=============================================================
proc LOCK_AXIS_MOTION {  } {
#=============================================================
# called by PB_CMD_kin_before_motion
#
#  The UDE lock_axis must be specified in the tool path
#  for the post to lock the requested axis.  The UDE lock_axis may only
#  be used for four and five axis machine tools.  A four axis post may
#  only lock an axis in the plane of the fourth axis.  For five axis
#  posts only the fifth axis may be locked.  Five axis will only
#  output correctly if the fifth axis is rotated so it is perpendicular
#  to the spindle axis.
#

  # Must be called by PB_CMD_kin_before_motion
   if { ![CALLED_BY "PB_CMD_kin_before_motion"] } {
return
   }


  global mom_sys_lock_status

   if { [string match "ON" $mom_sys_lock_status] } {

      global mom_pos mom_out_angle_pos
      global mom_current_motion
      global mom_motion_type
      global mom_cycle_feed_to_pos
      global mom_cycle_feed_to mom_tool_axis
      global mom_motion_event
      global mom_cycle_rapid_to_pos
      global mom_cycle_retract_to_pos
      global mom_cycle_rapid_to
      global mom_cycle_retract_to
      global mom_prev_pos
      global mom_kin_4th_axis_type
      global mom_kin_spindle_axis
      global mom_kin_5th_axis_type
      global mom_kin_4th_axis_plane
      global mom_sys_cycle_after_initial
      global mom_kin_4th_axis_min_limit
      global mom_kin_4th_axis_max_limit
      global mom_kin_5th_axis_min_limit
      global mom_kin_5th_axis_max_limit
      global mom_prev_rot_ang_4th
      global mom_prev_rot_ang_5th
      global mom_kin_4th_axis_direction
      global mom_kin_5th_axis_direction
      global mom_kin_4th_axis_leader
      global mom_kin_5th_axis_leader


      if { [string match "circular_move" $mom_current_motion] } {
return
      }


      if { ![info exists mom_sys_cycle_after_initial] } {
         set mom_sys_cycle_after_initial "FALSE"
      }

      if { [string match "FALSE" $mom_sys_cycle_after_initial] } {
         LOCK_AXIS mom_pos mom_pos mom_out_angle_pos
      }

      if { [string match "CYCLE" $mom_motion_type] } {

        if { [string match "initial_move" $mom_motion_event] } {
           set mom_sys_cycle_after_initial "TRUE"
return
        }

        if { [string match "TRUE" $mom_sys_cycle_after_initial] } {
           set mom_pos(0) [expr $mom_pos(0) - $mom_cycle_rapid_to * $mom_tool_axis(0)]
           set mom_pos(1) [expr $mom_pos(1) - $mom_cycle_rapid_to * $mom_tool_axis(1)]
           set mom_pos(2) [expr $mom_pos(2) - $mom_cycle_rapid_to * $mom_tool_axis(2)]
        }

        set mom_sys_cycle_after_initial "FALSE"

        if { [string match "Table" $mom_kin_4th_axis_type] } {

           VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis

        } elseif { [string match "Table" $mom_kin_5th_axis_type] } {

           VMOV 3 mom_tool_axis vec

           switch $mom_kin_4th_axis_plane {
              XY {
                 set vec(2) 0.0
              }
              ZX {
                 set vec(1) 0.0
              }
              YZ {
                 set vec(0) 0.0
              }
           }

           set len [VEC3_unitize vec mom_sys_spindle_axis]

           if { [EQ_is_zero $len] } {
              set mom_sys_spindle_axis(2) 1.0
           }

        } else {

           VMOV 3 mom_tool_axis mom_sys_spindle_axis
        }

        set mom_cycle_feed_to_pos(0) [expr $mom_pos(0) + $mom_cycle_feed_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_feed_to_pos(1) [expr $mom_pos(1) + $mom_cycle_feed_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_feed_to_pos(2) [expr $mom_pos(2) + $mom_cycle_feed_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_rapid_to_pos(0) [expr $mom_pos(0) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_rapid_to_pos(1) [expr $mom_pos(1) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_rapid_to_pos(2) [expr $mom_pos(2) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_retract_to_pos(0) [expr $mom_pos(0) + $mom_cycle_retract_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_retract_to_pos(1) [expr $mom_pos(1) + $mom_cycle_retract_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_retract_to_pos(2) [expr $mom_pos(2) + $mom_cycle_retract_to * $mom_sys_spindle_axis(2)]

      }

      global mom_kin_linearization_flag

      if { ![string compare "TRUE" $mom_kin_linearization_flag] &&\
            [string compare "RAPID" $mom_motion_type] &&\
            [string compare "RETRACT" $mom_motion_type] } {

         LINEARIZE_LOCK_MOTION

      } else {

         if { ![info exists mom_prev_rot_ang_4th] } { set mom_prev_rot_ang_4th 0.0 }
         if { ![info exists mom_prev_rot_ang_5th] } { set mom_prev_rot_ang_5th 0.0 }

         LINEARIZE_LOCK_OUTPUT -1

         #<09-15-09 wbh> We must call ROTSET only one time for the 4th and/or 5th axis.
         # Since the ROTSET was called in LINEARIZE_LOCK_OUTPUT,
         # we should reload mom_prev_rot_ang_5th if it exists.
         if { [info exists mom_kin_5th_axis_direction] } {
            set mom_prev_rot_ang_5th $mom_out_angle_pos(1)
            MOM_reload_variable mom_prev_rot_ang_5th
         }
      }

      set mom_prev_rot_ang_4th $mom_out_angle_pos(0)
      MOM_reload_variable mom_prev_rot_ang_4th
      MOM_reload_variable -a mom_pos
   }
}


#=============================================================
proc LOCK_AXIS_SUB { axis } {
#=============================================================
# called by SET_LOCK

  global mom_pos mom_lock_axis_value_defined mom_lock_axis_value

   if { $mom_lock_axis_value_defined == 1 } {
      return $mom_lock_axis_value
   } else {
      return $mom_pos($axis)
   }
}


#=============================================================
proc MAXMIN_ANGLE { a max min {tol_flag 0} } {
#=============================================================
   if { $tol_flag == 0 } { ;# Direct comparison

      while { $a < $min } { set a [expr $a + 360.0] }
      while { $a > $max } { set a [expr $a - 360.0] }

   } else { ;# Tolerant comparison

      while { [EQ_is_lt $a $min] } { set a [expr $a + 360.0] }
      while { [EQ_is_gt $a $max] } { set a [expr $a - 360.0] }
   }

return $a
}


#=============================================================
proc PAUSE { args } {
#=============================================================
# Revisions:
#-----------
# 05-19-10 gsl - Use EXEC command
#

   global env

   if { [info exists env(PB_SUPPRESS_UGPOST_DEBUG)]  &&  $env(PB_SUPPRESS_UGPOST_DEBUG) == 1 } {
  return
   }


   global gPB

   if { [info exists gPB(PB_disable_MOM_pause)]  &&  $gPB(PB_disable_MOM_pause) == 1 } {
  return
   }


   global tcl_platform

   set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]

   if { [string match "*windows*" $tcl_platform(platform)] } {
      set ug_wish "ugwish.exe"
   } else {
      set ug_wish ugwish
   }

   if { [file exists ${cam_aux_dir}$ug_wish]  &&  [file exists ${cam_aux_dir}mom_pause.tcl] } {

      set title ""
      set msg ""

      if { [llength $args] == 1 } {
         set msg [lindex $args 0]
      }

      if { [llength $args] > 1 } {
         set title [lindex $args 0]
         set msg [lindex $args 1]
      }

      set command_string [concat \"${cam_aux_dir}$ug_wish\" \"${cam_aux_dir}mom_pause.tcl\" \"$title\" \"$msg\"]

      set res [EXEC $command_string]


      switch [string trim $res] {
         no {
            set gPB(PB_disable_MOM_pause) 1
         }
         cancel {
            set gPB(PB_disable_MOM_pause) 1

            uplevel #0 {
               MOM_abort "*** User Abort Post Processing *** "
            }
         }
         default {
            return
         }
      }

   } else {

      CATCH_WARNING "PAUSE not executed -- \"$ug_wish\" or \"mom_pause.tcl\" not found"
   }
}


#=============================================================
proc PAUSE_win64 { args } {
#=============================================================
   global env
   if { [info exists env(PB_SUPPRESS_UGPOST_DEBUG)]  &&  $env(PB_SUPPRESS_UGPOST_DEBUG) == 1 } {
  return
   }

   global gPB
   if { [info exists gPB(PB_disable_MOM_pause)]  &&  $gPB(PB_disable_MOM_pause) == 1 } {
  return
   }


   set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]
   set ug_wish "ugwish.exe"

   if { [file exists ${cam_aux_dir}$ug_wish] &&\
        [file exists ${cam_aux_dir}mom_pause_win64.tcl] } {

      set title ""
      set msg ""

      if { [llength $args] == 1 } {
         set msg [lindex $args 0]
      }

      if { [llength $args] > 1 } {
         set title [lindex $args 0]
         set msg [lindex $args 1]
      }


     ######
     # Define a scratch file and pass it to mom_pause_win64.tcl script -
     #
     #   A separated process will be created to construct the Tk dialog.
     #   This process will communicate with the main process via the state of a scratch file.
     #   This scratch file will collect the messages that need to be conveyed from the
     #   child process to the main process.
     ######
      global mom_logname
      set pause_file_name "$env(TEMP)/${mom_logname}_mom_pause_[clock clicks].txt"


     ######
     # Path names should be per unix style for "open" command
     ######
      regsub -all {\\} $pause_file_name {/}  pause_file_name
      regsub -all { }  $pause_file_name {\ } pause_file_name
      regsub -all {\\} $cam_aux_dir {/}  cam_aux_dir
      regsub -all { }  $cam_aux_dir {\ } cam_aux_dir

      if [file exists $pause_file_name] {
         file delete -force $pause_file_name
      }


     ######
     # Note that the argument order for mom_pasue.tcl has been changed
     # The assumption at this point is we will always have the communication file as the first
     # argument and optionally the title and message as the second and third arguments
     ######
      open "|${cam_aux_dir}$ug_wish ${cam_aux_dir}mom_pause_win64.tcl ${pause_file_name} {$title} {$msg}"


     ######
     # Waiting for the mom_pause to complete its process...
     # - This is indicated when the scratch file materialized and became read-only.
     ######
      while { ![file exists $pause_file_name] || [file writable $pause_file_name] } { }


     ######
     # Delay a 100 milli-seconds to ensure that sufficient time is given for the other process to complete.
     ######
      after 100


     ######
     # Open the scratch file to read and process the information.  Close it afterward.
     ######
      set fid [open "$pause_file_name" r]

      set res [string trim [gets $fid]]
      switch $res {
         no {
            set gPB(PB_disable_MOM_pause) 1
         }
         cancel {
            close $fid
            file delete -force $pause_file_name

            set gPB(PB_disable_MOM_pause) 1

            uplevel #0 {
               MOM_abort "*** User Abort Post Processing *** "
            }
         }
         default {}
      }


     ######
     # Delete the scratch file
     ######
      close $fid
      file delete -force $pause_file_name
   }
}


#=============================================================
proc PAUSE_x { args } {
#=============================================================
   global env
   if { [info exists env(PB_SUPPRESS_UGPOST_DEBUG)]  &&  $env(PB_SUPPRESS_UGPOST_DEBUG) == 1 } {
  return
   }

   global gPB
   if { [info exists gPB(PB_disable_MOM_pause)]  &&  $gPB(PB_disable_MOM_pause) == 1 } {
  return
   }



  #==========
  # Win64 OS
  #
   global tcl_platform

   if { [string match "*windows*" $tcl_platform(platform)] } {
      global mom_sys_processor_archit

      if { ![info exists mom_sys_processor_archit] } {
         set pVal ""
         set env_vars [array get env]
         set idx [lsearch $env_vars "PROCESSOR_ARCHITE*"]
         if { $idx >= 0 } {
            set pVar [lindex $env_vars $idx]
            set pVal [lindex $env_vars [expr $idx + 1]]
         }
         set mom_sys_processor_archit $pVal
      }

      if { [string match "*64*" $mom_sys_processor_archit] } {

         PAUSE_win64 $args
  return
      }
   }



   set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]


   if { [string match "*windows*" $tcl_platform(platform)] } {
     set ug_wish "ugwish.exe"
   } else {
     set ug_wish ugwish
   }

   if { [file exists ${cam_aux_dir}$ug_wish] && [file exists ${cam_aux_dir}mom_pause.tcl] } {

      set title ""
      set msg ""

      if { [llength $args] == 1 } {
         set msg [lindex $args 0]
      }

      if { [llength $args] > 1 } {
         set title [lindex $args 0]
         set msg [lindex $args 1]
      }

      set res [exec ${cam_aux_dir}$ug_wish ${cam_aux_dir}mom_pause.tcl $title $msg]
      switch $res {
         no {
            set gPB(PB_disable_MOM_pause) 1
         }
         cancel {
            set gPB(PB_disable_MOM_pause) 1

            uplevel #0 {
               MOM_abort "*** User Abort Post Processing *** "
            }
         }
         default { return }
      }
   }
}


#=============================================================
proc REPOSITION_ERROR_CHECK { warn } {
#=============================================================
# not called in this script

   global mom_kin_4th_axis_max_limit mom_kin_4th_axis_min_limit
   global mom_kin_5th_axis_max_limit mom_kin_5th_axis_min_limit
   global mom_pos mom_prev_pos mom_alt_pos mom_alt_prev_pos
   global mom_sys_rotary_error mom_warning_info mom_kin_machine_type

   if { [string compare "secondary rotary position being used" $warn] || [string index $mom_kin_machine_type 0] != 5 } {
      set mom_sys_rotary_error $warn
return
   }

   set mom_sys_rotary_error 0

   set a4 [expr $mom_alt_pos(3)+360.0]
   set a5 [expr $mom_alt_pos(4)+360.0]

   while { [expr $a4-$mom_kin_4th_axis_min_limit] > 360.0 } { set a4 [expr $a4-360.0] }
   while { [expr $a5-$mom_kin_5th_axis_min_limit] > 360.0 } { set a5 [expr $a5-360.0] }

   if { $a4 <= $mom_kin_4th_axis_max_limit && $a5 <= $mom_kin_5th_axis_max_limit } {
return
   }

   for { set i 0 } { $i < 2 } { incr i } {
      set rot($i) [expr $mom_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
      while { $rot($i) > 180.0 } { set rot($i) [expr $rot($i)-360.0] }
      while { $rot($i) < 180.0 } { set rot($i) [expr $rot($i)+360.0] }
      set rot($i) [expr abs($rot($i))]

      set rotalt($i) [expr $mom_alt_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
      while { $rotalt($i) > 180.0 } { set rotalt($i) [expr $rotalt($i)-360.0] }
      while { $rotalt($i) < 180.0 } { set rotalt($i) [expr $rotalt($i)+360.0] }
      set rotalt($i) [expr abs($rotalt($i))]
   }

   if { [EQ_is_equal [expr $rot(0)+$rot(1)] [expr $rotalt(0)+$rotalt(1)]] } {
return
   }

   set mom_sys_rotary_error $warn
}


#=============================================================
proc RESET_ROTARY_SIGN { ang pre_ang axis } {
#=============================================================
# Called by ROTARY_AXIS_RETRACT
#
# The input parameters "ang" & "pre_ang" must use same unit. (Both in degree or radian)

   global mom_kin_4th_axis_direction mom_kin_5th_axis_direction
   global mom_kin_4th_axis_rotation mom_kin_5th_axis_rotation
   global mom_rotary_direction_4th mom_rotary_direction_5th

   set abs_ang [expr abs($ang)]
   set abs_pre [expr abs($pre_ang)]
   if { $axis == 3 && ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_4th_axis_direction] } {
    # The fourth axis.
      if { $abs_ang > $abs_pre } {
         set mom_rotary_direction_4th 1
      } elseif { $abs_ang < $abs_pre } {
         set mom_rotary_direction_4th -1
      }
   } elseif { $axis == 4 && ![string compare "SIGN_DETERMINES_DIRECTION" $mom_kin_5th_axis_direction] } {
    # The fifth axis.
      if { $abs_ang > $abs_pre } {
         set mom_rotary_direction_5th 1
      } elseif { $abs_ang < $abs_pre } {
         set mom_rotary_direction_5th -1
      }
   }
}


#=============================================================
proc RETRACT_POINT_CHECK { refpt axis retpt } {
#=============================================================
# called by CALC_SPHERICAL_RETRACT_POINT & CALC_CYLINDRICAL_RETRACT_POINT

  upvar $refpt rfp ; upvar $axis ax ; upvar $retpt rtp

#
#  determine if retraction point is "below" the retraction plane
#  if the tool is already in a safe position, do not retract
#
#  return 0    no retract needed
#         1     retraction needed
#

   VEC3_sub rtp rfp vec
   if { [VEC3_is_zero vec] } {
return 0
   }

   set x [VEC3_unitize vec vec1]
   set dir [VEC3_dot ax vec1]

   if { $dir <= 0.0 } {
return 0
   } else {
return 1
   }
}


#=============================================================
proc ROTARY_AXIS_RETRACT {  } {
#=============================================================
# called by PB_CMD_kin_befor_motion

#  This command is used by four and five axis posts to retract
#  from the part when the rotary axis become discontinuous.  This
#  command is activated by setting the axis limit violation
#  action to "retract / re-engage".
#

  # Must be called by PB_CMD_kin_before_motion
   if { ![CALLED_BY "PB_CMD_kin_before_motion"] } {
return
   }


   global mom_sys_rotary_error
   global mom_motion_event


   if { ![info exists mom_sys_rotary_error] } {
return
   }

   set rotary_error_code $mom_sys_rotary_error

  #<sws 9-21-06> Make sure mom_sys_rotary_error is always unset.
   unset mom_sys_rotary_error


   if { [info exists mom_motion_event] } {
      if { $rotary_error_code != 0 && ![string compare "linear_move" $mom_motion_event] } {
        #<06-25-12 gsl> The above conditions have been checked in PB_CMD_kin_before_motion already.
        #               We should consider removing these conditions for performance sake!!!
         global mom_kin_reengage_distance
         global mom_kin_rotary_reengage_feedrate
         global mom_kin_rapid_feed_rate
         global mom_pos
         global mom_prev_pos
         global mom_prev_rot_ang_4th mom_prev_rot_ang_5th
         global mom_kin_4th_axis_direction mom_kin_4th_axis_leader
         global mom_out_angle_pos mom_kin_5th_axis_direction mom_kin_5th_axis_leader
         global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
         global mom_sys_leader mom_tool_axis mom_prev_tool_axis mom_kin_4th_axis_type
         global mom_kin_spindle_axis
         global mom_alt_pos mom_prev_alt_pos mom_feed_rate
         global mom_kin_rotary_reengage_feedrate
         global mom_feed_engage_value mom_feed_cut_value
         global mom_kin_4th_axis_limit_action mom_warning_info
         global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
         global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit

        #
        #  Check for the limit action being warning only.  If so, issue warning and leave
        #
         if { ![string compare "Warning" $mom_kin_4th_axis_limit_action] } {
            CATCH_WARNING "Rotary axis limit violated, discontinuous motion may result."
            return
         } elseif { ![string compare "User Defined" $mom_kin_4th_axis_limit_action] } {
          #<04-17-09 wbh> add the case for user defined
            PB_user_def_axis_limit_action
            return
         }

        #
        #  The previous rotary info is only available after the first motion.
        #
         if { ![info exists mom_prev_rot_ang_4th] } {
            set mom_prev_rot_ang_4th [MOM_ask_address_value fourth_axis]
         }
         if { ![info exists mom_prev_rot_ang_5th] } {
            set mom_prev_rot_ang_5th [MOM_ask_address_value fifth_axis]
         }

        #
        #  Determine the type of rotary violation encountered.  There are
        #  three distinct possibilities.
        #
        #  "ROTARY CROSSING LIMIT" and a four axis machine tool.  The fourth
        #      axis will be repositioned by either +360 or -360 before
        #      re-engaging. (roterr = 0)
        #
        #  "ROTARY CROSSING LIMIT" and a five axis machine tool.  There are two
        #      possible solutions.  If the axis that crossed a limit can be
        #      repositioned by adding or subtracting 360, then that solution
        #      will be used.  (roterr = 0) If there is only one position available and it is
        #      not in the valid travel limits, then the alternate position will
        #      be tested.  If valid, then the "secondary rotary position being used"
        #      method will be used. (roterr = 2)
        #      If the aternate position cannot be used a warning will be given.
        #
        #  "secondary rotary position being used".  Can only occur with a five
        #      axis machine tool.  The tool will reposition to the alternate
        #      current rotary position and re-engage to the alternate current
        #      linear position.  (roterr = 1)
        #
        #
        #    roterr = 0 :
        #      Rotary Reposition : mom_prev_pos(3,4) +- 360
        #      Linear Re-Engage :  mom_prev_pos(0,1,2)
        #      Final End Point :   mom_pos(0-4)
        #
        #    roterr = 1 :
        #      Rotary Reposition : mom_prev_alt_pos(3,4)
        #      Linear Re-Engage :  mom_prev_alt_pos(0,1,2)
        #      Final End Point :   mom_pos(0-4)
        #
        #    roterr = 2 :
        #      Rotary Reposition : mom_prev_alt_pos(3,4)
        #      Linear Re-Engage :  mom_prev_alt_pos(0,1,2)
        #      Final End Point :   mom_alt_pos(0-4)
        #
        #    For all cases, a warning will be given if it is not possible to
        #    to cut from the re-calculated previous position to move end point.
        #    For all valid cases the tool will, retract from the part, reposition
        #    the rotary axis and re-engage back to the part.
        #

         if { ![string compare "ROTARY CROSSING LIMIT." $rotary_error_code] } {
            global mom_kin_machine_type

            set machine_type [string tolower $mom_kin_machine_type]
            switch $machine_type {
               5_axis_dual_table -
               5_axis_dual_head  -
               5_axis_head_table {

                  set d [expr $mom_out_angle_pos(0) - $mom_prev_rot_ang_4th]

                  if { [expr abs($d)] > 180.0 } {
                     set min $mom_kin_4th_axis_min_limit
                     set max $mom_kin_4th_axis_max_limit
                     if { $d > 0.0 } {
                        set ang [expr $mom_prev_rot_ang_4th + 360.0]
                     } else {
                        set ang [expr $mom_prev_rot_ang_4th - 360.0]
                     }
                  } else {
                     set min $mom_kin_5th_axis_min_limit
                     set max $mom_kin_5th_axis_max_limit
                     set d [expr $mom_out_angle_pos(1) - $mom_prev_rot_ang_5th]
                     if { $d > 0.0 } {
                        set ang [expr $mom_prev_rot_ang_5th + 360.0]
                     } else {
                        set ang [expr $mom_prev_rot_ang_5th - 360.0]
                     }
                  }

                  if { $ang >= $min && $ang <= $max } { ;# ==> 5th axis min/max will be used here(?)
                     set roterr 0
                  } else {
                     set roterr 2
                  }
               }

               default { set roterr 0 }
            }
         } else {

            set roterr 1
         }

        #
        #  Retract from part
        #
         VMOV 5 mom_pos save_pos
         VMOV 5 mom_prev_pos save_prev_pos
         VMOV 2 mom_out_angle_pos save_out_angle_pos
         set save_feedrate $mom_feed_rate

         global mom_kin_output_unit mom_part_unit
         if { ![string compare $mom_kin_output_unit $mom_part_unit] } {
            set mom_sys_unit_conversion "1.0"
         } elseif { ![string compare "IN" $mom_kin_output_unit] } {
            set mom_sys_unit_conversion [expr 1.0/25.4]
         } else {
            set mom_sys_unit_conversion 25.4
         }

        #<01-07-10 wbh> Fix pr6192146.
        # Declare/Set the variables used to convert the feed rate from MMPR/IPR to MMPM/IPM.
         global mom_spindle_rpm
         global mom_feed_approach_unit mom_feed_cut_unit
         global mom_feed_engage_unit mom_feed_retract_unit
         set mode_convert_scale "1.0"
         if { [info exists mom_spindle_rpm] && [EQ_is_gt $mom_spindle_rpm 0.0] } {
            set mode_convert_scale $mom_spindle_rpm
         }

         global mom_sys_spindle_axis
         GET_SPINDLE_AXIS mom_prev_tool_axis

         global mom_kin_retract_type
         global mom_kin_retract_distance
         global mom_kin_retract_plane

         if { ![info exists mom_kin_retract_distance] } {
            if { [info exists mom_kin_retract_plane] } {
              # Convert legacy variable
               set mom_kin_retract_distance $mom_kin_retract_plane
            } else {
               set mom_kin_retract_distance 10.0
            }
         }

         if { ![info exists mom_kin_retract_type] } {
            set mom_kin_retract_type "DISTANCE"
         }

        #
        #  Pre-release type conversion
        #
         if { [string match "PLANE" $mom_kin_retract_type] } {
            set mom_kin_retract_type "SURFACE"
         }

         switch $mom_kin_retract_type {
            SURFACE {
               set cen(0) 0.0
               set cen(1) 0.0
               set cen(2) 0.0
               if { [info exists mom_kin_4th_axis_center_offset] } {
                  VEC3_add cen mom_kin_4th_axis_center_offset cen
               }

               if { ![string compare "Table" $mom_kin_4th_axis_type] } {
                  set num_sol [CALC_CYLINDRICAL_RETRACT_POINT mom_prev_pos mom_kin_spindle_axis\
                                                              $mom_kin_retract_distance ret_pt]
               } else {
                  set num_sol [CALC_SPHERICAL_RETRACT_POINT   mom_prev_pos mom_prev_tool_axis cen\
                                                              $mom_kin_retract_distance ret_pt]
               }
               if {$num_sol != 0} {VEC3_add ret_pt cen mom_pos}
            }

            DISTANCE -
            default {
               set mom_pos(0) [expr $mom_prev_pos(0) + $mom_kin_retract_distance*$mom_sys_spindle_axis(0)]
               set mom_pos(1) [expr $mom_prev_pos(1) + $mom_kin_retract_distance*$mom_sys_spindle_axis(1)]
               set mom_pos(2) [expr $mom_prev_pos(2) + $mom_kin_retract_distance*$mom_sys_spindle_axis(2)]
               set num_sol 1
            }
         }


         global mom_motion_distance
         global mom_feed_rate_number
         global mom_feed_retract_value
         global mom_feed_approach_value


         set dist [expr $mom_kin_reengage_distance*2.0]

         if { $num_sol != 0 } {

        #
        #  Retract from the part at rapid feed rate.  This is the same for all conditions.
        #
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate [expr $mom_feed_retract_value*$mom_sys_unit_conversion]
           #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
            if { [info exists mom_feed_retract_unit] && [string match "*pr" $mom_feed_retract_unit] } {
               set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
            }
            if { [EQ_is_equal $mom_feed_rate 0.0] } {
               set mom_feed_rate [expr $mom_kin_rapid_feed_rate*$mom_sys_unit_conversion]
            }
            VEC3_sub mom_pos mom_prev_pos del_pos
            set dist [VEC3_mag del_pos]

           #<03-13-08 gsl> Replaced next call
           # global mom_sys_frn_factor
           # set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate)/ $dist]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET
            set retract "yes"
         } else {
            CATCH_WARNING "Retraction geometry is defined inside of the current point.\n\
                           No retraction will be output. Set the retraction distance to a greater value."
            set retract "no"
         }

         if { $roterr == 0 } {
#
#  This section of code handles the case where a limit forces a reposition to an angle
#  by adding or subtracting 360 until the new angle is within the limits.
#  This is either a four axis case or a five axis case where it is not a problem
#  with the inverse kinematics forcing a change of solution.
#  This is only a case of "unwinding" the table.
#
            if { ![string compare "yes"  $retract] } {
               PB_CMD_retract_move
            }

           #
           #  Move to previous rotary position
           #  <04-01-2013 gsl> mom_rev_pos(3,4) may have not been affected, we may just borrow them
           #                   as mom_out_angle_pos for subsequent output instead of recomputing them thru ROTSET(?)
           #
            if { [info exists mom_kin_4th_axis_direction] } {
               set mom_out_angle_pos(0) [ROTSET $mom_prev_pos(3) $mom_out_angle_pos(0) $mom_kin_4th_axis_direction\
                                                $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                                $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
            }
            if { [info exists mom_kin_5th_axis_direction] } {
               set mom_out_angle_pos(1) [ROTSET $mom_prev_pos(4) $mom_out_angle_pos(1) $mom_kin_5th_axis_direction\
                                                $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                                $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
            }

            PB_CMD_reposition_move

           #
           #  Position back to part at approach feed rate
           #
            GET_SPINDLE_AXIS mom_prev_tool_axis
            for { set i 0 } { $i < 3 } { incr i } {
               set mom_pos($i) [expr $mom_prev_pos($i) + $mom_kin_reengage_distance * $mom_sys_spindle_axis($i)]
            }
            set mom_feed_rate [expr $mom_feed_approach_value * $mom_sys_unit_conversion]
           #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
            if { [info exists mom_feed_approach_unit] && [string match "*pr" $mom_feed_approach_unit] } {
               set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
            }
            if { [EQ_is_equal $mom_feed_rate 0.0] } {
               set mom_feed_rate [expr $mom_kin_rapid_feed_rate*$mom_sys_unit_conversion]
            }
            set dist [expr $dist-$mom_kin_reengage_distance]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET
            MOM_suppress once fourth_axis fifth_axis
            PB_CMD_linear_move

           #
           #  Feed back to part at engage feed rate
           #
            MOM_suppress once fourth_axis fifth_axis
            if { $mom_feed_engage_value  > 0.0 } {
               set mom_feed_rate [expr $mom_feed_engage_value*$mom_sys_unit_conversion]
              #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
               if { [info exists mom_feed_engage_unit] && [string match "*pr" $mom_feed_engage_unit] } {
                  set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
               }
            } elseif { $mom_feed_cut_value  > 0.0 } {
               set mom_feed_rate [expr $mom_feed_cut_value*$mom_sys_unit_conversion]
              #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
               if { [info exists mom_feed_cut_unit] && [string match "*pr" $mom_feed_cut_unit] } {
                  set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
               }
            } else {
               set mom_feed_rate [expr 10.0*$mom_sys_unit_conversion]
            }

            VEC3_sub mom_pos mom_prev_pos del_pos
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $mom_kin_reengage_distance $mom_feed_rate]
            FEEDRATE_SET
            VMOV 3 mom_prev_pos mom_pos
            PB_CMD_linear_move

            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET

            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos
            VMOV 2 save_out_angle_pos mom_out_angle_pos

         } else {
#
#  This section of code handles the case where there are two solutions to the tool axis inverse kinematics.
#  The post is forced to change from one solution to the other.  This causes a discontinuity in the tool path.
#  The post needs to retract, rotate to the new rotaries, then position back to the part using the alternate
#  solution.
#
            #
            #  Check for rotary axes in limits before retracting
            #
            set res [ANGLE_CHECK mom_prev_alt_pos(3) 4]
            if { $res == 1 } {
               set mom_out_angle_pos(0) [ROTSET $mom_prev_alt_pos(3) $mom_prev_rot_ang_4th $mom_kin_4th_axis_direction\
                                                $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                                $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit 1]
            } elseif { $res == 0 } {
               set mom_out_angle_pos(0) $mom_prev_alt_pos(3)
            } else {
               CATCH_WARNING "Not possible to position to alternate rotary axis positions. Gouging may result"
               VMOV 5 save_pos mom_pos

             return
            }

            set res [ANGLE_CHECK mom_prev_alt_pos(4) 5]
            if { $res == 1 } {
               set mom_out_angle_pos(1) [ROTSET $mom_prev_alt_pos(4) $mom_prev_rot_ang_5th $mom_kin_5th_axis_direction\
                                                $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                                $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit 1]
            } elseif { $res == 0 } {
               set mom_out_angle_pos(1) $mom_prev_alt_pos(4)
            } else {
               CATCH_WARNING "Not possible to position to alternate rotary axis positions. Gouging may result"
               VMOV 5 save_pos mom_pos

             return
            }

            set mom_prev_pos(3) $mom_pos(3)
            set mom_prev_pos(4) $mom_pos(4)
            FEEDRATE_SET

            if { ![string compare "yes" $retract] } { PB_CMD_retract_move }
           #
           #  Move to alternate rotary position
           #
            set mom_pos(3) $mom_prev_alt_pos(3)
            set mom_pos(4) $mom_prev_alt_pos(4)
            set mom_prev_rot_ang_4th $mom_out_angle_pos(0)
            set mom_prev_rot_ang_5th $mom_out_angle_pos(1)
            VMOV 3 mom_prev_pos mom_pos
            FEEDRATE_SET
            PB_CMD_reposition_move

           #
           #  Position back to part at approach feed rate
           #
            set mom_prev_pos(3) $mom_pos(3)
            set mom_prev_pos(4) $mom_pos(4)
            for { set i 0 } { $i < 3 } { incr i } {
              set mom_pos($i) [expr $mom_prev_alt_pos($i)+$mom_kin_reengage_distance*$mom_sys_spindle_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate [expr $mom_feed_approach_value*$mom_sys_unit_conversion]
           #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
            if { [info exists mom_feed_approach_unit] && [string match "*pr" $mom_feed_approach_unit] } {
               set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
            }
            if { [EQ_is_equal $mom_feed_rate 0.0] } {
              set mom_feed_rate [expr $mom_kin_rapid_feed_rate * $mom_sys_unit_conversion]
            }
            set dist [expr $dist-$mom_kin_reengage_distance]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET
            PB_CMD_linear_move

           #
           #  Feed back to part at engage feed rate
           #
            MOM_suppress once fourth_axis fifth_axis
            if { $mom_feed_engage_value  > 0.0 } {
               set mom_feed_rate [expr $mom_feed_engage_value*$mom_sys_unit_conversion]
              #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
               if { [info exists mom_feed_engage_unit] && [string match "*pr" $mom_feed_engage_unit] } {
                  set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
               }
            } elseif { $mom_feed_cut_value  > 0.0 } {
               set mom_feed_rate [expr $mom_feed_cut_value*$mom_sys_unit_conversion]
              #<01-07-10 wbh> Convert the feed rate from MMPR/IPR to MMPM/IPM
               if { [info exists mom_feed_cut_unit] && [string match "*pr" $mom_feed_cut_unit] } {
                  set mom_feed_rate [expr $mom_feed_rate * $mode_convert_scale]
               }
            } else {
              # ???
               set mom_feed_rate [expr 10.0*$mom_sys_unit_conversion]
            }

            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $mom_kin_reengage_distance $mom_feed_rate]
            VMOV 3 mom_prev_alt_pos mom_pos
            FEEDRATE_SET
            PB_CMD_linear_move

            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            if { $dist <= 0.0 } { set dist $mom_kin_reengage_distance }
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET

            if { $roterr == 2 } {
               VMOV 5 mom_alt_pos mom_pos
            } else {
               VMOV 5 save_pos mom_pos
            }

           #<01-07-10 wbh> Reset the rotary sign
            RESET_ROTARY_SIGN $mom_pos(3) $mom_out_angle_pos(0) 3
            RESET_ROTARY_SIGN $mom_pos(4) $mom_out_angle_pos(1) 4

            set mom_out_angle_pos(0) [ROTSET $mom_pos(3) $mom_out_angle_pos(0) $mom_kin_4th_axis_direction\
                                             $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)\
                                             $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
            set mom_out_angle_pos(1) [ROTSET $mom_pos(4) $mom_out_angle_pos(1) $mom_kin_5th_axis_direction\
                                             $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)\
                                             $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]

            MOM_reload_variable -a mom_out_angle_pos
            MOM_reload_variable -a mom_pos
            MOM_reload_variable -a mom_prev_pos
         }

         set mom_feed_rate $save_feedrate
         FEEDRATE_SET
      }
   }
}


#=============================================================
proc ROTATE_VECTOR { plane angle input_vector output_vector } {
#=============================================================
# Called by LOCK_AXIS & UNLOCK_AXIS

  upvar $output_vector v ; upvar $input_vector v1

   switch $plane {
      0 {
         set v(0) $v1(0)
         set v(1) [expr $v1(1)*cos($angle) - $v1(2)*sin($angle)]
         set v(2) [expr $v1(2)*cos($angle) + $v1(1)*sin($angle)]
      }

      1 {
         set v(0) [expr $v1(0)*cos($angle) + $v1(2)*sin($angle)]
         set v(1) $v1(1)
         set v(2) [expr $v1(2)*cos($angle) - $v1(0)*sin($angle)]
      }

      default {
         set v(0) [expr $v1(0)*cos($angle) - $v1(1)*sin($angle)]
         set v(1) [expr $v1(1)*cos($angle) + $v1(0)*sin($angle)]
         set v(2) $v1(2)
      }
   }
}


#=============================================================
proc ROTSET { angle prev_angle dir kin_leader sys_leader min max {tol_flag 0} } {
#=============================================================
#  This command will take an input angle and format for a specific machine.
#  It will also validate that the angle is within the specified limits of
#  machine.
#
#  angle        angle to be output.
#  prev_angle   previous angle output.  It should be mom_out_angle_pos
#  dir          can be either MAGNITUDE_DETERMINES_DIRECTION or
#               SIGN_DETERMINES_DIRECTION
#  kin_leader   leader (usually A, B or C) defined by Post Builder
#  sys_leader   leader that is created by ROTSET.  It could be "C-".
#  min          minimum degrees of travel for current axis
#  max          maximum degrees of travel for current axis
#
#  tol_flag     performance comparison with tolerance
#                 0 : No (default)
#                 1 : Yes
#
#
# - This command is called by the following functions:
#   RETRACT_ROTARY_AXIS, LOCK_AXIS_MOTION, LINEARIZE_LOCK_OUTPUT,
#   MOM_rotate, LINEARIZE_OUTPUT and MILL_TURN.
#
#=============================================================
# Revisions
# 02-25-09 mzg - Added optional argument tol_flag to allow
#                performing comparisions with tolerance
# 03-13-12 gsl - (pb850) LIMIT_ANGLE should be called by using its return value
#              - Allow comparing max/min with tolerance
#=============================================================

   upvar $sys_leader lead

  #
  #  Make sure angle is 0~360 to start with.
  #
   set angle [LIMIT_ANGLE $angle]
   set check_solution 0

   if { ![string compare "MAGNITUDE_DETERMINES_DIRECTION" $dir] } {

   #
   #  If magnitude determines direction and total travel is less than or equal
   #  to 360, we can assume there is at most one valid solution.  Find it and
   #  leave.  Check for the total travel being less than 360 and give a warning
   #  if a valid position cannot be found.
   #
      set travel [expr abs($max - $min)]

      if { $travel <= 360.0 } {

         set check_solution 1

      } else {

         if { $tol_flag == 0 } { ;# Exact comparison
            while { [expr abs([expr $angle - $prev_angle])] > 180.0 } {
               if { [expr $angle - $prev_angle] < -180.0 } {
                  set angle [expr $angle + 360.0]
               } elseif { [expr $angle - $prev_angle] > 180.0 } {
                  set angle [expr $angle - 360.0]
               }
            }
         } else { ;# Tolerant comparison
            while { [EQ_is_gt [expr abs([expr $angle - $prev_angle])] 180.0] } {
               if { [EQ_is_lt [expr $angle - $prev_angle] -180.0] } {
                  set angle [expr $angle + 360.0]
               } elseif { [EQ_is_gt [expr $angle - $prev_angle] 180.0] } {
                  set angle [expr $angle - 360.0]
               }
            }
         }
      }

      #<03-13-12 gsl> Fit angle within limits
      if { $tol_flag == 1 } { ;# Tolerant comparison
         while { [EQ_is_lt $angle $min] } { set angle [expr $angle + 360.0] }
         while { [EQ_is_gt $angle $max] } { set angle [expr $angle - 360.0] }
      } else { ;# Legacy direct comparison
         while { $angle < $min } { set angle [expr $angle + 360.0] }
         while { $angle > $max } { set angle [expr $angle - 360.0] }
      }

   } elseif { ![string compare "SIGN_DETERMINES_DIRECTION" $dir] } {

   #
   #  Sign determines direction.  Determine whether the shortest distance is
   #  clockwise or counterclockwise.  If counterclockwise append a "-" sign
   #  to the address leader.
   #
      set check_solution 1

      #<09-15-09 wbh> If angle is negative, we add 360 to it instead of getting the absolute value of it.
      if { $angle < 0 } {
         set angle [expr $angle + 360]
      }

      set minus_flag 0
     # set angle [expr abs($angle)]  ;# This line was not in ROTSET of xzc post.

      set del [expr $angle - $prev_angle]
      if { $tol_flag == 0 } { ;# Exact comparison
         if { ($del < 0.0 && $del > -180.0) || $del > 180.0 } {
           # set lead "$kin_leader-"
            set minus_flag 1
         } else {
            set lead $kin_leader
         }
      } else { ;# Tolerant comparison
         if { ([EQ_is_lt $del 0.0] && [EQ_is_gt $del -180.0]) || [EQ_is_gt $del 180.0] } {
           # set lead "$kin_leader-"
            set minus_flag 1
         } else {
            set lead $kin_leader
         }
      }

      #<04-27-11 wbh> 1819104 Check the rotary axis is 4th axis or 5th axis
      global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
      global mom_rotary_direction_4th mom_rotary_direction_5th
      global mom_prev_rotary_dir_4th mom_prev_rotary_dir_5th

      set is_4th 1
      if { [info exists mom_kin_5th_axis_leader] && [string match "$mom_kin_5th_axis_leader" "$kin_leader"] } {
         set is_4th 0
      }

      #<09-15-09 wbh>
      if { $minus_flag && [EQ_is_gt $angle 0.0] } {
         set lead "$kin_leader-"

         #<04-27-11 wbh> Since the leader should add a minus, the rotary direction need be reset
         if { $is_4th } {
            set mom_rotary_direction_4th -1
         } else {
            set mom_rotary_direction_5th -1
         }
      }

      #<04-27-11 wbh> If the delta angle is 0 or 180, there has no need to change the rotary direction,
      #               we should reset the current direction with the previous direction
      if { [EQ_is_zero $del] || [EQ_is_equal $del 180.0] || [EQ_is_equal $del -180.0] } {
         if { $is_4th } {
            if { [info exists mom_prev_rotary_dir_4th] } {
               set mom_rotary_direction_4th $mom_prev_rotary_dir_4th
            }
         } else {
            if { [info exists mom_prev_rotary_dir_5th] } {
               set mom_rotary_direction_5th $mom_prev_rotary_dir_5th
            }
         }
      } else {
         # Set the previous direction
         if { $is_4th } {
            set mom_prev_rotary_dir_4th $mom_rotary_direction_4th
         } else {
            set mom_prev_rotary_dir_5th $mom_rotary_direction_5th
         }
      }
   }

   #<03-13-12 gsl> Check solution
   #
   #  There are no alternate solutions.
   #  If the position is out of limits, give a warning and leave.
   #
   if { $check_solution } {
      if { $tol_flag == 1 } {
         if { [EQ_is_gt $angle $max] || [EQ_is_lt $angle $min] } {
            CATCH_WARNING "$kin_leader-axis is under minimum or over maximum. Assumed default."
         }
      } else {
         if { ($angle > $max) || ($angle < $min) } {
            CATCH_WARNING "$kin_leader-axis is under minimum or over maximum. Assumed default."
         }
      }
   }

return $angle
}


#=============================================================
proc SET_FEEDRATE_NUMBER { dist feed } {
#=============================================================
# called by ROTARY_AXIS_RETRACT

#<03-13-08 gsl> FRN factor should not be used here! Leave it to PB_CMD_FEEDRATE_NUMBER
# global mom_sys_frn_factor

  global mom_kin_max_frn

  if { [EQ_is_zero $dist] } {
return $mom_kin_max_frn
  } else {
    set f [expr $feed / $dist ]
    if { [EQ_is_lt $f $mom_kin_max_frn] } {
return $f
    } else {
return $mom_kin_max_frn
    }
  }
}


#=============================================================
proc SET_LOCK { axis plane value } {
#=============================================================
# called by MOM_lock_axis

  upvar $axis a ; upvar $plane p ; upvar $value v

  global mom_kin_machine_type mom_lock_axis mom_lock_axis_plane mom_lock_axis_value
  global mom_warning_info

   set machine_type [string tolower $mom_kin_machine_type]
   switch $machine_type {
      4_axis_head       -
      4_axis_table      -
      3_axis_mill_turn  -
      mill_turn         { set mtype 4 }
      5_axis_dual_table -
      5_axis_dual_head  -
      5_axis_head_table { set mtype 5 }
      default {
         set mom_warning_info "Set lock only vaild for 4 and 5 axis machines"
return "error"
      }
   }

   # Check the locked rotary axis.
   # If the rotary axis is the locked axis, this axis must be the 4th axis for 4-axis machine,
   # or the 5th axis for 5-axis machine.
  if { ![CHECK_LOCK_ROTARY_AXIS $mom_lock_axis $mtype] } {
     set mom_warning_info "Specified rotary axis is invalid as the lock axis"
     return "error"
  }

   set p -1

   switch $mom_lock_axis {
      OFF {
         global mom_sys_lock_arc_save
         global mom_kin_arc_output_mode
         if { [info exists mom_sys_lock_arc_save] } {
             set mom_kin_arc_output_mode $mom_sys_lock_arc_save
             unset mom_sys_lock_arc_save
             MOM_reload_kinematics
         }
         return "OFF"
      }
      XAXIS {
         set a 0
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            NONE {
               if { $mtype == 5 } {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      YAXIS {
         set a 1
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if { $mtype == 5 } {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      ZAXIS {
         set a 2
         switch $mom_lock_axis_plane {
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            XYPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if { $mtype == 5 } {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      FOURTH {
         set a 3
         set v [LOCK_AXIS_SUB $a]
      }
      FIFTH {
         set a 4
         set v [LOCK_AXIS_SUB $a]
      }
      AAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      BAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      CAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
   }


   global mom_sys_lock_arc_save
   global mom_kin_arc_output_mode

   if { ![info exists mom_sys_lock_arc_save] } {
      set mom_sys_lock_arc_save $mom_kin_arc_output_mode
   }
   set mom_kin_arc_output_mode "LINEAR"

   MOM_reload_kinematics

return "ON"
}


#=============================================================
proc SIM_FEED { pos } {
#=============================================================
  upvar $pos p

  global mom_pos mom_cycle_feed_rate mom_feed_rate feed

#  set mom_feed_rate $mom_cycle_feed_rate

#  FEEDRATE_SET
  set feed $mom_cycle_feed_rate

  VMOV 3 p mom_pos
  PB_CMD_linear_move
  MOM_reload_variable -a mom_pos
}


#=============================================================
proc SIM_RAPID { pos } {
#=============================================================
  upvar $pos p

  global mom_pos mom_kin_rapid_feed_rate feed

#  set mom_feed_rate $mom_kin_rapid_feed_rate

#  FEEDRATE_SET

  set feed $mom_kin_rapid_feed_rate

  VMOV 3 p mom_pos
  PB_CMD_linear_move
  MOM_reload_variable -a mom_pos
}


#=============================================================
proc SIM_RAPID_APPROACH { pos } {
#=============================================================
  upvar $pos p

  global mom_pos mom_sys_spindle_axis mom_prev_pos

  VEC3_sub p mom_prev_pos v1
  if {[VEC3_is_zero v1]} {return}
  set dist [VEC3_unitize v1 v2]
  set dot [VEC3_dot v2 mom_sys_spindle_axis]
  set dist [expr $dist*$dot]
  VEC3_scale dist mom_sys_spindle_axis sp_move
  VEC3_sub v1 sp_move trav_move

  if {$dist < 0.0} {
    if {![VEC3_is_zero trav_move]} {
      VEC3_add mom_prev_pos trav_move v1
      SIM_RAPID v1
    }
    if {![VEC3_is_zero sp_move]} {
      SIM_RAPID p
    }
  } else {
    if {![VEC3_is_zero sp_move]} {
      VEC3_add mom_prev_pos sp_move v1
      SIM_RAPID v1
    }
    if {![VEC3_is_zero trav_move]} {
      SIM_RAPID p
    }
  }
}


#=============================================================
proc SIM_RTRCTO {  } {
#=============================================================
  global mom_cycle_retract_to_pos mom_cycle_rapid_to_pos mom_sys_spindle_axis

  VEC3_sub mom_cycle_retract_to_pos mom_cycle_rapid_to_pos v1
  if {[EQ_is_gt [VEC3_dot v1 mom_sys_spindle_axis] 0.0]} {SIM_RAPID mom_cycle_retract_to_pos}
}


#=============================================================
proc SOLVE_QUADRATIC { coeff rcomp icomp status degree } {
#=============================================================
# called by CALC_SPHERICAL_RETRACT_POINT

   upvar $coeff c ; upvar $rcomp rc ; upvar $icomp ic
   upvar $status st ; upvar $degree deg

   set st 1
   set deg 0
   set rc(0) 0.0 ; set rc(1) 0.0
   set ic(0) 0.0 ; set ic(1) 0.0
   set mag [VEC3_mag c]
   if { [EQ_is_zero $mag] } { return 0 }
   set acoeff [expr $c(2)/$mag]
   set bcoeff [expr $c(1)/$mag]
   set ccoeff [expr $c(0)/$mag]
   if { ![EQ_is_zero $acoeff] } {
      set deg 2
      set denom [expr $acoeff*2.]
      set dscrm [expr $bcoeff*$bcoeff - $acoeff*$ccoeff*4.0]
      if { [EQ_is_zero $dscrm] } {
         set dsqrt1 0.0
      } else {
         set dsqrt1 [expr sqrt(abs($dscrm))]
      }
      if { [EQ_is_ge $dscrm 0.0] } {
         set rc(0) [expr (-$bcoeff + $dsqrt1)/$denom]
         set rc(1) [expr (-$bcoeff - $dsqrt1)/$denom]
         set st 3
         return 2
      } else {
         set rc(0) [expr -$bcoeff/$denom]
         set rc(1) $rc(0)
         set ic(0) [expr $dsqrt1/$denom]
         set ic(1) $ic(0)
         set st 2
         return 0
      }
   } elseif { ![EQ_is_zero $bcoeff] } {
      set st 3
      set deg 1
      set rc(0) [expr -$ccoeff/$bcoeff]
      return 1
   } elseif { [EQ_is_zero $ccoeff] } {
      return 0
   } else {
      return 0
   }
}


#=============================================================
proc STR_MATCH { VAR str {out_warn 0} } {
#=============================================================
# This command will match a variable with a given string.
#
# - Users can set the optional flag "out_warn" to "1" to produce
#   warning message when the variable is not defined in the scope
#   of the caller of this function.
#
   upvar $VAR var

   if { [info exists var] && [string match "$var" "$str"] } {
return 1
   } else {
      if { $out_warn } {
         CATCH_WARNING "Variable $VAR is not defined in \"[info level -1]\"!"
      }
return 0
   }
}


#=============================================================
proc TRACE {  } {
#=============================================================
   set start_idx 1

   set str ""
   set level [info level]
   for { set i $start_idx } { $i < $level } { incr i } {
      set str "${str}[lindex [info level $i] 0]\n"
   }

return $str
}


#=============================================================
proc UNLOCK_AXIS { locked_point unlocked_point } {
#=============================================================
# called by LINEARIZE_LOCK_MOTION

   upvar $locked_point ip ; upvar $unlocked_point op

   global mom_sys_lock_plane
   global mom_sys_linear_axis_index_1
   global mom_sys_linear_axis_index_2
   global mom_sys_rotary_axis_index
   global mom_kin_4th_axis_center_offset
   global mom_kin_5th_axis_center_offset
   global DEG2RAD


   if { [info exists mom_kin_4th_axis_center] } {
       VEC3_add ip mom_kin_4th_axis_center_offset temp
   } else {
       set temp(0) $ip(0)
       set temp(1) $ip(1)
       set temp(2) $ip(2)
   }
   if { [info exists mom_kin_5th_axis_center_offset] } {
      VEC3_add temp mom_kin_5th_axis_center_offset temp
   }

   set op(3) $ip(3)
   set op(4) $ip(4)

   set ang [expr $op($mom_sys_rotary_axis_index)*$DEG2RAD]
   ROTATE_VECTOR $mom_sys_lock_plane $ang temp op

   set op($mom_sys_rotary_axis_index) 0.0

   if { [info exists mom_kin_4th_axis_center_offset] } {
      VEC3_sub op mom_kin_4th_axis_center_offset op
   }
   if { [info exists mom_kin_5th_axis_center_offset] } {
      VEC3_sub op mom_kin_5th_axis_center_offset op
   }
}


#=============================================================
proc UNSET_VARS { args } {
#=============================================================
# Inputs: List of variable names
#

   if { [llength $args] == 0 } {
return
   }

   foreach VAR $args {
      upvar $VAR var

      global tcl_version

      if { [array exists var] } {
         if { [expr $tcl_version < 8.4] } {
            foreach a [array names var] {
               if { [info exists var($a)] } {
                  unset var($a)
               }
            }
            unset var
         } else {
            array unset var
         }
      }

      if { [info exists var] } {
         unset var
      }
   }
}


#=============================================================
proc VMOV { n p1 p2 } {
#=============================================================
  upvar $p1 v1 ; upvar $p2 v2

   for { set i 0 } { $i < $n } { incr i } {
      set v2($i) $v1($i)
   }
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}


#=============================================================
proc PB_load_alternate_unit_settings { } {
#=============================================================
   global mom_output_unit mom_kin_output_unit

  # Skip this function when output unit agrees with post unit.
   if { ![info exists mom_output_unit] } {
      set mom_output_unit $mom_kin_output_unit
return
   } elseif { ![string compare $mom_output_unit $mom_kin_output_unit] } {
return
   }


   global mom_event_handler_file_name

  # Set unit conversion factor
   if { ![string compare $mom_output_unit "MM"] } {
      set factor 25.4
   } else {
      set factor [expr 1/25.4]
   }

  # Define unit dependent variables list
   set unit_depen_var_list [list mom_kin_x_axis_limit mom_kin_y_axis_limit mom_kin_z_axis_limit \
                                 mom_kin_pivot_gauge_offset mom_kin_ind_to_dependent_head_x \
                                 mom_kin_ind_to_dependent_head_z]

   set unit_depen_arr_list [list mom_kin_4th_axis_center_offset \
                                 mom_kin_5th_axis_center_offset \
                                 mom_kin_machine_zero_offset \
                                 mom_kin_4th_axis_point \
                                 mom_kin_5th_axis_point \
                                 mom_sys_home_pos]

  # Load unit dependent variables
   foreach var $unit_depen_var_list {
      if { ![info exists $var] } {
         global $var
      }
      if { [info exists $var] } {
         set $var [expr [set $var] * $factor]
         MOM_reload_variable $var
      }
   }

   foreach var $unit_depen_arr_list {
      if { ![info exists $var] } {
         global $var
      }
      foreach item [array names $var] {
         if { [info exists ${var}($item)] } {
            set ${var}($item) [expr [set ${var}($item)] * $factor]
         }
      }

      MOM_reload_variable -a $var
   }


  # Source alternate unit post fragment
   uplevel #0 {
      global mom_sys_alt_unit_post_name
      set alter_unit_post_name \
          "[file join [file dirname $mom_event_handler_file_name] [file rootname $mom_sys_alt_unit_post_name]].tcl"

      if { [file exists $alter_unit_post_name] } {
         source "$alter_unit_post_name"
      }
      unset alter_unit_post_name
   }

   if { [llength [info commands PB_load_address_redefinition]] > 0 } {
      PB_load_address_redefinition
   }

   MOM_reload_kinematics
}


if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}


